/**
 * Institute for Genome Science & Policy
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2009 by the
 * Institute for Genome Science & Policy/Duke University.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Institute for Genome Science & Policy nor Duke University can be responsible for
 * its use, misuse, or functionality.
 */

package edu.duke.igsp.app.objects;

import java.io.Serializable;

/**
 * @author Qing Xiong < qing.xiong@duke.edu >
 * Date: April, 2009
 *
 */
public class GeneBean implements Serializable{
    private String accessionID;
    private String symbol;
    private int chromosome;
    private String status;
    private String strand;
    private int start;
    private int end;
    private String description;
    private String sequence;

    public GeneBean() {
    }

    public String getAccessionID() {
        return accessionID;
    }

    public String getSymbol() {
        return symbol;
    }

    public int getChromosome() {
        return chromosome;
    }

    public String getStatus() {
        return status;
    }

    public int getStart(){
        return start;
    }

    public int getEnd(){
        return end;
    }

    public String getStrand(){
        return strand;
    }

    public String getDescription() {
        return description;
    }

    public String getSequence() {
        return sequence;
    }

    public void setAccessionID(String accessionID) {
        this.accessionID = accessionID;
    }

    public void setSymbol(String symbol) {
        this.symbol = symbol;
    }

    public void setChromosome(int chromosome) {
        this.chromosome = chromosome;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public void setStart(int start){
        this.start=start;
    }

    public void setEnd(int end){
        this.end=end;
    }

    public void setStrand(String strand){
        this.strand = strand;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public void setSequence(String sequence) {
        this.sequence = sequence;
    }

    public String toString() {
        /*return "Accession ID: " + accessionID + "\tOfficial Symbol: " + symbol +
                "\tStatus: " + status + "\tDescription: " + description;*/
         return "Official Symbol: " + symbol +"\tChromosome: " + chromosome +
                "\tStart: " + start + "\tEnd: " + end+ "\tStrand: " + strand;
    }

    public void reset(){
        this.accessionID="";
        this.symbol="";
        this.chromosome=0;
        this.start=0;
        this.end=0;
        this.strand="";
        this.status="";
        this.description="";
        this.sequence="";
    }
}
