/**
 * Institute for Genome Science & Policy
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2009 by the
 * Institute for Genome Science & Policy/Duke University.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Institute for Genome Science & Policy nor Duke University can be responsible for
 * its use, misuse, or functionality.
 */

package edu.duke.igsp.app.objects;

import java.util.Vector;

/**
 * @author Qing Xiong < qing.xiong@duke.edu >
 * Date: April, 2009
 *
 */
public class GeneSnps {

    private Vector geneBeans = new Vector();
    private String[][] orig_snps;
    private Vector snps = new Vector();
    private Vector map = new Vector();

    public GeneSnps() {
    }

    public GeneSnps(Vector geneBeans) {
        this.geneBeans = geneBeans;
    }

    public GeneSnps(Vector geneBeans, String[][] orig_snps) {
        this.geneBeans = geneBeans;
        this.orig_snps = orig_snps;
    }

    public void Vsnp2Gene() {
        int marker = 0;
        int counter = 0;
        for (int i = 0; i < geneBeans.size(); i++) {
            int start = ((GeneBean) geneBeans.get(i)).getStart() - 500;
            int end = ((GeneBean) geneBeans.get(i)).getEnd() + 500;
            int start_next = ((GeneBean) geneBeans.get(i + 1)).getStart() - 500;
            Vector cluster = new Vector();
            for (int j = marker; j < orig_snps.length; j++) {
                int pos = Integer.parseInt(orig_snps[j][2]);
                if (start <= pos && pos <= end) {
                    for (int k = 0; k < orig_snps[j].length; k++) {
                        cluster.add(orig_snps[j][k]);
                    }
                    snps.add(cluster);
                    counter++;
                }
                if (start_next < pos) {
                    marker = j - 1;
                }
                if (pos > end) {
                    map.add(new Integer(counter));
                    counter = 0;
                    break;
                }
            }
        }

    }

    public Vector getSnps() {
        Vector geneSnps = new Vector();
        for (int i = 0; i < snps.size(); i++) {
            Vector row = new Vector();
            for (int j = 0; j < ((Vector) snps.get(i)).size(); j++) {
                String value = (String) ((Vector) snps.get(i)).get(j);
                row.add(value);
            }
            geneSnps.add(row);
        }
        return geneSnps;
    }

    public Vector getMap() {
        Vector map = new Vector();
        for (int i = 0; i < this.map.size(); i++) {
            map.add(this.map.get(i));
        }
        return map;
    }

}

