/**
 * Institute for Genome Science & Policy
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2009 by the
 * Institute for Genome Science & Policy/Duke University.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Institute for Genome Science & Policy nor Duke University can be responsible for
 * its use, misuse, or functionality.
 */

package edu.duke.igsp.app.struts;

import edu.mit.broad.genome.objects.GeneSet;
import java.util.List;
import java.util.HashMap;

/**
 * @author Qing Xiong < qing.xiong@duke.edu >
 * Date: August, 2009
 *
 */
public class SnpStruc{

    private List fScoredDataset;
    private GeneSet[] fSnpSet;
    private HashMap fCor;

    /**
     * Class constructor
     *
     * @param rankedList
     * @param snpSet
     */
    public SnpStruc(final List scoredDataset, final GeneSet[] snpSet) {

        if (scoredDataset == null) {
            throw new IllegalArgumentException("Param rankedList cannot be null");
        }

        if (snpSet == null) {
            throw new IllegalArgumentException("Param snpSet cannot be null");
        }

        this.fScoredDataset = scoredDataset;
        this.fSnpSet = snpSet;
    }

    public SnpStruc(final List scoredDataset, final GeneSet[] snpSet, final HashMap cor) {

        if (scoredDataset == null) {
            throw new IllegalArgumentException("Param rankedList cannot be null");
        }

        if (snpSet == null) {
            throw new IllegalArgumentException("Param snpSet cannot be null");
        }

        if (cor == null) {
            throw new IllegalArgumentException("Param cor cannot be null");
        }

        this.fScoredDataset = scoredDataset;
        this.fSnpSet = snpSet;
        this.fCor = cor;

    }

    public List getScoredDataset(){
        return fScoredDataset;
    }

    public GeneSet[] getSnpSet(){
        return fSnpSet;
    }

    public HashMap getCor(){
        return fCor;
    }

} 


