/**
 * Institute for Genome Science & Policy
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2009 by the
 * Institute for Genome Science & Policy/Duke University.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Institute for Genome Science & Policy nor Duke University can be responsible for
 * its use, misuse, or functionality.
 */
package edu.duke.igsp.app.tools;

import java.util.ArrayList;
import java.util.List;
import java.io.*;

/**
 * @author Qing Xiong < qing.xiong@duke.edu >
 * Date: April, 2009
 *
 */
public class ArrayListTool {

    public ArrayListTool() {
    }

    public static void saveArrayListS(ArrayList array, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < array.size(); i++) {
                String s = (String) array.get(i);
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListI(ArrayList array, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < array.size(); i++) {
                String s = ((Integer) array.get(i)).toString();
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListD(ArrayList array, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < array.size(); i++) {
                String s = ((Double) array.get(i)).toString();
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListS(String[] array, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < array.length; i++) {
                String s = array[i];
                bw.write(s + "\t");
                bw.newLine();
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListI(int[] array, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < array.length; i++) {
                String s = ((Integer) array[i]).toString();
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListD(double[] array, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < array.length; i++) {
                String s = ((Double) array[i]).toString();
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListSA(ArrayList array, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < array.size(); i++) {
                String s = (String) array.get(i);
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListIA(ArrayList array, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < array.size(); i++) {
                String s = ((Integer) array.get(i)).toString();
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListDA(ArrayList array, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < array.size(); i++) {
                String s = ((Double) array.get(i)).toString();
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListSA(String[] array, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < array.length; i++) {
                String s = array[i];
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListIA(int[] array, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < array.length; i++) {
                String s = ((Integer) array[i]).toString();
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListFA(float[] array, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < array.length; i++) {
                String s = ((Float) array[i]).toString();
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveArrayListDA(double[] array, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < array.length; i++) {
                String s = ((Double) array[i]).toString();
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void printArrayListS(ArrayList array) {
        for (int i = 0; i < array.size(); i++) {
            String s = (String) array.get(i);
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void printArrayListI(ArrayList array) {
        for (int i = 0; i < array.size(); i++) {
            String s = ((Integer) array.get(i)).toString();
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void printArrayListD(ArrayList array) {
        for (int i = 0; i < array.size(); i++) {
            String s = ((Double) array.get(i)).toString();
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void printArrayListS(String[] array) {
        for (int i = 0; i < array.length; i++) {
            String s = array[i];
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void printArrayListI(int[] array) {
        for (int i = 0; i < array.length; i++) {
            String s = ((Integer) array[i]).toString();
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void printArrayListD(double[] array) {
        for (int i = 0; i < array.length; i++) {
            String s = ((Double) array[i]).toString();
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void saveMatrixS(ArrayList matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                        j++) {
                    String s = (String) ((ArrayList) matrix.get(i)).get(
                            j);
                    bw.write(s + "\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixI(ArrayList matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                        j++) {
                    String s = ((Integer) ((ArrayList) matrix.get(i)).get(
                            j)).toString();
                    bw.write(s + "\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixD(ArrayList matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                        j++) {
                    String s = ((Double) ((ArrayList) matrix.get(i)).get(
                            j)).toString();
                    bw.write(s + "\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixS(String[][] matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.length; i++) {
                for (int j = 0; j < matrix[i].length; j++) {
                    String s = matrix[i][j];
                    bw.write(s + "\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixI(int[][] matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.length; i++) {
                for (int j = 0; j < matrix[i].length; j++) {
                    String s = ((Integer) matrix[i][j]).toString();
                    bw.write(s + "\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixD(double[][] matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.length; i++) {
                for (int j = 0; j < matrix[i].length; j++) {
                    String s = ((Double) matrix[i][j]).toString();
                    bw.write(s + "\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixSA(ArrayList matrix, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                        j++) {
                    String s = (String) ((ArrayList) matrix.get(i)).get(
                            j);
                    pw.print(s + "\t");
                }
                pw.println();
            }
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixIA(ArrayList matrix, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                        j++) {
                    String s = ((Integer) ((ArrayList) matrix.get(i)).get(
                            j)).toString();
                    pw.print(s + "\t");
                }
                pw.println();
            }
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixDA(ArrayList matrix, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                        j++) {
                    String s = ((Double) ((ArrayList) matrix.get(i)).get(
                            j)).toString();
                    pw.print(s + "\t");
                }
                pw.println();
            }
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixSA(String[][] matrix, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < matrix.length; i++) {
                for (int j = 0; j < matrix[i].length; j++) {
                    String s = matrix[i][j];
                    pw.print(s + "\t");
                }
                pw.println();
            }
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixIA(int[][] matrix, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < matrix.length; i++) {
                for (int j = 0; j < matrix[i].length; j++) {
                    String s = ((Integer) matrix[i][j]).toString();
                    pw.print(s + "\t");
                }
                pw.println();
            }
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixDA(double[][] matrix, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < matrix.length; i++) {
                for (int j = 0; j < matrix[i].length; j++) {
                    String s = ((Double) matrix[i][j]).toString();
                    pw.print(s + "\t");
                }
                pw.println();
            }
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void printMatrixS(ArrayList matrix) {
        for (int i = 0; i < matrix.size(); i++) {
            for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                    j++) {
                String s = (String) ((ArrayList) matrix.get(i)).get(
                        j);
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static void printMatrixI(ArrayList matrix) {
        for (int i = 0; i < matrix.size(); i++) {
            for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                    j++) {
                String s = ((Integer) ((ArrayList) matrix.get(i)).get(
                        j)).toString();
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static void printMatrixD(ArrayList matrix) {
        for (int i = 0; i < matrix.size(); i++) {
            for (int j = 0; j < ((ArrayList) matrix.get(i)).size();
                    j++) {
                String s = ((Double) ((ArrayList) matrix.get(i)).get(
                        j)).toString();
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static void printMatrixS(String[][] matrix) {
        for (int i = 0; i < matrix.length; i++) {
            for (int j = 0; j < matrix[i].length; j++) {
                String s = matrix[i][j];
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static void printMatrixI(int[][] matrix) {
        for (int i = 0; i < matrix.length; i++) {
            for (int j = 0; j < matrix[i].length; j++) {
                String s = ((Integer) matrix[i][j]).toString();
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static void printMatrixD(double[][] matrix) {
        for (int i = 0; i < matrix.length; i++) {
            for (int j = 0; j < matrix[i].length; j++) {
                String s = ((Double) matrix[i][j]).toString();
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static String[] toStringArray(ArrayList al) {
        String[] dist = new String[al.size()];
        for (int i = 0; i < dist.length; i++) {
            dist[i] = (String) al.get(i);
        }
        return dist;
    }

    public static void saveStringA(String s, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            pw.print(s);
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static String[] int2string(int[] data){
        String[] ss = new String[data.length];
        for(int i=0; i<ss.length; i++){
            ss[i] = (new Integer(data[i])).toString();
        }
        return ss;
    }

    public static int[] string2int(String[] data){
        int[] is = new int[data.length];
        for(int i=0; i<is.length; i++){
            is[i] = Integer.parseInt(data[i]);
        }
        return is;
    }

    public static String[] list2string(List data){
        String[] ss = new String[data.size()];
        for(int i=0; i<ss.length; i++){
            ss[i] = (String)data.get(i);
        }
        return ss;
    }

    public static int[] list2int(List data){
        int[] is = new int[data.size()];
        for(int i=0; i<is.length; i++){
            is[i] = Integer.parseInt((String)data.get(i));
        }
        return is;
    }

    public static List string2list(String[] data){
        List l = new ArrayList();
        for(int i=0; i<l.size(); i++){
            l.add(data[i]);
        }
        return l;
    }

    public static List int2list(int[] data){
        List l = new ArrayList();
        for(int i=0; i<l.size(); i++){
            l.add(new Integer(data[i]));
        }
        return l;
    }
}

