/**
 * Institute for Genome Science & Policy
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2009 by the
 * Institute for Genome Science & Policy/Duke University.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Institute for Genome Science & Policy nor Duke University can be responsible for
 * its use, misuse, or functionality.
 */

package edu.duke.igsp.app.tools;

import java.util.Vector;
import java.io.*;

/**
 * @author Qing Xiong < qing.xiong@duke.edu >
 * Date: April, 2009
 *
 */
public class VectorTool {

    public static void saveVectorS(Vector vector, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < vector.size(); i++) {
                String s = (String) vector.get(i);
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveVectorI(Vector vector, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < vector.size(); i++) {
                String s = ((Integer) vector.get(i)).toString();
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveVectorD(Vector vector, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < vector.size(); i++) {
                String s = ((Double) vector.get(i)).toString();
                bw.write(s + "\t");
            }
            bw.newLine();
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveVectorSA(Vector vector, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < vector.size(); i++) {
                String s = (String) vector.get(i);
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveVectorIA(Vector vector, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < vector.size(); i++) {
                String s = ((Integer) vector.get(i)).toString();
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveVectorDA(Vector vector, String filename) {
        try {
            File file = new File(filename);
            FileOutputStream fos = new FileOutputStream(file, true);
            PrintWriter pw = new PrintWriter(fos);
            for (int i = 0; i < vector.size(); i++) {
                String s = ((Double) vector.get(i)).toString();
                pw.print(s + "\t");
            }
            pw.println();
            pw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void printVectorS(Vector vector) {
        for (int i = 0; i < vector.size(); i++) {
            String s = (String) vector.get(i);
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void printVectorI(Vector vector) {
        for (int i = 0; i < vector.size(); i++) {
            String s = ((Integer) vector.get(i)).toString();
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void printVectorD(Vector vector) {
        for (int i = 0; i < vector.size(); i++) {
            String s = ((Double) vector.get(i)).toString();
            System.out.print(s + "\t");
        }
        System.out.println();
    }

    public static void saveMatrixS(Vector matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((Vector) matrix.get(i)).size();
                        j++) {
                    String s = (String) ((Vector) matrix.get(i)).get(
                            j);
                    bw.write(s+"\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixI(Vector matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((Vector) matrix.get(i)).size();
                        j++) {
                    String s = ((Integer) ((Vector) matrix.get(i)).get(
                            j)).toString();
                    bw.write(s+"\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void saveMatrixD(Vector matrix, String filename) {
        try {
            FileWriter output = new FileWriter(filename);
            BufferedWriter bw = new BufferedWriter(output);
            for (int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < ((Vector) matrix.get(i)).size();
                        j++) {
                    String s = ((Double) ((Vector) matrix.get(i)).get(
                            j)).toString();
                    bw.write(s+"\t");
                }
                bw.newLine();
            }
            bw.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void printMatrixS(Vector matrix) {
        for (int i = 0; i < matrix.size(); i++) {
            for (int j = 0; j < ((Vector) matrix.get(i)).size();
                    j++) {
                String s = (String) ((Vector) matrix.get(i)).get(
                        j);
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static void printMatrixI(Vector matrix) {
        for (int i = 0; i < matrix.size(); i++) {
            for (int j = 0; j < ((Vector) matrix.get(i)).size();
                    j++) {
                String s = ((Integer) ((Vector) matrix.get(i)).get(
                        j)).toString();
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

    public static void printMatrixD(Vector matrix) {
        for (int i = 0; i < matrix.size(); i++) {
            for (int j = 0; j < ((Vector) matrix.get(i)).size();
                    j++) {
                String s = ((Double) ((Vector) matrix.get(i)).get(
                        j)).toString();
                System.out.print(s + "\t");
            }
            System.out.println();
        }
    }

}
