/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.vdb.chip;

import edu.mit.broad.vdb.meg.Gene;

import java.util.List;
import java.util.Set;

/**
 * @author Aravind Subramanian
 *         Date: Jan 22, 2005
 *         Time: 8:16:55 PM
 */
public interface NullSymbolMode {

    public String getSymbol(String probeId, Gene gene);

    public String getTitle(String probeId, Gene gene);

    public void processSymbol(String probeId, Gene gene, Set set);

    public void processSymbol(String probeId, Gene gene, List list);

    public void processHugo(String probeId, Gene gene, Set set);

    public void processHugo(String probeId, Gene gene, List set);

}
