/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.vdb.map;

import edu.mit.broad.genome.objects.PersistentObject;
import edu.mit.broad.vdb.chip.Chip;

/**
 * @author Aravind Subramanian
 *         Date: Feb 16, 2005
 *         Time: 1:04:17 PM
 */
public interface Chip2ChipMapper extends PersistentObject, Mapper {

    public String getChipsId();

    public int getNumSourceProbes();

    public MappingDbType getMappingDbType();

    public Chip getSourceChip();

    public Chip getTargetChip();

    public boolean equals(final Chip sourceChip, final Chip targetChip, final MappingDbType db);

    public boolean equals(final Chip sourceChip, final Chip targetChip);

    public String[] getSourceProbes();

} // End interface Chip2ChipMapper
