/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.vdb.map;

import gnu.trove.THashMap;

/**
 * Keep slim and not many refs as this object is serialized
 */
// dont extend abstract object as want to keep this self contained
public class Chip2ChipMapperSlim extends Chip2ChipMapperAbstract {

    private static final long serialVersionUID = 3328223111976142699L;

    /**
     * Class constructor
     *
     * @param mc
     */
    public Chip2ChipMapperSlim(final Chip2ChipMapper mc) throws Exception {

        THashMap map = new THashMap();
        String[] sourceProbes = mc.getSourceProbes();
        for (int i = 0; i < sourceProbes.length; i++) {
            java.util.Set maps = mc.map(sourceProbes[i]); // @todo
            map.put(sourceProbes[i], maps);
        }

        init(mc.getSourceChip().getName(), mc.getTargetChip().getName(), mc.getMappingDbType(), map);
    }

    protected void checkAndInit() {
        // nothing to do
    }


} // End class SlimMappedChip2

