/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.vdb.map;

import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.genome.objects.GeneSetMatrix;

import java.util.Set;

/**
 * @author Aravind Subramanian
 *         Date: Feb 19, 2005
 *         Time: 3:50:58 PM
 */
public interface Mapper {

    // MAPPING RELATED -----------------------
    public MGeneSet map(final GeneSet sourceGeneSet, final boolean maintainEtiology) throws Exception;

    public MGeneSetMatrix map(final GeneSetMatrix sourceGm, final boolean maintainEtiology) throws Exception;

    public Set map(final String sourceProbeName) throws Exception;

}
