package edu.mit.broad.vdb.msigdb;

import edu.mit.broad.genome.objects.AbstractObject;
import edu.mit.broad.genome.objects.ColorMap;
import edu.mit.broad.genome.objects.FeatureAnnot;
import edu.mit.broad.genome.objects.strucs.Linked;
import edu.mit.broad.genome.reports.web.LinkedFactory;
import edu.mit.broad.vdb.chip.Chip;

/**
 * @author Aravind Subramanian
 *         Date: Jan 21, 2006
 *         Time: 6:44:00 PM
 * @todo implement better with Msigdb
 */
public class FeatureAnnotMSigDbImpl extends AbstractObject implements FeatureAnnot {

    private MSigDB fMSigDB;

    /**
     * Class constructor
     *
     * @param name
     * @param msigdb
     */
    public FeatureAnnotMSigDbImpl(final MSigDB msigdb) {
        super(msigdb.getName());
        this.fMSigDB = msigdb;
    }

    public String getQuickInfo() {
        return null;
    }

    public String[] getNames() {
        return fMSigDB.getStandardNames();
    }

    public int getNumFeatures() {
        return fMSigDB.getNumGeneSets();
    }

    public String getNativeDesc(final String featureName) {
        return fMSigDB.getGeneSetAnnotation(featureName).getDescription().getBrief();
    }

    public boolean hasNativeDescriptions() {
        return true;
    }

    public String getGeneSymbol(final String featureName) {
        return null;
    }

    public String getGeneTitle(final String featureName) {
        return null;
    }

    public Chip getChip() {
        return null;
    }

    public void setChip(final Chip chip, final ColorMap.Rows cmr) {

        //throw new NotImplementedException();
    }

    public ColorMap.Rows getColorMap() {
        return null;
    }

    public Linked getLink(final String featureName) {
        return new LinkedFactory.LinkedGeneSet(featureName);
    }

} // End class FeatureAnnotMSigDbImpl
