package edu.mit.broad.vdb.msigdb;

import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.vdb.Organism;

import java.util.Set;

/**
 * @author Aravind Subramanian
 *         Date: Oct 22, 2005
 *         Time: 6:33:39 PM
 */
public interface GeneSetAnnotation {

    public GeneSet getGeneSet(final boolean origIds, final boolean lookupAccessionsOnlineIfNeeded);

    public GeneSet getGeneSet(final boolean origIds);

    public GeneSetContributor getContributor();

    public GeneSetExternalLinks getExternalLinks();

    public String getStandardName();

    public String getLSIDName();

    public String getChipOriginal_name();

    public Organism getOrganism();

    public GeneSetCategory getCategory();

    public GeneSetDescription getDescription();

    public Set getTags();

    public String[] getTagsArray();

} // End interface GeneSetAnnotation
