package edu.mit.broad.vdb.msigdb;

import xapps.gsea.GseaWebResources;

/**
 * @author Aravind Subramanian
 *         Date: Oct 22, 2005
 *         Time: 8:57:10 PM
 */
public class GeneSetContributorImpl implements GeneSetContributor {

    public static final GeneSetContributor BROAD = new GeneSetContributorImpl("Broad Institute", GseaWebResources.getGseaBaseURL(), "gsea@broadinstitute.org");
    public static final GeneSetContributor XHX = new GeneSetContributorImpl("Xiaohui Xie", GseaWebResources.getGseaBaseURL(), "gsea@broadinstitute.org");
    public static final GeneSetContributor BIOCARTA = new GeneSetContributorImpl("BioCarta", "http://www.biocarta.com", null);
    public static final GeneSetContributor SIGMA_ALDRICH = new GeneSetContributorImpl("SigmaAldrich", "http://www.sigmaaldrich.com/Area_of_Interest/Biochemicals/Enzyme_Explorer/Key_Resources.html", null);
    public static final GeneSetContributor GEARRAY = new GeneSetContributorImpl("GEArray", "http://www.superarray.com/home.php", null);
    public static final GeneSetContributor GENMAPP = new GeneSetContributorImpl("GenMAPP", "http://www.genmapp.org/", null);
    public static final GeneSetContributor GO = new GeneSetContributorImpl("GO", "http://www.geneontology.org/", null);
    public static final GeneSetContributor STKE = new GeneSetContributorImpl("Signalling Transduction KE", "http://stke.sciencemag.org/", null);
    public static final GeneSetContributor SIGNALLING_ALLIANCE = new GeneSetContributorImpl("Signalling Alliance", "http://www.signaling-gateway.org/", null);
    public static final GeneSetContributor KEVIN_VOGELSANG = new GeneSetContributorImpl("Kevin Vogelsang", GseaWebResources.getGseaBaseURL(), "gsea@broadinstitute.org");

    static GeneSetContributor[] ALL = new GeneSetContributor[]{
            BROAD, BIOCARTA,
            SIGMA_ALDRICH,
            GEARRAY, GENMAPP, GO,
            STKE, SIGNALLING_ALLIANCE
    };

    // -------------------------------------------------------------------------------------------- //
    // -------------------------------------------------------------------------------------------- //
    // -------------------------------------------------------------------------------------------- //

    private String fName;
    private String fUrl;
    private String fEmail;

    public static GeneSetContributor create(String name) {
        for (int i = 0; i < ALL.length; i++) {
            if (ALL[i].getName().equalsIgnoreCase(name)) {
                return ALL[i];
            }
        }

        return new GeneSetContributorImpl(name, null, null);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param url
     * @param email
     */
    public GeneSetContributorImpl(String name, String url, String email) {
        this.fName = name;
        this.fUrl = url;
        this.fEmail = email;
    }

    public String getName() {
        return fName;
    }

    // can be null
    public String getURL() {
        return fUrl;
    }

    public String getEmail() {
        return fEmail;
    }


} // End class GeneSetSourceImpl
