/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.vdb.sampledb;

import edu.mit.broad.vdb.chip.Chip;

/**
 * Sample is a particular manifestation of a template on a dataset
 */

public interface Sample {

    public String getName();

    public String getCategoryValue(final String categoryName);

    public String getCelFileName();

    public Chip getChip();

    public String getChipName();

    public String getOrganism();

    public SampleDataSource getDataSource();

    public float getPCall();

    public String getPCall_str();

    public boolean getQuality();

    public String getComments();

} // End interface Sample
