package edu.mit.broad.vdb.sampledb;

/**
 * @author Aravind Subramanian
 *         Date: Jul 10, 2006
 *         Time: 10:26:09 PM
 */

public class SampleDataSource {

    private String fName;

    public static SampleDataSource BROAD = new SampleDataSource("BROAD");
    public static SampleDataSource NOVARTIS = new SampleDataSource("NOVARTIS");
    public static SampleDataSource GEO = new SampleDataSource("GEO");
    public static SampleDataSource ARRAY_EXPRESS = new SampleDataSource("ARRAY_EXPRESS");

    private SampleDataSource(final String name) {
        this.fName = name;
    }

    public boolean isBroad() {
        return fName.equalsIgnoreCase(BROAD.fName);
    }

    public boolean isGEO() {
        return fName.equalsIgnoreCase(GEO.fName);
    }

    public boolean isArrayExpress() {
        return fName.equalsIgnoreCase(ARRAY_EXPRESS.fName);
    }

    public String getName() {
        return fName;
    }

    public static SampleDataSource lookup(final String source) {
        if (source.equalsIgnoreCase(BROAD.fName)) {
            return BROAD;
        }
        if (source.equalsIgnoreCase(GEO.fName)) {
            return GEO;
        }
        if (source.equalsIgnoreCase(ARRAY_EXPRESS.fName)) {
            return ARRAY_EXPRESS;
        }

        if (source.equalsIgnoreCase(NOVARTIS.fName)) {
            return NOVARTIS;
        }

        return new SampleDataSource(source);
    }

} // End class SampleDataSource
