package edu.mit.broad.vdb.sampledb;

/**
 * @author Aravind Subramanian
 * Date: Jun 2, 2006
 * Time: 8:24:57 PM
 */

/**
 * Sample class capturing information about a single GCM sample
 */
public class SampleGcm extends AbstractSample {

    protected String fCelFileName_hu6000;

    protected String fCelFileName_hu35k;

    protected String fDiagnosis;

    protected String fLineage;

    /**
     * Class constructor
     *
     * @param celFileName_hu6000
     */
    public SampleGcm(final String celFileName_hu6000, final String celFileName_hu35k) {
        this.fCelFileName_hu6000 = celFileName_hu6000;
        this.fCelFileName_hu35k = celFileName_hu35k;
    }

    public String getCategoryValue(final String categoryName) {

        String val = super.getCategoryValue(categoryName);

        if (val == null) {
            throw new IllegalArgumentException("Unknown category name: >" + categoryName + "<");
        }

        return val;
    }

    public String getCelFileName() {
        return fCelFileName_hu6000;
    }

    // -------------------------------------------------------------------------------------------- //

    public String getLineage() {
        return fLineage;
    }

} // End class Sample
