package edu.mit.broad.vdb.sampledb;

/**
 * @author Aravind Subramanian
 * Date: Oct 14, 2006
 * Time: 4:10:39 PM
 */

/**
 * Sample class capturing information about a single sample
 */
public class SampleNCI60 extends AbstractSample {

    protected String fLineage;

    /**
     * Class constructor
     *
     * @param celFileName_hu6000
     */
    public SampleNCI60(final String celFileName) {
        this.fCelFileName = celFileName;
    }

    public String getCategoryValue(final String categoryName) {

        String val = super.getCategoryValue(categoryName);

        if (val == null && categoryName.equalsIgnoreCase(SampleAnnot.HEADER_LINEAGE)) {
            val = getLineage();
        }

        if (val == null) {
            throw new IllegalArgumentException("Unknown category name: >" + categoryName + "<");
        }

        return val;
    }

    public String getLineage() {
        return fLineage;
    }

} // End class Sample
