package edu.mit.broad.vdb.sampledb;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * An actual state (e.g erythroid ...)
 *
 * @author Aravind Subramanian
 *         Date: Sep 6, 2005
 *         Time: 4:47:15 PM
 */
public class State {

    private String fName;

    private Sample[] fSamples;

    /**
     * Class constructor
     *
     * @param stateName
     * @param samples
     */
    public State(final String stateName, final Sample[] samples) {

        if (stateName == null) {
            throw new IllegalArgumentException("Param stateName cannot be null");
        }

        if (samples == null) {
            throw new IllegalArgumentException("Param stateName cannot be null");
        }

        this.fName = stateName;
        this.fSamples = samples;
    }

    public String getName() {
        return fName;
    }

    public Sample getSample(final int s) {
        return fSamples[s];
    }

    public Sample[] getSamples() {
        List list = getSamples_list();
        return (Sample[]) list.toArray(new Sample[list.size()]); // @note safe copy
    }

    public String[] getSampleNames() {
        String[] names = new String[getNumSamples()];
        for (int i = 0; i < getNumSamples(); i++) {
            names[i] = getSample(i).getName();
        }

        return names;
    }

    public List getSampleNames_list() {
        return Arrays.asList(getSampleNames());
    }

    public List getSamples_list() {
        List list = new ArrayList();
        for (int i = 0; i < fSamples.length; i++) {
            list.add(fSamples[i]);
        }


        return list;
    }

    public int getNumSamples() {
        return fSamples.length;
    }

} // End class State
