/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.actions;

import edu.mit.broad.genome.viewers.ChipViewer;
import edu.mit.broad.vdb.chip.Chip;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class ChipViewerAction extends ObjectAction {

    private edu.mit.broad.vdb.chip.Chip fChip;

    /**
     * Class Constructor.
     */
    public ChipViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }

    /**
     * Class Constructor.
     *
     * @param ds
     */
    public ChipViewerAction(Chip chip) {
        super();

        this.fChip = chip;
    }

    public void setObject(Object chipann) {
        this.fChip = (Chip) chipann;
    }

    public Widget getWidget() {
        return new ChipViewer(fChip);
    }

    public String getId() {
        return "ChipViewerAction";
    }

    public String getName() {
        return "View Chip Annotation";
    }

    public String getDescription() {
        return "View Chip Annotation";
    }

    public Icon getIcon() {
        return ChipViewer.ICON;
    }
}    // End ChipViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
