/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.actions;


import edu.mit.broad.xbench.core.WindowComponent;
import edu.mit.broad.xbench.core.api.Application;


/**
 * Base action-pattern class for all xomics actions.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public abstract class XAction extends edu.mit.broad.xbench.actions.UIResAction {

    public XAction() {

        super();

        // dont -> class vars not inited yet
        // implementing classes need to do this after a call to super()
        //putValue(Action.NAME, getName());
        //putValue(Action.SMALL_ICON, getIcon());
    }

    /**
     * Open specified WindowComponent in the Application.
     * A call to this method will cause the application to initialize.
     *
     * @param comp
     */
    public void open(WindowComponent comp) {
        Application.getWindowManager().openWindow(comp);
    }
}    // End XAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
