/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.core;

import java.awt.*;

/**
 * @author Aravind Subramanian
 *         Date: Mar 28, 2003
 *         Time: 6:16:50 PM
 */
public interface Window {

    public Container getContentPane();

    public Dimension getSize();

    public Point getLocation();

    public String getTitle();

    public GraphicsConfiguration getGraphicsConfiguration();

    public void removeAll();

    public void hide();

    public void dispose();

    /**
     * Helper method to iconify the window.
     */
    public void minimize();

    /**
     * Helper method to maximize the window.
     */
    public void maximize();

    /**
     * Helper method to de-iconify the window.
     */
    public void restore();

    /**
     * Helper method to close the window and Document at once.
     */
    public void close();

    public boolean isClosed();

    /**
     * Checks to see if this Window's associated UI is ready to be closed.
     */
    public boolean allowClose();


    public void show();

} // End interface IWindow
