/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.core;


import edu.mit.broad.genome.JarResources;
import edu.mit.broad.genome.XLogger;
import org.apache.log4j.Logger;

import java.applet.Applet;
import java.applet.AudioClip;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;


/**
 * Really really overkill. But fun.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class XSounds {

    private static final Logger klog = XLogger.getLogger(XSounds.class);

    /**
     * key -> URL, valu e-> AudioClip, cached sounds to avoid repreated loading
     */
    private static final Map kUrlSoundMap = new HashMap();

    /**
     * Privatizec Class Constructor.
     */
    private XSounds() {
    }

    /**
     * sound when a jif is externalized
     */
    public static void playExternalize() {

        try {
            new SoundPlayer(JarResources.toURL("Externalize.wav"));
        } catch (Throwable t) {
            klog.error(t);
        }
    }

    public static void playToolSuccess() {

        try {
            new SoundPlayer(JarResources.toURL("Externalize.wav"));    // same for now
        } catch (Throwable t) {
            klog.error(t);
        }
    }

    public static void playToolKilled() {

        try {
            new SoundPlayer(JarResources.toURL("Killed.wav"));
        } catch (Throwable t) {
            klog.error(t);
        }
    }


    public static void playFtpComplete() {
        try {

            new SoundPlayer(JarResources.toURL("FtpComplete.wav"));

        } catch (Throwable t) {
            klog.error(t);
        }
    }

    /**
     * <p> </p>
     * <p> </p>
     * <p> </p>
     * <p> </p>
     *
     * @author Aravind Subramanian
     * @version %I%, %G%
     */
    static class SoundPlayer extends Thread {

        final URL url;

        public SoundPlayer(URL url) {

            this.url = url;

            if (url == null) {
                ;    // bad url
            } else {
                setPriority(MIN_PRIORITY);
                start();
            }
        }

        public void run() {

            Object obj = kUrlSoundMap.get(url);    // already loaded?

            if (obj == null) {
                obj = Applet.newAudioClip(url);

                kUrlSoundMap.put(url, obj);
            }

            AudioClip ac = (AudioClip) obj;

            ac.play();
        }
    }
}    // End XSounds

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
