package edu.mit.broad.xbench.core.api;

import edu.mit.broad.genome.objects.GenesOfInterest;
import edu.mit.broad.vdb.sampledb.SampleAnnot;

import java.io.File;

/**
 * Class that defines databases that are widely available
 */
public interface VdbManager {

    public SampleAnnot getDefaultSampleAnnot();

    public GenesOfInterest getDefaultGenesOfInterest();

    public File getRuntimeHomeDir();

    public File getTmpDir(); // must not be lazily made -- too many things depend on it

    public File getDatabasesDir();

    public File getExamplesDir();

    public File getTestDataDir();

    public File getReportsCacheDir();

    public File getDefaultOutputDir();

    public DescriptedFile[] getDescriptedFiles();

} // End interface VdbManager
