/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.dataio;


import java.awt.*;


/**
 * Class ImportStage
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
class ImportStage {

    public final String name;
    public final Color color;
    static final ImportStage WAITING = new ImportStage("waiting", Color.gray);
    static final ImportStage PARSING = new ImportStage("parsing", Color.blue);
    static final ImportStage SUCCESS = new ImportStage("success", Color.green);
    static final ImportStage ERROR = new ImportStage("error!", Color.red);

    protected ImportStage(ImportStage initialStage) {
        this.name = initialStage.name;
        this.color = initialStage.color;
    }

    private ImportStage(String name, Color color) {
        this.name = name;
        this.color = color;
    }

    public String toString() {
        return name;
    }
}    // End ImportState

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
