/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.dataio;


import edu.mit.broad.xbench.actions.FilesAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;
import java.io.File;


/**
 * @author Aravind Subramanian
 */
public class ParserAction extends FilesAction {

    private File[] fFiles;

    /**
     * Class constructor
     */
    public ParserAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }


    /**
     * Class constructor
     *
     * @param files
     */
    public ParserAction(File[] files) {

        this();

        this.fFiles = files;
    }

    public void setFiles(File[] files) {
        this.fFiles = files;
    }

    public void setFile(File file) {
        setFiles(new File[]{file});
    }

    public Widget getWidget() {

        if (fFiles != null) {
            return new ParserWidget(fFiles);
        } else {
            return new ParserWidget();
        }
    }

    public String getName() {
        return ParserWidget.TITLE;
    }

    public Icon getIcon() {
        return ParserWidget.ICON;
    }

    public String getDescription() {
        return "Parse Data into the Application";
    }

    public String getId() {
        return "ParserAction";
    }
}    // End ParserAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
