/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.explorer.filemgr;

import java.io.File;

/**
 * Simplified (both in code and UI) & specialized directory chooser
 * Based on the IntelliJ UI.
 */
public interface XDirChooser {

    public void setRootLocation(final String path);

    public void setCurrentLocation(final String path);

    public boolean show();

    public File getSelectedDir();

    public void setApproveButtonText(String txt);

    public void resetState();

} // End XDirChooser
