/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.explorer.filemgr;

import java.io.File;

/**
 * 1) custom icons
 * 2) keep ext stuff confinded here
 * <p/>
 * ONLY for files -- dont use for directories
 *
 * @see DirChooser for directories
 */
public interface XFileChooser {

    public void setCurrentLocation(final File file);

    public void setCurrentLocation(final String path);

    public void setApproveButtonText(final String txt);

    public File getSelectedFile();

    public File[] getSelectedFiles();

    public boolean showOpenDialog();

    public boolean showSaveDialog();

    public void setMultiSelectionEnabled(boolean multi); // @todo hot to for reusabiluyt

} // End XFileChooser
