/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

package edu.mit.broad.xbench.explorer.filemgr;


import edu.mit.broad.genome.swing.dnd.DndSource;
import edu.mit.broad.xbench.core.Widget;


/**
 * Customized XTreeDirectoryPane for xomics.
 * <p/>
 * Features:
 * 1) Only recognized file types (by ext) are displayed
 * 2) Associates popup menu actions with some files
 * 3) Dnd support for dragging files out of the explorer
 * to other places.
 * 4) displays files in a tree pane
 * 5) Filter files, sort files etc ...
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public interface XTreeDirectoryPane extends Widget, DndSource {

    public String toString();

    public void setSortByType(final boolean setOrNot);

    public void showOnlyXFiles(final boolean show);

    public void refresh();

    public void setRootLocation(final String rootPath);

    public void setRootVisible(final boolean vis);


}    // End XTreeDirectoryPane

/*--- Formatted in Sun Java Convention Style on Thu, Oct 31, '02 ---*/
