/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import edu.mit.broad.genome.swing.fields.GCheckBoxField;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

import javax.swing.*;

/**
 * @author Aravind Subramanian
 *         Date: Mar 14, 2003
 *         Time: 2:42:07 AM
 */
public class BooleanPreference extends AbstractPreference {

    private GCheckBoxField fField;

    /**
     * @param name
     * @param desc
     * @param def
     */
    protected BooleanPreference(final String name,
                                final String desc,
                                final boolean def,
                                final boolean isDebug,
                                final boolean needsRestart) {
        super(name, desc, Boolean.valueOf(def), isDebug, needsRestart);
    }

    public boolean getBoolean() {
        return ((Boolean) getValue()).booleanValue();
    }

    public Boolean getBooleanO() {
        return (Boolean) getValue();
    }

    public Object getValue() {
        return Boolean.valueOf(kPrefs.getBoolean(getName(), ((Boolean) getDefault()).booleanValue()));
    }

    public void reset() {
        if (fField != null) {
            fField.setValue(getValue());
        }
    }

    public GFieldPlusChooser getSelectionComponent() {
        if (fField == null) {
            JCheckBox cx = new JCheckBox("", ((Boolean) getValue()).booleanValue());
            fField = new GCheckBoxField(cx);
        }

        //klog.debug("Getting component");
        fField.setValue(getValue());
        return fField;
    }


    public void setValue(final Object value) throws Exception {
        kPrefs.putBoolean(getName(), ((Boolean) value).booleanValue());
    }

    public boolean isDebugPreference() {
        return false;
    }

    public void setValueOfPref2SelectionComponentValue() {
        if (fField != null) {
            super._setValueOfPref2SelectionComponentValue(fField.getValue());
        }
    }

} // End BooleanPreference

