/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import edu.mit.broad.genome.swing.fields.GDirFieldPlusChooser;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

import java.io.File;

/**
 * @author Aravind Subramanian
 *         Date: Mar 14, 2003
 *         Time: 2:41:42 AM
 */
public class DirPreference extends AbstractPreference {

    private GDirFieldPlusChooser fChooser;

    /**
     * @param name
     * @param desc
     * @param def
     */
    protected DirPreference(String name, String desc, File def, boolean isDebug, boolean needsRestart) {
        super(name, desc, def, isDebug, needsRestart);
    }

    public Object getValue() {
        String s = kPrefs.get(getName(), ((File) getDefault()).getPath());
        return new File(s);
    }

    public File getDir(boolean makeItIfItDoesntAlreadyExist) {
        //klog.debug("$$$ " + getValue());
        File f = (File) getValue();
        if ((f.exists() == false) && (makeItIfItDoesntAlreadyExist)) {
            boolean success = f.mkdir();
            klog.info("Made pref dir: " + f + " status: " + success);
        }
        return (File) getValue();
    }

    public void setValue(Object value) throws Exception {
        kPrefs.put(getName(), value.toString());
    }

    public GFieldPlusChooser getSelectionComponent() {

        if (fChooser == null) {
            fChooser = new GDirFieldPlusChooser();
            fChooser.setValue(getValue());
        }

        fChooser.setValue(getValue());

        //klog.debug("Getting component");

        return fChooser;

    }

    public void reset() {
        if (fChooser != null) {
            fChooser.setValue(getValue());
        }
    }

    public void setValueOfPref2SelectionComponentValue() {
        if (fChooser != null) {
            super._setValueOfPref2SelectionComponentValue(fChooser.getValue());
        }
    }

} // End DirPreference