/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import edu.mit.broad.genome.swing.choosers.GFileFieldPlusChooser;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

import java.io.File;

/**
 * @author Aravind Subramanian
 *         Date: Mar 14, 2003
 *         Time: 2:41:42 AM
 */
public class FilePreference extends AbstractPreference {

    private GFileFieldPlusChooser fChooser;

    /**
     * @param name
     * @param desc
     * @param def
     */
    protected FilePreference(final String name,
                             final String desc,
                             final File def,
                             final boolean isDebug,
                             final boolean needsRestart) {

        super(name, desc, def, isDebug, needsRestart);
    }

    public Object getValue() {
        String s = kPrefs.get(getName(), ((File) getDefault()).getPath());
        return new File(s);
    }

    public File getFile() {
        return (File) getValue();
    }

    public void setValue(Object value) throws Exception {
        kPrefs.put(getName(), value.toString());
    }

    public GFieldPlusChooser getSelectionComponent() {
        if (fChooser == null) {
            fChooser = new GFileFieldPlusChooser();
        }

        //klog.debug("Getting component");
        fChooser.setValue(getValue());
        return fChooser;
    }

    public void reset() {
        if (fChooser != null) {
            fChooser.setValue(getValue());
        }
    }

    public void setValueOfPref2SelectionComponentValue() {
        if (fChooser != null) {
            super._setValueOfPref2SelectionComponentValue(fChooser.getValue());
        }
    }

} // End FilePreference