/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;
import edu.mit.broad.genome.swing.fields.GIntegerField;
import edu.mit.broad.genome.utils.NamedInteger;

/**
 * @author Aravind Subramanian
 *         Date: Mar 14, 2003
 *         Time: 2:42:07 AM
 */
public class IntPreference extends AbstractPreference {

    protected GFieldPlusChooser fField;

    /**
     * @param name
     * @param desc
     * @param def
     */
    protected IntPreference(String name, String desc, int def, boolean isDebug, boolean needsRestart) {
        super(name, desc, new Integer(def), isDebug, needsRestart);
    }

    public Object getValue() {
        return new Integer(kPrefs.getInt(getName(), ((Integer) getDefault()).intValue()));
    }

    public int getInt() {
        return ((Integer) getValue()).intValue();
    }

    public GFieldPlusChooser getSelectionComponent() {
        if (fField == null) {
            fField = new GIntegerField(getInt(), 10);
        }

        fField.setValue(getValue());
        return fField;
    }

    public void setValue(Object value) throws Exception {

        int ival;

        if (value instanceof NamedInteger) {
            ival = ((NamedInteger) value).getValue();
        } else {
            ival = Integer.parseInt(value.toString());
        }

        kPrefs.putInt(getName(), ival);
    }

    public void reset() {
        if (fField != null) {
            fField.setValue(getValue());
        }
    }

    public void setValueOfPref2SelectionComponentValue() {
        if (fField != null) {
            super._setValueOfPref2SelectionComponentValue(fField.getValue());
        }
    }

} // End IntPreference
