/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

import java.util.prefs.Preferences;

/**
 * @author Aravind Subramanian
 *         Date: Mar 14, 2003
 *         Time: 2:42:43 AM
 */
public interface Preference {

    public static String PATHNAME = Preference.class.toString();

    public static Preferences kPrefs = Preferences.userRoot().node(PATHNAME);

    public String getName();

    public String getDesc();

    public Object getDefault();

    public Object getValue();

    public void setValue(final Object newValue) throws Exception;

    public GFieldPlusChooser getSelectionComponent();

    public void reset();

    public void setValueOfPref2SelectionComponentValue();

    /**
     * some prefs are in for debugging only
     */
    public boolean isDebugPreference();

    public boolean needsRestart();

}


