/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import javax.swing.*;

/**
 * @author Aravind Subramanian
 *         Date: Mar 14, 2003
 *         Time: 2:46:08 AM
 */
class PreferenceCategory {

    private String fName;
    private String fDesc;
    private Icon fIcon;

    private boolean isDebugCategory;

    private Preference[] fPrefs;

    PreferenceCategory(String name, String desc, Icon icon, Preference[] prefs, boolean isDebugCategory) {
        this.fName = name;
        this.fDesc = desc;
        this.fPrefs = new Preference[prefs.length]; // shallow clone
        for (int i = 0; i < prefs.length; i++) {
            this.fPrefs[i] = prefs[i];
        }

        this.isDebugCategory = isDebugCategory;
        this.fIcon = icon;
    }

    public String getName() {
        return fName;
    }

    public Icon getIcon() {
        return fIcon;
    }

    public boolean isDebugCategory() {
        return isDebugCategory;
    }

    public String getDesc() {
        return fDesc;
    }

    public Preference[] getPreferences() {
        return fPrefs; // dont bother cloning
    }

}
