/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;
import edu.mit.broad.genome.swing.fields.GStringField;

/**
 * @author Aravind Subramanian
 *         Date: Mar 14, 2003
 *         Time: 2:42:07 AM
 */
public class StringPreference extends AbstractPreference {

    private GStringField fField;

    protected StringPreference(String name, String desc, String def, boolean isDebug, boolean needsRestart) {
        super(name, desc, def, isDebug, needsRestart);
    }

    public Object getValue() {
        return kPrefs.get(getName(), getDefault().toString());
    }

    public String getString() {
        return getValue().toString();
    }

    public GFieldPlusChooser getSelectionComponent() {
        if (fField == null) {
            fField = new GStringField();
        }

        fField.setValue(getValue());

        //klog.debug("Getting component");
        return fField;
    }

    public void setValue(Object value) {
        kPrefs.put(getName(), value.toString());
    }

    public void reset() {
        if (fField != null) {
            fField.setValue(getValue());
        }
    }

    public void setValueOfPref2SelectionComponentValue() {
        if (fField != null) {
            super._setValueOfPref2SelectionComponentValue(fField.getValue());
        }
    }

} // End FilePreference

