/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.prefs;

import edu.mit.broad.genome.swing.fields.FieldFactory;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

/**
 * Where to place the tabs
 */
public class TabPlacementPreference extends IntPreference {

    /**
     * @param name
     * @param desc
     * @param def
     */
    protected TabPlacementPreference(String name, String desc, int def) {
        super(name, desc, def, false, true);
    }

    public GFieldPlusChooser getSelectionComponent() {
        if (fField == null) {
            fField = FieldFactory.createTabPlacementField(getInt());
        }

        fField.setValue(getValue());
        return fField;
    }

} // End TabPlacementPreference

