/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.tui;

import xtools.api.Tool;
import xtools.api.param.ParamSet;

import javax.swing.*;
import java.awt.event.MouseMotionListener;

/**
 * @author Aravind Subramanian
 *         Date: Dec 25, 2004
 *         Time: 8:56:22 PM
 */
public class ToolDisplayFactory {

    public static ParamSetDisplay createParamSetDisplayComponent(final Tool tool, final MouseMotionListener ml) {
        return createParamSetDisplayComponent(tool.getTitle(), null, tool.getParamSet(), ml);
    }

    public static ParamSetDisplay createParamSetDisplayComponent(final String title,
                                                                 final Icon icon,
                                                                 final ParamSet pset,
                                                                 final MouseMotionListener ml) {
        // @changed march 2006 always go with the form
        return new ParamSetFormDisplay(title, icon, pset, ml);
        /*
        if (XPreferencesFactory.kToolDisplayComponent.getBoolean()) {
            return new ParamSetTableDisplay(pset);
        } else {
            return new ParamSetFormDisplay(title, icon, pset, ml);
        }
        */
    }

    public static ToolSelectorUI createToolSelector(final Tool[] tools,
                                                    final boolean showReportNode,
                                                    final boolean showRootNode) {

        return new ToolSelectorTree(tools, showReportNode, showRootNode);
        /*// @changed march 2006 always go with the form
        if (XPreferencesFactory.kToolSelectorComponent.getBoolean()) {
            return new ToolSelectorTree(tools, showReportNode, showRootNode);
        } else {
            return new ToolSelectorComboBox(tools);
        }
        */
    }

    public static ToolLauncher createToolLauncher() {
        return new ToolLauncherDefaultImpl();
    }

    /**
     * @param tools
     * @param showLsfOption
     * @param showHighCpuOption
     * @param showReportNode
     * @param showRootNode
     * @param showToolLauncher
     * @param makeNormalTheDefault
     * @param showGrayHelptext
     * @param icon
     * @param title
     * @return
     */
    public static ToolLauncher createToolLauncher(final Tool[] tools,
                                                  final boolean showLsfOption,
                                                  final boolean showHighCpuOption,
                                                  final boolean showReportNode,
                                                  final boolean showRootNode,
                                                  final boolean showToolLauncher,
                                                  final boolean makeNormalTheDefault,
                                                  final boolean showGrayHelptext,
                                                  final Icon icon,
                                                  final String title) {
        return new ToolLauncherDefaultImpl(tools,
                showLsfOption,
                showHighCpuOption,
                showReportNode,
                showRootNode,
                showToolLauncher,
                makeNormalTheDefault,
                showGrayHelptext,
                icon,
                title);

    }

} // End class ParamSetDisplayFactory
