/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.xbench.tui;


import edu.mit.broad.xbench.actions.WidgetAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;
import java.awt.*;


/**
 * @author Aravind Subramanian
 */
public class ToolLauncherAction extends WidgetAction {

    public final static Dimension DEFAULT_DIM = new Dimension(550, 380);
    private static ToolLauncher kToolLauncher;


    public ToolLauncherAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }

    public Widget getWidget() {
        // IMP dont place this in the class init are -- cause the app to recursively loop
        //setSize(DEFAULT_DIM.width, DEFAULT_DIM.height, true);

        if (kToolLauncher == null) {
            kToolLauncher = ToolDisplayFactory.createToolLauncher();
        }

        return kToolLauncher;
    }

    public String getId() {
        return "ToolLauncherAction";
    }

    public String getName() {
        return ToolLauncher.TITLE;
    }

    public Icon getIcon() {
        return ToolLauncher.ICON;
    }

    public String getDescription() {
        return "Set Parameters and Launch Analysis Tools";
    }
}    // End ToolAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
