/*
  The Broad Institute
  SOFTWARE COPYRIGHT NOTICE AGREEMENT
  This software and its documentation are copyright (2003-2006) by the
  Broad Institute/Massachusetts Institute of Technology. All rights are
  reserved.

  This software is supplied without any warranty or guaranteed support
  whatsoever. Neither the Broad Institute nor MIT can be responsible for its
  use, misuse, or functionality.
*/


package org.genepattern.heatmap.image;

import java.util.List;

/**
 * @author Joshua Gould
 */
public interface FeatureAnnotator {
    /**
     * @param feature the feature
     * @param j       the column
     * @return the jth annotation for the feature at the given row
     */
    public String getAnnotation(String feature, int j);

    /**
     * @return the maximum number of annotations to draw
     */
    public int getColumnCount();

    /**
     * @param featureName the feature
     * @param j           the column
     * @return the jth color for the feature at the given row
     */
    public List getColors(String featureName);

}
