/*
  The Broad Institute
  SOFTWARE COPYRIGHT NOTICE AGREEMENT
  This software and its documentation are copyright (2003-2006) by the
  Broad Institute/Massachusetts Institute of Technology. All rights are
  reserved.

  This software is supplied without any warranty or guaranteed support
  whatsoever. Neither the Broad Institute nor MIT can be responsible for its
  use, misuse, or functionality.
*/


package org.genepattern.heatmap.image;

import java.awt.*;
import java.util.List;

public interface SampleAnnotator {
    /**
     * @param sampleName the sampleName
     * @return the phenotype color
     */
    public Color getPhenotypeColor(String sampleName);

    /**
     * @return <tt>true</tt> if phenotype colors should be drawn,
     *         <tt>false</tt> otherwise
     */
    public boolean hasPhenotypeColors();

    /**
     * @param i the row
     * @return the ith label
     */
    public String getLabel(int i);

    /**
     * @param sampleName the sample name
     * @return a list of colors for the sample at the given column
     */
    public List getColors(String sampleName);

}
