/*
  The Broad Institute
  SOFTWARE COPYRIGHT NOTICE AGREEMENT
  This software and its documentation are copyright (2003-2006) by the
  Broad Institute/Massachusetts Institute of Technology. All rights are
  reserved.

  This software is supplied without any warranty or guaranteed support
  whatsoever. Neither the Broad Institute nor MIT can be responsible for its
  use, misuse, or functionality.
*/

/*
  The Broad Institute
  SOFTWARE COPYRIGHT NOTICE AGREEMENT
  This software and its documentation are copyright (2003-2006) by the
  Broad Institute/Massachusetts Institute of Technology. All rights are
  reserved.

  This software is supplied without any warranty or guaranteed support
  whatsoever. Neither the Broad Institute nor MIT can be responsible for its
  use, misuse, or functionality.
*/


package org.genepattern.io;

import com.sun.media.jai.codec.*;

import javax.media.jai.JAI;
import java.awt.image.BufferedImage;

public class ImageUtil {

    private ImageUtil() {
    }


    /**
     * Saves the image to a file
     *
     * @param bi
     * @param outputFileName
     * @param outputFileFormat
     */
    public static void saveImage(BufferedImage bi, String outputFileName,
                                 String outputFileFormat) {

        if (outputFileFormat.equals("jpeg")) {
            if (!outputFileName.toLowerCase().endsWith(".jpg")
                    && !outputFileName.toLowerCase().endsWith(".jpeg")) {
                outputFileName += ".jpg";
            }
        } else if (outputFileFormat.equals("png")) {
            if (!outputFileName.toLowerCase().endsWith(".png")) {
                outputFileName += ".png";
            }
        } else if (outputFileFormat.equals("tiff")) {
            if (!outputFileName.toLowerCase().endsWith(".tiff")) {
                outputFileName += ".tiff";
            }
        } else if (outputFileFormat.equals("bmp")) {
            if (!outputFileName.toLowerCase().endsWith(".bmp")) {
                outputFileName += ".bmp";
            }
        } else {
            throw new IllegalArgumentException("Unknown output file format");
        }

        ImageEncodeParam fParam = null;
        if (outputFileFormat.equals("jpeg")) {
            JPEGEncodeParam jpegParam = new JPEGEncodeParam();
            jpegParam.setQuality(1.0f);
            fParam = jpegParam;
        } else if (outputFileFormat.equals("png")) {
            fParam = new PNGEncodeParam.RGB();
        } else if (outputFileFormat.equals("tiff")) {
            TIFFEncodeParam param = new TIFFEncodeParam();
            param.setCompression(TIFFEncodeParam.COMPRESSION_NONE);
            fParam = param;
        } else if (outputFileFormat.equals("bmp")) {
            fParam = new BMPEncodeParam();
        } else {
            throw new IllegalArgumentException("Unknown output file format");
        }

        JAI.create("filestore", bi, outputFileName, outputFileFormat, fParam);
    }

}
