/*
 The Broad Institute
 SOFTWARE COPYRIGHT NOTICE AGREEMENT
 This software and its documentation are copyright (2003-2006) by the
 Broad Institute/Massachusetts Institute of Technology. All rights are
 reserved.

 This software is supplied without any warranty or guaranteed support
 whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 use, misuse, or functionality.
 */

/*
 The Broad Institute
 SOFTWARE COPYRIGHT NOTICE AGREEMENT
 This software and its documentation are copyright (2003-2006) by the
 Broad Institute/Massachusetts Institute of Technology. All rights are
 reserved.

 This software is supplied without any warranty or guaranteed support
 whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 use, misuse, or functionality.
 */

package org.genepattern.menu;

import org.genepattern.uiutil.OS;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author Joshua Gould
 */
public abstract class FileMenu extends AbstractPlotMenu {

    public FileMenu(JComponent plot, Frame parent) {
        super("File", plot, parent);
    }

    public static JMenuItem createExitMenuItem() {
        JMenuItem item = null;
        if (OS.isMac()) {
            item = new JMenuItem("Quit");
            KeyStroke ks = KeyStroke.getKeyStroke('Q', Toolkit
                    .getDefaultToolkit().getMenuShortcutKeyMask());
            item.setAccelerator(ks);
        } else {
            item = new JMenuItem("Exit");
        }

        item.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }

        });
        return item;
    }

}
