/*
 The Broad Institute
 SOFTWARE COPYRIGHT NOTICE AGREEMENT
 This software and its documentation are copyright (2003-2006) by the
 Broad Institute/Massachusetts Institute of Technology. All rights are
 reserved.

 This software is supplied without any warranty or guaranteed support
 whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 use, misuse, or functionality.
 */

/*
 The Broad Institute
 SOFTWARE COPYRIGHT NOTICE AGREEMENT
 This software and its documentation are copyright (2003-2006) by the
 Broad Institute/Massachusetts Institute of Technology. All rights are
 reserved.

 This software is supplied without any warranty or guaranteed support
 whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 use, misuse, or functionality.
 */

package org.genepattern.menu;

import javax.swing.*;

/**
 * An <tt>AbstractAction</tt> that performs some action on a plot
 *
 * @author Joshua Gould
 */
// XXX refactor so that no longer inherits from AbstractAction
public abstract class PlotAction extends AbstractAction {
    static public final String SHOW_ACCELERATORS_PROPERTY = "org.genepattern.menu.showAccelerators";

    private JComponent plot;

    public PlotAction(String name) {
        super(name);
    }

    public PlotAction() {
        super();
    }

    /**
     * Sets the current plot component
     *
     * @param plot the plot
     */
    public void setPlot(JComponent plot) {
        this.plot = plot;
    }

    /**
     * Gets the current plot component
     *
     * @return the plot
     */
    public JComponent getPlot() {
        return plot;
    }

    /**
     * Creates the sub menu items if this action has any or <tt>null</tt> if
     * this action does not contain menu items and hence will be a menu
     *
     * @return the sub menu items
     */
    public JMenuItem[] getSubMenuItems() {
        return null;
    }
}
