/*
 The Broad Institute
 SOFTWARE COPYRIGHT NOTICE AGREEMENT
 This software and its documentation are copyright (2003-2006) by the
 Broad Institute/Massachusetts Institute of Technology. All rights are
 reserved.

 This software is supplied without any warranty or guaranteed support
 whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 use, misuse, or functionality.
 */

/*
 The Broad Institute
 SOFTWARE COPYRIGHT NOTICE AGREEMENT
 This software and its documentation are copyright (2003-2006) by the
 Broad Institute/Massachusetts Institute of Technology. All rights are
 reserved.

 This software is supplied without any warranty or guaranteed support
 whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 use, misuse, or functionality.
 */

package org.genepattern.menu.jfree;

import org.genepattern.menu.AbstractSaveImageAction;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;

import java.awt.*;
import java.awt.image.BufferedImage;

/**
 * @author Joshua Gould
 */
public class JFreeSaveImageAction extends AbstractSaveImageAction {

    public JFreeSaveImageAction(Frame parent) {
        super(parent);
    }

    protected BufferedImage createImage() {
        ChartPanel plot = (ChartPanel) getPlot();
        return createImage(plot);
    }

    public static BufferedImage createImage(ChartPanel plot) {
        JFreeChart jfree = plot.getChart();
        BufferedImage bufferedImage = new BufferedImage(
                plot.getPreferredSize().width, plot.getPreferredSize().height,
                BufferedImage.TYPE_3BYTE_BGR);
        Rectangle rectangle = new Rectangle(plot.getPreferredSize());
        Graphics2D g2 = bufferedImage.createGraphics();
        jfree.draw(g2, rectangle);
        g2.dispose();
        return bufferedImage;
    }

}
