/*
 The Broad Institute
 SOFTWARE COPYRIGHT NOTICE AGREEMENT
 This software and its documentation are copyright (2003-2006) by the
 Broad Institute/Massachusetts Institute of Technology. All rights are
 reserved.

 This software is supplied without any warranty or guaranteed support
 whatsoever. Neither the Broad Institute nor MIT can be responsible for its
 use, misuse, or functionality.
 */

package org.genepattern.uiutil;

import javax.swing.*;

/**
 * @author Joshua Gould
 */
public class OS {

    private OS() {
    }

    public static boolean isMac() {
        return System.getProperty("mrj.version") != null
                && javax.swing.UIManager.getSystemLookAndFeelClassName()
                .equals(
                        javax.swing.UIManager.getLookAndFeel()
                                .getClass().getName());
    }

    public static boolean isWindows() {
        return System.getProperty("os.name").toLowerCase()
                .startsWith("windows");
    }

    public static void setLookAndFeel() {
        if (!OS.isMac()) {
            try {
                UIManager.setLookAndFeel(UIManager
                        .getSystemLookAndFeelClassName());
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

    }
}
