/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xapps.api;

import edu.mit.broad.xbench.actions.WidgetAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class AppDataLoaderAction extends WidgetAction {

    private AppDataLoaderWidget fApl;

    public AppDataLoaderAction() {
        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }

    public Widget getWidget() {

        if (fApl == null) {
            fApl = new AppDataLoaderWidget();
        }

        fApl.revalidate();
        fApl.repaint();
        return fApl;
    }

    public String getId() {
        return "AppDataLoaderAction";
    }

    public String getName() {
        return AppDataLoaderWidget.TITLE;
    }

    public Icon getIcon() {
        return AppDataLoaderWidget.ICON;
    }

    public String getDescription() {
        return "Import data from file(s) into the application";
    }

}    // End AppFileBrowserAction