package xapps.api;

import com.jgoodies.looks.LookUtils;
import com.jgoodies.looks.Options;
import com.jgoodies.looks.plastic.PlasticXPLookAndFeel;
import com.jgoodies.looks.plastic.theme.ExperienceBlue;
import edu.mit.broad.genome.utils.SystemUtils;

import javax.swing.*;

/**
 * @author Aravind Subramanian
 *         Date: Oct 6, 2005
 *         Time: 3:36:17 PM
 */
public class MostMain implements AppMain {

    // Tell Jide we are valid

    static {
        com.jidesoft.utils.Lm.verifyLicense("Broad Institute of MIT and Harvard",
                "Gene set  enrichment analysis java desktop application",
                "YSjBO6OJfF9WbavzI73Jt1HgDI4x9L21");
    }

    /**
     * @note dont make this class do anything ore fancy than install lnf
     * <p/>
     * Class Constructor.
     * <p/>
     * Class Constructor.
     * <p/>
     * Class Constructor.
     * <p/>
     * Class Constructor.
     * <p/>
     * Class Constructor.
     */

    /**
     * Class Constructor.
     */
    public void setLnF() {

        try {

            // Set the look and feel early
            // Java Web Start
            // If you use a third party l&f in a network launchable environment such as Java Web Start, you must indicate where to find the l&f classes:
            UIManager.put("ClassLoader", LookUtils.class.getClassLoader());

            try {
                if (!SystemUtils.isMac()) {
                    PlasticXPLookAndFeel.setMyCurrentTheme(new ExperienceBlue());
                    UIManager.setLookAndFeel(new com.jgoodies.looks.plastic.PlasticXPLookAndFeel());
                    //UIManager.setLookAndFeel(new com.jgoodies.looks.));
                    //PlasticLookAndFeel.setMyCurrentTheme(new Silver());
                    //UIManager.setLookAndFeel(new com.jgoodies.looks.plastic.PlasticLookAndFeel());

                }

            } catch (Throwable t) {
                t.printStackTrace();
            }
            //UIManager.setLookAndFeel("com.jgoodies.looks.plastic.PlasticXPLookAndFeel");
            //UIManager.setLookAndFeel("com.jgoodies.looks.plastic.Plastic3DLookAndFeel");
            //UIManager.setLookAndFeel("com.jgoodies.looks.plastic.ExtWindowsLookAndFeel");
            // PlasticXPLookAndFeel.setMyCurrentTheme(new DarkStar());
            //PlasticXPLookAndFeel.setMyCurrentTheme(new DesertBlue());

            // Some UI tweaks thanks to jgoodies suggestions
            // You can force the JGoodies looks and the 1.4 versions of the
            // // Sun looks to use system fonts using a String key, or JGoodies constant:
            UIManager.put("Application.useSystemFontSettings", Boolean.TRUE);
            UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);

            // In Microsoft environments that use Tahoma as dialog font, you can
            // tweak the choosen font sizes by setting optional JGoodies font size hints. The global hints can be overriden by look-specific hints:
            Options.setUseSystemFonts(true);
            // @note api deprecated jgoodies 2.0 feb 2006
            //setGlobalFontSizeHints(FontSizeHints.MIXED);

            // Dont know if the font stuff actualy did anything!!

            //You can choose between two styles for Plastic focus colors: low vs. high contrast;
            // the default is low. You can choose one of:
            //PlasticXPLookAndFeel.setHighContrastFocusColorsEnabled(true);

            // lthough ClearLook will typlically improve the appearance of your application,
            // it may lead to incompatible layout, and so, it is switched off by default.
            // You can switch it on, enable a verbose mode, which will log reports about
            // the performed modifications to the console or use the debug mode. In debug mode,
            // ClearLook will mark decorations that it has identified as visual clutter using saturated colors.

            //ClearLookManager.setMode(ClearLookMode.DEBUG);

            // enable tooltips application wide
            ToolTipManager.sharedInstance().setEnabled(true);

            // make tooltips persist for a wee bit longer than the default
            ToolTipManager.sharedInstance().setDismissDelay(15 * 1000);


        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    // Used when the icnors alloy lnf was used
    protected static void initAlloyGlobalPropertiesOld(boolean installDefaultLookAndFeel) {
        // enable tooltips application wide
        ToolTipManager.sharedInstance().setEnabled(true);

        // make tooltips persist for a wee bit longer than the default
        ToolTipManager.sharedInstance().setDismissDelay(15 * 1000);

        try {
            // UIManager.setLookAndFeel(new MetouiaLookAndFeel());

            /* If a custom theme is needed
            Color contrastControlColor = new Color(151, 182, 224);
            Color standardControlColor  = new Color(241, 240, 227);
            //Color arrowButtonColor  = new Color(236, 234, 226);
            //Color frameColor = new Color( 90, 144, 218);
            Color desktopColor = new Color( 164, 164, 158);
            Color selectionColor = new Color(96, 128, 172);
            //Color rolloverColor = Color.BLACK;
            Color rolloverColor = GuiHelper.COLOR_DARK_BLUE; //new Color(255, 207, 49);
            Color highlightColor = new Color(249, 224, 137);
            //Color highlightColor = Color.GREEN;
            // create custom theme
            com.incors.plaf.alloy.AlloyTheme theme =
                com.incors.plaf.alloy.themes.custom.CustomThemeFactory.createTheme(contrastControlColor,
                standardControlColor, desktopColor, selectionColor, rolloverColor, highlightColor);
            */

            // The lines below can be used for setting the other themes.
            //com.incors.plaf.alloy.AlloyTheme theme = new com.incors.plaf.alloy.themes.glass.GlassTheme();
            //com.incors.plaf.alloy.AlloyTheme theme = new com.incors.plaf.alloy.themes.bedouin.BedouinTheme();
            //com.incors.plaf.alloy.AlloyTheme theme = new com.incors.plaf.alloy.themes.acid.AcidTheme();
            //javax.swing.LookAndFeel alloyLnF = new com.incors.plaf.alloy.AlloyLookAndFeel(theme);

            /*
            try {
                UIManager.setLookAndFeel("PlasticXPLookAndFeel");
            } catch (Exception e) {
                // Likely PlasticXP is not in the class path; ignore.
            }
            */

            if (installDefaultLookAndFeel) {
                //com.incors.plaf.alloy.AlloyLookAndFeel.setProperty("alloy.licenseCode", "2005/11/04#aravind@broadinstitute.org#159acnt#192ud0");
                //javax.swing.LookAndFeel alloyLnF = new com.incors.plaf.alloy.AlloyLookAndFeel(new com.incors.plaf.alloy.themes.bedouin.BedouinTheme());
                //javax.swing.UIManager.setLookAndFeel(alloyLnF);
            }


        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }


} // End class AbstractMain
