/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xapps.api;

import edu.mit.broad.genome.viewers.ReportViewer;
import edu.mit.broad.xbench.actions.WidgetAction;
import edu.mit.broad.xbench.core.Widget;
import edu.mit.broad.xbench.tui.ToolDisplayFactory;
import edu.mit.broad.xbench.tui.ToolLauncher;
import xtools.api.Tool;

import javax.swing.*;
import java.awt.*;


/**
 * @author Aravind Subramanian
 */
public class PastAnalysisAction extends WidgetAction {

    public final static Dimension DEFAULT_DIM = new Dimension(550, 380);
    private static ToolLauncher kToolLauncher = null;

    /**
     * Class constructor
     */
    public PastAnalysisAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }

    public Widget getWidget() {
        // IMP dont place this in the class init are -- cause the app to recursively loop
        //setSize(DEFAULT_DIM.width, DEFAULT_DIM.height, true);

        if (kToolLauncher == null) {
            kToolLauncher = ToolDisplayFactory.createToolLauncher(new Tool[]{}, false, false, true, false,
                    false, false, true, ReportViewer.ICON, "Analysis history");
        }

        return kToolLauncher;
    }

    public String getId() {
        return "PastAnalysisAction";
    }

    public String getName() {
        return ToolLauncher.TITLE;
    }

    public Icon getIcon() {
        return ReportViewer.ICON;
    }

    public String getDescription() {
        return "Record of past analyses";
    }

}    // End GeneSetUtilitiesLauncherAction


