package xapps.api.frameworks.fiji;

import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.xbench.core.Window;

import javax.swing.*;
import java.awt.*;

/**
 * @author Aravind Subramanian
 *         Date: Dec 23, 2005
 *         Time: 6:34:03 PM
 */
public class JideWindow implements Window {

    private String fTitle;

    private JComponent fComp;

    /**
     * Class constructor
     *
     * @param comp
     */
    public JideWindow(final String title, final JComponent comp) {
        this.fComp = comp;
        this.fTitle = title;
    }

    public Container getContentPane() {
        return fComp;
    }

    public Dimension getSize() {
        return fComp.getSize();
    }

    public Point getLocation() {
        return fComp.getLocation();
    }

    public String getTitle() {
        return fTitle;
    }

    public GraphicsConfiguration getGraphicsConfiguration() {
        return fComp.getGraphicsConfiguration();
    }

    public void removeAll() {
        fComp.removeAll();
    }

    public void hide() {
        fComp.setVisible(false);
    }

    public void dispose() {
        // @todo
        //fComp.dispose();
    }

    /**
     * Helper method to iconify the window.
     */
    public void minimize() {
        throw new NotImplementedException();
        //fDf.set;
    }

    /**
     * Helper method to maximize the window.
     */
    public void maximize() {
        throw new NotImplementedException();
    }

    /**
     * Helper method to de-iconify the window.
     */
    public void restore() {
        throw new NotImplementedException();
    }

    /**
     * Helper method to close the window and Document at once.
     */
    public void close() {
        throw new NotImplementedException();
    }

    public boolean isClosed() {
        throw new NotImplementedException();
    }

    /**
     * Checks to see if this Window's associated UI is ready to be closed.
     */
    public boolean allowClose() {
        throw new NotImplementedException();
    }

    public void show() {
        fComp.setVisible(true);
    }

}
