package xapps.api.frameworks.fiji;

import com.jidesoft.swing.JideTabbedPane;
import edu.mit.broad.xbench.actions.XAction;
import edu.mit.broad.xbench.core.WindowComponent;
import edu.mit.broad.xbench.core.api.AbstractWindowManager;
import edu.mit.broad.xbench.core.api.DialogType;
import edu.mit.broad.xbench.core.api.VTool;
import xapps.api.vtools.VToolRunner;

import javax.swing.*;
import java.awt.*;
import java.io.File;

/**
 * @author Aravind Subramanian
 *         Date: Feb 11, 2006
 *         Time: 12:50:06 PM
 */
public class WindowManagerImplJideTabbedPane extends AbstractWindowManager {

    private VToolRunner fRunner;

    private JideTabbedPane fTabbedPane;

    /**
     * Class constructor
     *
     * @param frame
     * @param tp
     */
    public WindowManagerImplJideTabbedPane(final JFrame frame) {
        super(frame);

        fTabbedPane = new JideTabbedPane(JideTabbedPane.TOP);
        fTabbedPane.setTabEditingAllowed(false);
        //fTabbedPane.setBoxStyleTab(true);
        fTabbedPane.setShowCloseButton(true);
        fTabbedPane.setShowCloseButtonOnTab(true);
        fTabbedPane.setShowGripper(true); // just a decorator no action
        fTabbedPane.setShowIconsOnTab(true);
        fTabbedPane.setShowTabButtons(true);


        fTabbedPane.setFont(FONT_DEFAULT_PLAIN);
        fTabbedPane.setSelectedTabFont(FONT_DEFAULT_BOLD);

    }

    public static final Font FONT_DEFAULT_PLAIN = new Font("Helvetica",
            Font.PLAIN, 14);
    public static final Font FONT_DEFAULT_BOLD = new Font("Helvetica",
            Font.BOLD, 14);

    public JideTabbedPane getTabbedPane() {
        return fTabbedPane;
    }


    private int getTabIndex(WindowComponent wc) {
        for (int i = 0; i < fTabbedPane.getTabCount(); i++) {
            Component comp = fTabbedPane.getComponentAt(i);
            if (comp == wc.getWindowUI()) {
                return i;
            }
        }

        return -1;
    }

    public edu.mit.broad.xbench.core.Window openWindow(final WindowComponent wc) {

        int selIndex = getTabIndex(wc);
        if (selIndex != -1) { // helps the jumpiness a lot
            fTabbedPane.setSelectedIndex(selIndex);
        } else {
            fTabbedPane.addTab(wc.getTitle(), wc.getIcon(), wc.getWindowUI());
            fTabbedPane.setSelectedComponent(wc.getWindowUI());
        }

        return new JideWindow(wc.getTitle(), wc.getWindowUI());
    }

    // -------------------------------------------------------------------------------------------- //
    // ---------------------------------- ACTION RELATED ------------------------------------ //
    // -------------------------------------------------------------------------------------------- //

    public JPopupMenu createPopupMenu(final Object obj) {
        return null;
    }

    public XAction createAction(final Class clazz, final File files[]) {
        return null; // @todo
    }

    public boolean runDefaultAction(final Object obj) {
        return false;
    }

    public void runModalTool(final VTool tool, final DialogType dt) {
        if (fRunner == null) {
            fRunner = new VToolRunner();
        }

        fRunner.showRunner(tool, dt);
    }

} // End class WindowManagerImpl
