package xapps.api.vtools.viewers;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

import edu.mit.broad.genome.JarResources;
import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.HClustDataset;
import edu.mit.broad.genome.objects.Template;
import edu.mit.broad.genome.objects.esmatrix.db.EnrichmentDbMulti;
import edu.mit.broad.genome.objects.esmatrix.db.EnrichmentResult;
import xapps.api.vtools.Hooks;
import xapps.api.vtools.stackables.VStackables;

import javax.swing.*;

/**
 * EnrichmentViewer.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class EnrichmentViewer extends AbstractHeatMapViewer {

    public static final Icon ICON = JarResources.getIcon("GseaApp16.gif");

    public static final Icon ICON_HC = JarResources.getIcon("Cdt.png");

    private EnrichmentDbMulti fEdbMulti_synched;

    /**
     * Class constructor
     *
     * @param multi
     */
    public EnrichmentViewer(final EnrichmentDbMulti multi) {
        this(multi.getESSDataset(), null, null, multi);
    }

    public EnrichmentViewer(final Dataset essDataset,
                            final Template t_opt,
                            final HClustDataset hclust_opt,
                            final EnrichmentDbMulti edb_multi) {

        if (edb_multi == null) {
            throw new IllegalArgumentException("Param edb_multi cannot be null");
        }

        // Always viz the dataset (thats why this is a hmviewer)
        // BUT make sure the manger and actions etc are edb aware

        this.fEdbMulti_synched = edb_multi.cloneDeep(essDataset);
        super.initHMV(formatTitle(edb_multi), getMyIcon(hclust_opt), essDataset, t_opt, hclust_opt);

        jbInit();
    }

    protected Hooks.Matrix getMyHook(final JTable rowTable,
                                     final JTable colTable,
                                     final VStackables.SampleAndTemplateLabels stl) {
        return new Hooks.Ess(fEdbMulti_synched, fDataset, fSampleAnnot, fTemplate_opt, rowTable, colTable, stl);
    }

    static Icon getMyIcon(final HClustDataset hclust_opt) {
        if (hclust_opt != null) {
            return ICON_HC;
        } else {
            return ICON;
        }
    }

    // each cell is an enrichment result
    public EnrichmentResult createEnrichmentResult(final int row, final int col) {

        /*
        String gsetName = fEssDataset.getRowName(row);
        String rlName = fEssDataset.getColumnName(col);
        
        RankedList rl = fRdb.getRankedList(rlName);
        GeneSet gset  = fGmx.getGeneSet(gsetName);

        KSCore core = new KSCore();
        core.calculate

        String name = row + "Rx" + col + "C";

        float es = fEssDataset.getElement(row, col);
        EnrichmentScore score = new EnrichmentScoreImpl(es, );

       // Template t = fTch.getComp(rlName).createTemplate()
        Template t = null;

       return new EnrichmentResultImpl(name, rl, t, gset, fChip, es, null);
       */

        return null;
    }

}        // End EnrichmentViewer
