package xapps.api.vtools.viewers;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

import edu.mit.broad.genome.JarResources;
import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.HClustDataset;
import edu.mit.broad.genome.objects.Template;
import xapps.api.vtools.Hooks;
import xapps.api.vtools.stackables.HStackables;
import xapps.api.vtools.stackables.StackablesManager;
import xapps.api.vtools.stackables.VStackables;

import javax.swing.*;
import java.awt.*;

/**
 * HeatMapViewer.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class HeatMapViewerSimple extends AbstractHeatMapViewer {

    public static final Icon ICON = JarResources.getIcon("HeatMap.gif");

    public static final Icon ICON_HC = JarResources.getIcon("Cdt.png");

    /**
     * Builds a Viewer on specified dataset object
     *
     * @param gset
     */
    public HeatMapViewerSimple(final Dataset ds) {
        this(ds, null, null);
    }

    /**
     * Class constructor
     *
     * @param ds
     * @param t_opt
     */
    public HeatMapViewerSimple(final Dataset ds,
                               final Template t_opt,
                               final HClustDataset hclust_opt) {
        super.initHMV(formatTitle(ds), getMyIcon(hclust_opt), ds, t_opt, hclust_opt);
        jbInit();
    }

    protected HStackables.FeatureAnnotComponentSimple createFeatureAnnotComponent(final Dataset ds) {
        return new HStackables.FeatureAnnotComponentSimple(ds);
    }

    protected StackablesManager.ToolBarMode getToolBarMode() {
        return StackablesManager.SIMPLE;
    }

    protected Hooks.Matrix getMyHook(JTable rowTable, JTable colTable, VStackables.SampleAndTemplateLabels stl) {
        return new Hooks.Gex(fDataset, fSampleAnnot, fTemplate_opt, rowTable, colTable, stl);
    }

    static Icon getMyIcon(final HClustDataset hclust_opt) {
        if (hclust_opt != null) {
            return ICON_HC;
        } else {
            return ICON;
        }
    }

    protected static Dimension getPlaceHolderSize() {
        return new Dimension(200, 50);
    }

} // End HeatMapViewer
