package xapps.api.vtools.viewers;

import edu.mit.broad.genome.XLogger;
import edu.mit.broad.xbench.heatmap.DisplayState;
import edu.mit.broad.xbench.heatmap.GramImager;
import edu.mit.broad.xbench.heatmap.GramImagerImpl;
import org.apache.log4j.Logger;
import org.genepattern.heatmap.ColorScheme;

/**
 * @author Aravind Subramanian
 *         Date: Dec 6, 2005
 *         Time: 6:24:29 PM
 */
public class VizFactory {

    private static final Logger klog = XLogger.getLogger(VizFactory.class);

    public static GramImager createGramImager(ColorScheme cs) {
        return new GramImagerImpl(new DisplayState(cs));
    }

    public static GramImager createGramImager() {
        return new GramImagerImpl();
    }

    public static GramImager createGramImager(final DisplayState ds) {
        return new GramImagerImpl(ds);
    }

} // End class VizFactory