package xapps.browser;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

import edu.mit.broad.genome.viewers.ReportViewer;
import edu.mit.broad.xbench.actions.WidgetAction;
import edu.mit.broad.xbench.core.Widget;
import edu.mit.broad.xbench.tui.ToolLauncher;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class MSigDBViewerAction extends WidgetAction {

    private MSigDBViewerContainer fViewerContainer;

    /**
     * Class constructor
     */
    public MSigDBViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }


    public Widget getWidget() {

        if (fViewerContainer == null) {
            fViewerContainer = new MSigDBViewerContainer();
        }

        return fViewerContainer;
    }


    public String getId() {
        return "MSigDBViewerAction";
    }

    public String getName() {
        return ToolLauncher.TITLE;
    }

    public Icon getIcon() {
        return ReportViewer.ICON;
    }

    public String getDescription() {
        return "Browse & search for gene sets in the Broad Institute Gene Sets Database (MSigDB)";
    }

}    // End MSigDBBrowserAction
