package xapps.gsea;

import com.jidesoft.comparator.ObjectComparatorManager;
import com.jidesoft.swing.SplashScreen;
import edu.mit.broad.genome.JarResources;
import edu.mit.broad.genome.XLogger;
import edu.mit.broad.xbench.ComparatorFactory2;
import org.apache.log4j.Logger;
import xapps.api.MostMain;

import javax.swing.*;

/**
 * @author Qing Xiong < qing.xiong@duke.edu >
 * Date: April, 2009
 *
 */
public class GsaaMain extends MostMain {

    private static final Logger klog = XLogger.getLogger(GsaaMain.class);

    /**
     * Class Constructor.
     */
    public GsaaMain() {

        super();

        super.setLnF();

        //boolean dosplash = edu.mit.broad.genome.Conf.doSplash();

        //boolean dosplash = true;
        boolean dosplash = false;

        if (dosplash) {
            ImageIcon splash = JarResources.getImageIcon("gsaa_splash.gif");
            SplashScreen.create(splash);
            SplashScreen.show(); // to show it
        }

        // start up the application

        final GsaaAppFrame frame = new GsaaAppFrame();

        if (dosplash) {
            try {
                frame.init_bg_while_splashing();

            } catch (Throwable t) {
                System.out.println("Error while initializing .., things may not work");
                t.printStackTrace();
            }
            SplashScreen.hide(); // to hide it
        }

        frame.makeVisible(true);

        // A global object that can register comparator with a type and a ComparatorContext.
        ObjectComparatorManager.registerComparator(Integer.class, new ComparatorFactory2.IntegerComparator());
        ObjectComparatorManager.registerComparator(Float.class, new ComparatorFactory2.FloatComparator());

    }

    /**
     * Main method to launch the Tools Desktop application
     *
     * @param args Ignored
     */
    public static void main(final String[] args) {
        try {
            new GsaaMain();
        } catch (Throwable e) {
            e.printStackTrace();
            klog.fatal("Could not create application", e);
        }
    }
}    // End GsaaMain

