/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xapps.gsea;

import edu.mit.broad.genome.NamingConventions;
import gnu.trove.THashSet;

import java.io.File;

/**
 * @author Aravind Subramanian
 *         Date: Dec 27, 2004
 *         Time: 11:57:54 PM
 */
public class GseaFileFilter extends javax.swing.filechooser.FileFilter {


    private THashSet fCustomExts;
    private String fDesc;

    /**
     * Class constructor
     *
     * @param customExts
     */
    public GseaFileFilter(String[] customExts, String desc) {
        this.fCustomExts = new THashSet();
        for (int i = 0; i < customExts.length; i++) {
            this.fCustomExts.add(customExts[i]);
            this.fCustomExts.add(customExts[i].toLowerCase());
            this.fCustomExts.add(customExts[i].toUpperCase());
        }

        this.fDesc = desc;
    }

    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String ext = NamingConventions.getExtension(f);
        return fCustomExts.contains(ext);
    }

    public String getDescription() {
        return fDesc;
    }

    public void setDescription(String s) {
        this.fDesc = s;
    }

}    // End class GseaFileFilter
