package xapps.gsea;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

import edu.mit.broad.genome.viewers.ReportViewer;
import edu.mit.broad.xbench.actions.WidgetAction;
import edu.mit.broad.xbench.core.Widget;
import edu.mit.broad.xbench.tui.ToolLauncher;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class LeadingEdgeReportAction extends WidgetAction {

    private LeadingEdgeReportViewer fViewer;

    /**
     * Class constructor
     */
    public LeadingEdgeReportAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }


    public Widget getWidget() {

        if (fViewer == null) {
            fViewer = new LeadingEdgeReportViewer();
        }

        return fViewer;
    }


    public String getId() {
        return "LeadingEdgeReportAction";
    }

    public String getName() {
        return ToolLauncher.TITLE;
    }

    public Icon getIcon() {
        return ReportViewer.ICON;
    }

    public String getDescription() {
        return "Run leading edge analysis to find shared signals amongst gene sets";
    }

}    // End LeadingEdgeReportAction
