package xexamples;


import edu.mit.broad.genome.utils.Timer;
import edu.mit.broad.vdb.VdbRuntimeResources;
import edu.mit.broad.vdb.chip.Chip;

/**
 * @author Aravind Subramanian
 *         Date: Feb 10, 2007
 *         Time: 9:17:22 PM
 */
public class CustomChipRepositoryExample {


    public static void main(String[] args) {

        try {

            // Note: (1) Because Chip objects are cached (i.e not re-read from source on each call)
            //           you must make this call first before any usage of Chip
            //       (2) The chip base path must end with "/" or "\"
            VdbRuntimeResources.setChipPathBase("/web/ftp/pub/gsea/annotations/"); // If you comment out this line, the Broad FTP site will be used

            Chip chip = VdbRuntimeResources.getChip_Gene_Symbol();

            System.out.println("Chip source path was: " + chip.getSourcePath());

            // We have not yet read in any data
            // Lets see how long it takes to read the file in (comment out the setChipPathBase above to comapre FTP load time)
            Timer timer = new Timer();
            timer.start();
            System.out.println("# features: " + chip.getNumProbes());
            timer.stop();
            timer.printTimeTaken_ms("Time taken: ");

        } catch (Throwable t) {
            t.printStackTrace();
        }

    }

}

