package xexamples;


import edu.mit.broad.genome.alg.GeneSetGenerators;
import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.genome.objects.GenesOfInterest;
import edu.mit.broad.genome.parsers.ParserFactory;
import edu.mit.broad.genome.utils.ColorUtils;

/**
 * @author Aravind Subramanian
 *         Date: Feb 10, 2007
 *         Time: 10:15:38 PM
 */
public class GinExample {

    public static void main(String[] args) {

        try {

            // (1) READ IN THE GENES OF INTEREST LISTS
            GenesOfInterest gin = ParserFactory.readGenesOfInterest("gsea.gin.xls", true);

            // (2) get the colors for each gene list
            for (int i = 0; i < gin.getNumGeneLists(); i++) {
                System.out.println(">> " + gin.getGeneList(i).getName() + " color:" + gin.getGeneList(i).getColor() + " hex: " + ColorUtils.toHex(gin.getGeneList(i).getColor()));
            }

            System.out.println("===============================\n\n");

            // (3) show me the intersections
            for (int i = 0; i < gin.getNumGeneLists(); i++) {
                GeneSet a = gin.getGeneList(i).toGeneSet();
                for (int j = 0; j < gin.getNumGeneLists(); j++) {
                    GeneSet b = gin.getGeneList(j).toGeneSet();
                    GeneSet common = GeneSetGenerators.createIntersectionGeneSet(a, b);
                    System.out.println("a: " + a.getName(true) + " b: " + b.getName(true) + " # common: " + common.getNumMembers());
                }
            }


        } catch (Throwable t) {
            t.printStackTrace();
        }

    }

}
