/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtest.api;


import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.genome.XLogger;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.apache.log4j.Logger;

import java.util.Iterator;


/**
 * need to use sytem properties as the testcase cnstructor that auto loaded
 * is only of the form super("name");
 * <p/>
 * <p/>
 * Hints for writing tests:
 * (iunlucde my junit ideoms thing here)
 * http://www.javaworld.com/javaworld/jw-12-2000/jw-1221-junit.html
 * <p/>
 * if an uncaught exception occurs -> junit calls it an error
 * if an assert fails junit clals it a failure
 * <p/>
 * - name the test case class FooTest and the methids in it testSomeThing
 * <p/>
 * The adv of using the text test runnner is that uou can click onthe
 * exception oand got to the offending line in the source.
 * <p/>
 * To init class vars do it in  setUp rathrth than in the class constrrucrtor
 * as a better exception messge is got - read the javaworld article.
 * <p/>
 * TODO chnge the i desc - dont use the system.getproperty things.
 * <p/>
 * The advantage in thei is that any tewtclasses added to a package are auto added
 * to the test all suite and no need to manually update
 * <p/>
 * Test suite for the entire Java implementation. Runs
 * all Java test cases in the source tree that extend TestCase and are of a specified type.
 * The following system properties must be set:
 * <ul>
 * <li><code>class_root</code>: Directory containing classes. e.g /product/classes
 * <li><code>test_type</code>: Type of test case to load. All test cases with public static final String TEST_ALL_TEST_TYPE defined
 * to match the value of <code>test_type</code> will be loaded.
 * <li><code>package_root</code>: Where to start looking for packages within the package tree. e.g. com.company.app.sub1 will only run tests in package com.company.app.sub1 or below.
 * </ul>
 *
 * @author Andy Schneider (javaworld)
 * @author (forxomics) Aravind Subramanian
 * @version %I%, %G%
 * @todo list all test that were successfully run - not just the errors
 * @todo Get this to work from the test runner vdbgui
 * @todo Make the swing vdbgui testruner print to stdout exceptions. Helpful because can then
 * click on an exception stack trace line an go to source. (else stuff is presented
 * only in the vdbgui's text fields and not linked to source).
 * @see http://www.javaworld.com/javaworld/jw-12-2000/jw-1221-junit.html
 */
public class TestAll extends TestCase {

    private static final Logger klog = XLogger.getLogger(TestAll.class);

    /**
     * system properties that control the test class search behavior
     */
    public static final String TEST_CLASS_ROOT = "test_class_root";
    public static final String TEST_PACKAGE_ROOT = "test_package_root";
    public static final String TEST_TYPE = "test_type";

    /**
     * Basic constructor - called by the test runners.
     * This is whgy we cant have other forms of the constructor and neede to use
     * sustem.getproperties to toggle behaviour
     */
    public TestAll(String name) {
        super(name);
    }

    /**
     * Dynamically create a test suite from a set of class files in a directory tree,
     * based on system propertie set.
     */
    public static Test suite() throws Throwable {
        throw new NotImplementedException();
    }

    // need this annoying if else construct as the system property can only be a string
    // and the sytem property mechanism is used because of the test runner requirements (see above)
    private static TestType getTestType() {

        String s = System.getProperty(TEST_TYPE);

        if (s == null) {
            throw new NullPointerException("System property " + TEST_TYPE + " must be set.");
        }

        return TestType.getTestType(s);
    }

    /**
     * Iterates over the classes accessible via the iterator and adds them to the test suite.
     */
    private static int addAllTests(final TestSuite suite, final Iterator classIterator) {

        int testClassCount = 0;

        /*
        while(classIterator.hasNext()) {
            Class testCaseClass = (Class) classIterator.next();

            try {
                Method               suiteMethod = testCaseClass.getMethod("suite", new Class[0]);
                junit.framework.Test test        = (junit.framework.Test) suiteMethod.invoke(null,
                                                       new Class[0]);    // static method

                suite.addTest(test);
            } catch(NoSuchMethodException e) {
                suite.addTest(new TestSuite(testCaseClass));
            } catch(Exception e) {
                System.err.println("Failed to execute suite ()");
                e.printStackTrace();
            }

            System.out.println("Loaded test case: " + testCaseClass.getName());

            testClassCount++;
        }
        */

        return testClassCount;
    }
}

/*
       TestCaseLoader tcl = new TestCaseLoader(type);
       tcl.loadTestCases(finder.getClasses());
       fSuite = new TestSuite();
       int numberOfTests = addAllTests(fSuite, tcl.getClasses ());
       log.info("Number of test classes found: " + numberOfTests);

       System.out.println("fSuite = " + fSuite);
       return fSuite;
       */

/**
 * Class Constructor.
 * Creates a junit TestSuite with all testCases found in the
 * specified location that belong to the specified package.
 */
/*
public TestAll(TestType type, final File classPathRoot, final Package pkg)  throws IOException {
    this(type, new ClassFinder(classPathRoot, pkg));
}
*/
/**
 * Class Constructor.
 * Creates a junit TestSuite with all testCases found in the
 * specified location.
 */
/*
public TestAll(TestType type, final File classPathRoot)  throws IOException {
    this(type, new ClassFinder(classPathRoot));
}
*/

/**
 * Class Constructor.
 * Creates a junit TestSuite with all testCases found in the
 * specified ClassFinder.
 */
/*
public TestAll(TestType type, ClassFinder finder) throws IOException {
    super("lll");
    TestCaseLoader tcl = new TestCaseLoader(type);
    tcl.loadTestCases(finder.getClasses());
    fSuite = new TestSuite();
    int numberOfTests = addAllTests(fSuite, tcl.getClasses ());
    log.info("Number of test classes found: " + numberOfTests);
}
*/

/*

  TestSuite suite = new TestSuite();
        suite.addTest(MiscTest.suite());
        suite.addTest(CollectionUtilsTest.suite());
        suite.addTest(ParseUtilsTest.suite());
        //junit.textui.TestRunner.run(suite());
        //runner.setSuite(suite.getClass().toString());
        //runner.setSuite("edu.mit.broad.xtest.junit.MiscTest.suite()");
        //runner.runSuite();

        int numb = suite.countTestCases();

        System.out.println("Number of test " + numb);

        Enumeration enum = suite.tests();
        ArrayList al = new ArrayList();
        // Hmm is there a better way to convert an enum to an array?
        while (enum.hasMoreElements()) {
            al.add(enum.nextElement().toString());
        }
        System.out.println("al=" + al);
        String[] tests = (String[])al.toArray(new String[al.size()]);

        for (int i=0; i < tests.length; i++) {
            System.out.println("to run > " + tests[i]);
        }



        TestSuite ts;
        ts.tests();
        TestCase tc;
        tc.




        //runner.start(tests);
        //runner.main(tests);
        //runner.run(MiscTest.class);
        enum = suite.tests();
        while (enum.hasMoreElements()) {
            runner.run(enum.nextElement().getClass());
        }
        */

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
