package xtest.api;

import edu.mit.broad.genome.XLogger;
import junit.framework.Test;
import junit.framework.TestResult;
import junit.runner.BaseTestRunner;
import org.apache.log4j.Logger;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author Aravind Subramanian
 *         Date: Nov 8, 2005
 *         Time: 4:43:02 PM
 */
public class TestSimpleUI extends BaseTestRunner {

    private Logger log = XLogger.getLogger(TestSimpleUI.class);

    public void testStarted(java.lang.String pmid) {
        System.out.println("testStarted: " + pmid);
    }

    public void testEnded(java.lang.String pmid) {
        System.out.println("testEnded: " + pmid);
    }

    public void testFailed(int i, junit.framework.Test test, java.lang.Throwable throwable) {
        System.out.println("testFailed: " + test + " " + throwable);
    }

    protected void runFailed(java.lang.String pmid) {
        System.out.println("runFailed: " + pmid);
    }

    public TestSimpleUI() {

        JFrame frame = new JFrame();

        JButton but = createRunButton();

        frame.add(but);
        frame.pack();
        frame.setVisible(true);

    }

    protected JButton createRunButton() {
        JButton run = new JButton("Run");
        run.setEnabled(true);
        run.addActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        runSuite();
                    }
                }
        );
        return run;
    }


    synchronized public void runSuite() {
        //setLoading(true);
        //reset();
        //showInfo("Load Test Case...");
        /*
        final String suiteName = "xtest.xbench.XBenchTest";
        System.out.println(">>> suiteName: " + suiteName);
        final junit.framework.Test testSuite = getTest(suiteName);
        System.out.println("testSuite: " + testSuite);
        if (testSuite != null) {
            doRunTest(testSuite);
        }

        */
    }


    private void start(final Test test) {
        SwingUtilities.invokeLater(
                new Runnable() {
                    public void run() {
                        int total = test.countTestCases();
                        //fProgressIndicator.start(total);
                        //fCounterPanel.setTotal(total);
                    }
                }
        );
    }

    /*
     private void doRunTest(final Test testSuite) {
        setButtonLabel(fRun, "Stop");
        fRunner = new Thread("TestRunner-Thread") {
            public void run() {
                TestRunnerAS.this.start(testSuite);
                postInfo("Running...");

                long startTime = System.currentTimeMillis();
                testSuite.run(fTestResult);

                if (fTestResult.shouldStop()) {
                    postStatus("Stopped");
                } else {
                    long endTime = System.currentTimeMillis();
                    long runTime = endTime - startTime;
                    postInfo("Finished: " + elapsedTimeAsString(runTime) + " seconds");
                }

                runFinished(testSuite);
                setButtonLabel(fRun, "Run");
                fRunner = null;
                System.gc();
            }
        };
        // make sure that the test result is created before we start the
        // test runner thread so that listeners can register for it.
        fTestResult = createTestResult();
        fTestResult.addListener(TestRunnerAS.this);
        //aboutToStart(testSuite);

        fRunner.start();
    }
    */

    private TestResult fTestResult = new TestResult();

    Thread fRunner;

    private void doRunTest(final junit.framework.Test testSuite) {
        fRunner = new Thread("TestRunner-Thread") {
            public void run() {
                TestSimpleUI.this.start(testSuite);
                log.debug("doRunTest running: " + testSuite);
                //postInfo("Running...");


                long startTime = System.currentTimeMillis();
                testSuite.run(fTestResult);

                if (fTestResult.shouldStop()) {
                    log.debug("STOPPED");
                    //postStatus("Stopped");
                } else {
                    long endTime = System.currentTimeMillis();
                    long runTime = endTime - startTime;
                    log.debug("Finished: " + elapsedTimeAsString(runTime) + " seconds");
                }

                //runFinished(testSuite);
                //setButtonLabel(fRun, "Run");
                fRunner = null;
            }
        };
        // make sure that the test result is created before we start the
        // test runner thread so that listeners can register for it.
        //fTestResult = createTestResult();
        //fTestResult.addListener(TestRunnerAS.this);
        //aboutToStart(testSuite);

        fRunner.start();
    }

    public static void main(final String[] args) {

        try {
            new TestSimpleUI();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
