/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtest.api;


import edu.mit.broad.genome.XLogger;
import edu.mit.broad.genome.utils.Timer;
import junit.framework.TestCase;
import org.apache.log4j.Logger;


/**
 * Class UnitTest
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class UnitTest extends TestCase {

    /**
     * For logging support
     */
    protected final Logger log;

    /**
     * Tags this class for TestAll
     */
    public static final TestType TEST_ALL_TEST_TYPE = TestType.UNIT;
    protected Test fTest;
    protected final TestConf fConf;
    protected final Timer fTimer;

    /**
     * Class Constructor.
     */
    public UnitTest(String name) {

        super(name);

        log = XLogger.getLogger(this.getClass());
        fConf = ConfImpl.DEFAULT;
        fTimer = new Timer();
    }

    /**
     * Subclasses that override this method should make sure to call
     * <code>super.setUp()</code>
     * Also, its better to place any TestCase initialization in setUp() rather than
     * in the TestCase class constructor.
     * Initialization is done to teh default set of Test configuration.
     * Subclasses can redefine fConf (in their constructor) to initialize to
     * a different test configuration.
     */
    public void setUp() throws Exception {

        assertNotNull("Could not initialize TestConf properly -- fConf is null", fConf);

        fTest = new xtest.api.Test(fConf);

        assertNotNull("Could not initialize Test properly -- fTest is null", fTest);
    }

    public void testToAvoidANoTestFoundErrorOnRunningUnitTest() {
    }
}    // End UnitTest

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
