/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * For interactive command-line input
 * Mimics the ReadLine capability of perl-scripts
 *
 * @author Original code form http://www.devdaily.com/java/edu/pj/pj010005/index.shtml
 * @author Aravind Subramanian
 * @version %I%, %G%
 */

public class ReadLine {

    public static final String YES = "yes";
    public static final String Y = "y";

    private ReadLine() {
    }

    public static boolean proceed(String question) throws IOException {

        System.out.println(question);
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        String ans = br.readLine();
        if ((ans != null) && ((ans.equalsIgnoreCase(YES)) || (ans.equalsIgnoreCase(Y)))) {
            return true;
        }

        System.out.println("aborting ...");
        return false;

    }

    public static String ask(String question) throws IOException {

        System.out.print(question);

        //  open up standard input
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

        StringBuffer ans = null;

        //  read the username from the command-line; need to use try/catch with the
        //  readLine() method

        String line = br.readLine();
        if (line == null) {
            return ans.toString();
        }

        while (line != null) {
            line = line.trim();
            ans.append(line);
            line = br.readLine();
        }

        br.close();
        return ans.toString();

    }

}  // end of ReadString class
