/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api;


import edu.mit.broad.genome.JarResources;
import edu.mit.broad.genome.reports.api.Report;
import xtools.api.param.ParamSet;

import javax.swing.*;
import java.io.PrintStream;
import java.io.Serializable;

/**
 * <p> </p>
 * <p> </p>
 * <p> </p>
 * <p> </p>
 * <p/>
 * IMP IMP keep this junit linkage safe
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public interface Tool extends Serializable {

    public static final Icon ICON = JarResources.getIcon("Tool16.gif");

    public String getHelpURL();

    /**
     * @return The name of this Tool
     */
    public String getName();

    public String getTitle();

    /**
     * @return A short description of this tool
     */
    public String getDesc();

    /**
     * @return The category that this tool belongs to
     */
    public ToolCategory getCategory();

    /**
     * @return ParamSet that this tools accepts/needs to execute
     */
    public ParamSet getParamSet();

    /**
     * State the Param (reqd and opt) that the Tool uses.
     */
    public void declareParams();

    /**
     * Actually run the Tool
     */
    public void execute() throws Exception;

    /**
     * Retrieve reports of results of execution of the tool.
     * The Report may have nothing in it but canNOT be null
     */
    public Report getReport();

    // in millisecs
    public long getExecutionTime();

    public long getStartTime();

    public long getStopTime();

    /**
     * Print to System.out a summary of the parameters
     * and usage hints for this Tool.
     */
    public void printfUsage();

    public void requestKill();

    public void setOutputStream(final PrintStream sout);

}    // End Tool

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
