/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api;


import edu.mit.broad.xbench.core.api.Application;
import xtest.api.Test;
import xtest.api.TestConf;

import java.io.File;


/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @maint A bunch of file paths and names defined here.
 * No real way to ensure that the files are really there.
 * Intended as a mechanism to keep all the file name / path gunk
 * needed for tests in one place.
 * <p/>
 * Basically adds methods to xtest.api.Test
 * <p/>
 * Mostly more data that is helpful / specific to Tools
 */
public class ToolTest extends Test {

    private static final File kDataDir = Application.getVdbManager().getTmpDir();

    private static final File kBioc = new File(kDataDir, "bioc");

    public static File getBiocDir() {
        return kBioc;
    }

    /**
     * Class constructor
     *
     * @param conf
     * @throws Exception
     */
    public ToolTest(TestConf conf) {
        super(conf);
    }

    /**
     * shared (and complete 600 gene) dataset
     */
    /*
    public static Ffn getPabloArtificialCohorts_type1() throws Exception {

        Dataset ds = ParserFactory.readDataset((new File(kDataDir,
                                                         "pablos_artificial_dataset1.res")), true);
        List orders = new ArrayList(6);

        orders.add(new int[]{8, 52});
        orders.add(new int[]{8, 12, 40});
        orders.add(new int[]{20, 10, 30});

        //orders.add(new int[]{30, 15, 15});
        //orders.add(new int[]{45, 5, 10});
        //orders.add(new int[]{50, 10});
        Template[] templates = TemplateFactory.createBiphasicTemplates(orders);

        return Ffn.createFfn("pablos_artificial_dataset1.ffn", ds, templates);
    }
    */

    /**
     * portioned dataset
     * <p/>
     * everything v/s random one
     * <p/>
     * dataset, cls and fset
     *
     * @return
     * @throws Exception dataset, cls and fset
     * @throws Exception everything v/s random one
     *                   <p/>
     *                   dataset, cls and fset
     * @throws Exception dataset, cls and fset
     * @throws Exception everything v/s random one
     *                   <p/>
     *                   dataset, cls and fset
     * @throws Exception dataset, cls and fset
     * @throws Exception everything v/s random one
     *                   <p/>
     *                   dataset, cls and fset
     * @throws Exception dataset, cls and fset
     * @throws Exception
     */
    /*
    public static Ffn getPabloArtificialCohorts_type2() throws Exception {
        Dataset ds = ParserFactory.readDataset(new File(kDataDir,
                                                        "pablos_artificial_dataset1.res"), true);
        List orders = new ArrayList(6);

        orders.add(new int[]{8, 52});
        orders.add(new int[]{8, 12, 40});
        orders.add(new int[]{20, 10, 30});
        orders.add(new int[]{30, 15, 15});
        orders.add(new int[]{45, 5, 10});
        orders.add(new int[]{50, 10});

        Template[] templates = TemplateFactory.createBiphasicTemplates(orders);
        Dataset[] dss = new Dataset[6];

        dss[0] = new DefaultDataset("junk", 0, 49, ds);
        dss[1] = new DefaultDataset("junk", 50, 99, ds);
        dss[2] = new DefaultDataset("junk", 100, 149, ds);
        dss[3] = new DefaultDataset("junk", 150, 199, ds);
        dss[4] = new DefaultDataset("junk", 200, 249, ds);
        dss[5] = new DefaultDataset("junk", 250, 299, ds);

        Printf.out(templates[0]);
        Printf.out(templates[1]);
        Printf.out(templates[2]);
        Printf.out(dss[2]);



        return null;

        //return ffn;
    }
    */

    /**
     * everything v/s random one
     * <p/>
     * dataset, cls and fset
     *
     * @return
     * @throws Exception dataset, cls and fset
     * @throws Exception
     */
    /*
    public static Ffn getPabloArtificialCohorts_type3() throws Exception {

        Dataset ds = ParserFactory.readDataset(new File(kDataDir,
                                                        "pablos_artificial_dataset1.res"), true);
        List orders = new ArrayList(6);

        orders.add(new int[]{8, 52});
        orders.add(new int[]{8, 12, 40});
        orders.add(new int[]{20, 10, 30});
        orders.add(new int[]{30, 15, 15});
        orders.add(new int[]{45, 5, 10});
        orders.add(new int[]{50, 10});

        Template[] templates = TemplateFactory.createBiphasicTemplates(orders);
        Dataset[] dss = new Dataset[6];
        Dataset rnd = new DefaultDataset("junk", 300, 349, ds);

        Printf.out(templates[0]);
        Printf.out(templates[1]);
        Printf.out(templates[2]);
        Printf.out(dss[2]);


        return null;
    }
    */
    public static File getBiocHgu133a() {
        return new File(kBioc, "hgu133a.xml");
    }

}    // End ToolTest

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
