package xtools.api.param;


import edu.mit.broad.vdb.chip.Chip;
import edu.mit.broad.vdb.chip.ChipHelper;


/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the chpices are presented in a JListWindow and not
 * in a text area
 */
public class ChipChooserMultiParam extends WChipChooserAbstractParam implements IChipParam {

    /**
     * @param name
     * @param desc
     * @param reqd
     */
    public ChipChooserMultiParam(String name, String nameEnglish, String desc, boolean reqd) {
        super(name, nameEnglish, desc, reqd, true);
    }

    public ChipChooserMultiParam(boolean reqd) {
        this(CHIP, CHIP_ENGLISH_MULTI, CHIP_DESC_MULTI, reqd);
    }

    public ChipChooserMultiParam(String name, boolean reqd) {
        this(name, CHIP_ENGLISH_MULTI, CHIP_DESC_MULTI, reqd);
    }

    public Chip[] getChips() throws Exception {
        return super._getChips();
    }

    public String getChipNames() throws Exception {
        Chip[] chips = getChips();
        if (chips.length == 1) {
            return chips[0].getName();
        } else {
            StringBuffer buf = new StringBuffer();
            for (int c = 0; c < chips.length; c++) {
                buf.append(chips[c].getName());
                if (c != chips.length - 1) {
                    buf.append('_');
                }
            }

            return buf.toString();
        }

    }

    public Chip getChipCombo() throws Exception {
        Chip[] chips = getChips();

        // not sure why the chips.lemtgh == 0 check is needed - should this be generically caught?
        // see Probes2Symbol for an example of how this method fails (on no chip specified) if not checked in this manner
        if (isReqd() && chips.length == 0) {
            throw new IllegalArgumentException("Chips must be specified");
        }

        return ChipHelper.createComboChip(chips);
    }


    public Chip getChip(int pos) {

        Object val = super.getValue();

        if (val == null) {
            throw new NullPointerException("Null param value. Always check isSpecified() before calling");
        }

        return ((Chip[]) val)[pos];
    }

}    // End class ChipsChooserParam

