/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


/**
 *
 */
public class ChipComboModeReqdParam extends StringReqdParam {

    public static final String SEPARATE = "Process_Independently_for_Every_Selected_Chip";

    public static final String COMBO = "Combine_Selected_Chips_into_One_Big_Virtual_Chip";

    public static final String[] ALL = new String[]{SEPARATE, COMBO};

    /**
     * Class constructor
     *
     * @param reqd
     */
    public ChipComboModeReqdParam() {
        super(CHIPCOMBOTYPE, CHIPCOMBOTYPE_ENGLISH, CHIPCOMBOTYPE_DESC, ALL);
    }

    public boolean isSeparate() {
        return getString().equals(SEPARATE);
    }

    public boolean isCombo() {
        return getString().equals(COMBO);
    }

    public boolean isFileBased() {
        return false;
    }

} // End class MdbSearchTypeParam
