package xtools.api.param;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */


/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class ClusterAxisParam extends StringOptParam {


    private static String[] MODES = new String[]{
            "rows",
            "columns",
            "both"
    };

    public ClusterAxisParam() {
        super("axis", "Cluster axis",
                "Cluster axis",
                MODES[2], // both
                MODES,
                false
        );
    }
    /*
   public final static int ROWS = 0;

public final static int BOTH = 2;

public final static int COLUMNS = 1;
    */


    public String getMode() {
        return super.getString(0);
    }

    public int getModeIndex() {
        return super.getSpecifiedPositions()[0];
    }

    public boolean isOnlyGenes() {
        return getModeIndex() == 0;
    }

    public boolean isBoth() {
        return getModeIndex() == 2;
    }

    public boolean isOnlySamples() {
        return getModeIndex() == 1;
    }

}    // End class ClusterAxisParam
