package xtools.api.param;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */


/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class ClusterDistanceParam extends StringOptParam {

    private static String[] MODES = new String[]{
            "euclidean",
            "cosine",
            "correlation"
    };

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public ClusterDistanceParam() {
        super("distance", "Distance metric",
                "Distance metric",
                MODES[2], // corr
                MODES,
                false
        );
    }

    public String getMode() {
        return super.getString(0);
    }

    public int getModeIndex() {
        return super.getSpecifiedPositions()[0];
    }

}    // End class ClusterDistance
