package xtools.api.param;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */


import edu.mit.broad.genome.parsers.DataFormat;
import edu.mit.broad.genome.swing.fields.GComboBoxField;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public abstract class DataFormatAbstractParam extends AbstractParam implements DataFormatChooser, ActionListener {

    private GComboBoxField cbOptions;

    /**
     * Class constructor
     *
     * @param def
     * @param reqd
     */
    public DataFormatAbstractParam(String name, String nameEnglish, String desc, DataFormat def, DataFormat[] hints, boolean reqd) {
        super(name, nameEnglish, DataFormat.class, desc,
                def, hints, reqd);
    }

    public DataFormatAbstractParam(String name, String desc, DataFormat def, DataFormat[] hints, boolean reqd) {
        super(name, DataFormat.class, desc,
                def, hints, reqd);
    }

    public void setValue(Object value) {

        if (value == null) {
            super.setValue(null);
        } else {
            super.setValue(DataFormat.getExtension(value));
        }
    }

    public void setValue(DataFormat df) {
        super.setValue(df);
    }

    public boolean isFileBased() {
        return false;
    }

    public DataFormat getDataFormat() {

        Object val = super.getValue();

        if (val == null) {
            return (DataFormat) getDefault(); // @note
        } else {
            return (DataFormat) val;
        }
    }


    public GFieldPlusChooser getSelectionComponent() {

        if (cbOptions == null) {
            cbOptions = ParamHelper.createActionListenerBoundHintsComboBox(false, this, this);
            ParamHelper.safeSelectValueDefaultByString(cbOptions.getComboBox(), this);
        }

        return cbOptions;

    }

    public void actionPerformed(ActionEvent evt) {
        this.setValue((DataFormat) ((JComboBox) cbOptions.getComponent()).getSelectedItem());
    }


}    // End class AbstractDataFormatParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
