/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.objects.Dataframe;
import edu.mit.broad.genome.objects.StringDataframe;
import edu.mit.broad.genome.parsers.ParserFactory;

/**
 * @author Aravind Subramanian
 *         Date: Apr 20, 2004
 *         Time: 7:48:10 PM
 */
public class DataframeFileParam extends FileParam {
    // @todo improve the abstraction of idf/sdf/df
    public DataframeFileParam(boolean reqd) {
        super(DF_FILE, DF_FILE_DESC, DF_FILE_DESC, reqd);
    }

    public DataframeFileParam(String name, String nameEnglish, String desc, boolean reqd) {
        super(name, nameEnglish, desc, reqd);
    }

    public StringDataframe getSdf() throws Exception {
        return ParserFactory.readStringDataframe(super.getFile(), true);
    }

    /* @todo
    public IDataframe getIdf() throws Exception {
        return ParserFactory.readStringDataframe(super.getFile(), true);
    }
    */

    public Dataframe getDf() throws Exception {
        return ParserFactory.readDataframe(super.getFile(), true);
    }

}
