package xtools.api.param;

import edu.mit.broad.genome.objects.Dataframe;
import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.PersistentObject;
import edu.mit.broad.genome.parsers.ParserFactory;

import java.awt.event.ActionListener;
import java.io.File;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class DataframeOptParam extends PobParam implements ActionListener {

    /**
     * Class constructor
     */
    public DataframeOptParam() {
        this(DF, DF_DESC, false);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public DataframeOptParam(String name, String desc, boolean reqd) {
        super(name, Dataframe.class, desc, new Dataframe[]{}, reqd);
    }

    public void setValue(Dataframe df) {
        super.setValue(df);
    }

    public Dataframe getDataframe() throws Exception {
        return (Dataframe) getPob();
    }

    public Dataset getDataset() throws Exception {
        return getDataframe().toDataset(true);
    }

    protected PersistentObject getPob() throws Exception {
        /*
        if (getValue() != null) {
            log.debug("Value = " + getValue() + " class: " + getValue().getClass());
        }
        */

        Object val = getValue();

        // @note added march 2006
        if (val instanceof Object[] && ((Object[]) val).length == 1) {
            val = ((Object[]) val)[0];
        }


        if (val == null) {
            throw new NullPointerException("Null param value. Always check isSpecified() before calling");
        } else if (val instanceof PersistentObject) {
            return (PersistentObject) val;
        } else if (val instanceof File) {
            return ParserFactory.readDataframe((File) val, true); // @note explicit df call
        } else {
            throw new RuntimeException("Unexpected value >" + val + "< of class: " + val.getClass() + " for param: " + getName());
        }

    }


}    // End class DataframeOptParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
