/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.PersistentObject;


/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the choices are presented in a JListWindow and not
 * in a text area
 */
abstract class DatasetChooserAbstractParam extends AbstractPobChooserParam {

    DatasetChooserAbstractParam(String name, String desc, boolean reqd, boolean multipleAlllowed) {
        super(name, desc, Dataset[].class, Dataset.class, new Dataset[]{}, new Dataset[]{}, reqd, multipleAlllowed);
    }

    public void setValue(Dataset[] dss) {
        super.setValue(dss);
    }

    public void setValue(Dataset ds) {
        super.setValue(new Dataset[]{ds});
    }

    protected Dataset[] _getDatasets() throws Exception {

        PersistentObject[] pobs = (PersistentObject[]) getValue();
        Dataset[] dss = new Dataset[pobs.length];

        for (int i = 0; i < pobs.length; i++) {
            log.debug(pobs[i].getClass());
            dss[i] = (Dataset) pobs[i];
        }

        return dss;
    }

}    // End class AbstractDatasetChooserParam



