/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.objects.strucs.DatasetTemplate;
import edu.mit.broad.genome.parsers.ParseUtils;

import java.io.File;


/**
 * entry 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @imp enters in a text are not a list chooser
 */
public class DatasetTemplateFileParam extends FileParam {

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public DatasetTemplateFileParam(String name, String nameEnglish, String desc, boolean reqd) {
        super(name, nameEnglish, desc, new File[]{}, reqd);
    }

    public DatasetTemplateFileParam(boolean reqd) {
        super(DT_FILE, DT_FILE_DESC, DT_FILE_ENGLISH, new File[]{}, reqd);
    }

    public DatasetTemplate[] getDatasetTemplates(boolean add2cache) throws Exception {
        final String[] dssTssFilePaths = getStrings();

        DatasetTemplate[] dts = new DatasetTemplate[dssTssFilePaths.length];
        for (int i = 0; i < dssTssFilePaths.length; i++) {
            String[] ss = ParseUtils.string2strings(dssTssFilePaths[i], false);
            dts[i] = new DatasetTemplate(new File(ss[0]), new File(ss[1]), add2cache);
        }

        return dts;
    }

}    // End class DatasetTemplateFileParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
