package xtools.api.param;

import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class FeatureSpaceReqdParam extends StringReqdParam implements ActionListener {

    //private static String[] MODES = new String[]{"gene_symbols", "native"};
    private static String[] MODES = new String[]{"true", "false"};

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public FeatureSpaceReqdParam() {
        super(FEATURE_SPACE, FEATURE_SPACE_ENGLISH, FEATURE_SPACE_DESC, MODES[0], MODES);
    }

    public boolean isSymbols() {
        int index = getStringIndexChoosen();
        if (index == 0) {
            return true;
        } else {
            return false;
        }
    }

    public boolean isNative() {
        int index = getStringIndexChoosen();
        if (index == 1) {
            return true;
        } else {
            return false;
        }
    }


    public GFieldPlusChooser getSelectionComponent() {

        if (cbOptions == null) {

            cbOptions = ParamHelper.createActionListenerBoundHintsComboBox(false, this, this);
            ParamHelper.safeSelectValueDefaultByString(cbOptions.getComboBox(), this);
            cbOptions.getComboBox().setRenderer(new MyListRenderer());
        }

        return cbOptions;

    }

    public static class MyListRenderer extends DefaultListCellRenderer {

        public Component getListCellRendererComponent(JList list, Object value, int index,
                                                      boolean isSelected, boolean cellHasFocus) {

            // doesnt work properly unless called
            super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);

            //System.out.println("index=" + index);

            if (index == 0) {
                //this.setText("foo");
                this.setText(MODES[0] + " (use 'chip' to collapse gene expression dataset to symbols before analysis)");
            } else if (index == 1) {
                //this.setText("bar");
                this.setText(MODES[1] + " (use gene expression dataset 'as is' in the original format)");
            } // @note IMP to do specifically for 0 and 1 sometimes gets -1

            return this;
        }
    }    // End CommonLookListRenderer


}    // End class FeatureSpaceReqdParam
