/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import java.io.File;

/**
 * @author Aravind Subramanian
 *         Date: Feb 1, 2005
 *         Time: 8:30:39 AM
 */
public class FilesParam extends StringMultiInputParam {

    public FilesParam(boolean reqd) {
        this(FILES, FILES_ENGLISH, FILES_DESC, reqd);
    }

    public FilesParam(final String name, final String nameEnglish, final String desc, final boolean reqd) {
        super(name, nameEnglish, desc, new String[]{}, reqd);
    }

    public File[] getFiles(boolean barfOnMissing) {
        String[] paths = super.getStrings();
        File[] files = new File[paths.length];

        for (int i = 0; i < paths.length; i++) {
            files[i] = new File(paths[i]);
            if (barfOnMissing && files[i].exists() == false) {
                throw new IllegalArgumentException("Path specified does not exist: " + paths[i]);
            }
        }

        return files;
    }

} // End class FilesParam

