/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.objects.DefaultGeneSetMatrix;
import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.genome.objects.GeneSetMatrix;


/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the chpices are presented in a JListWindow and not
 * in a text area
 */
public class GeneSetMatrixMultiChooserParam extends GeneSetMatrixChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param nameEnglish
     * @param desc
     * @param reqd
     */
    public GeneSetMatrixMultiChooserParam(String name, String nameEnglish, String desc, boolean reqd) {
        super(name, nameEnglish, desc, reqd, true, true);
    }

    public GeneSetMatrixMultiChooserParam(String name, boolean reqd) {
        this(name, GMX_ENGLISH, GMX_DESC_MULTI, true, reqd, true);
    }

    public GeneSetMatrixMultiChooserParam(String name, String nameEnglish, String desc, boolean multiAlowed, boolean reqd, boolean includeGmx) {
        super(name, nameEnglish, desc, reqd, multiAlowed, includeGmx);
    }

    public GeneSetMatrixMultiChooserParam(boolean reqd) {
        this(GMX, GMX_ENGLISH, GMX_DESC_MULTI, reqd);
    }

    public GeneSetMatrixMultiChooserParam(boolean reqd, boolean multiAlowed, boolean includeGmx) {
        this(GMX, GMX_ENGLISH, GMX_DESC_MULTI, reqd, multiAlowed, includeGmx);
    }

    public GeneSetMatrix[] getGeneMatrices() throws Exception {
        return super._getGeneSetMatrices();
    }

    public GeneSetMatrix getGeneSetMatrix(final StringMultiInputParam smip) throws Exception {
        GeneSetMatrix gm = getGeneSetMatrixCombo(true);

        if (smip.isSpecified()) {
            GeneSet[] gsets = gm.getGeneSets(smip.getStringsS());
            return new DefaultGeneSetMatrix(gm.getName() + "_" + gsets.length, gsets);
        } else {
            return gm;
        }
    }

}    // End class GeneSetMatrixCombiner
