/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.objects.GeneSetMatrix;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class GeneSetMatrixOptParam extends GeneSetMatrixChooserAbstractParam {

    public GeneSetMatrixOptParam(String name, String nameEnglish, String desc) {
        super(name, nameEnglish, desc, false, false, true);
    }

    public GeneSetMatrixOptParam(String name) {
        this(name, GMX_ENGLISH, GMX_DESC);
    }

    public GeneSetMatrixOptParam() {
        this(GMX);
    }

    public GeneSetMatrix getGeneSetMatrix() throws Exception {
        GeneSetMatrix[] gmxs = super._getGeneSetMatrices();
        if (gmxs.length > 1) {
            throw new IllegalStateException("Prog error only 1 expected. got: " + gmxs.length);
        }

        return gmxs[0];
    }

}    // End class GeneSetMatrixOptParam
