/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.FSet;
import edu.mit.broad.genome.objects.GeneSet;

import java.util.HashSet;
import java.util.Set;

/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the chpices are presented in a JListWindow and not
 * in a text area
 */
public class GeneSetMultiChooserParam extends GeneSetChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param nameEnglish
     * @param desc
     */
    public GeneSetMultiChooserParam(String name, String nameEnglish, String desc) {
        super(name, nameEnglish, desc, false, true);
    }

    public GeneSetMultiChooserParam(String name) {
        this(name, GRP_ENGLISH, GRP_DESC);
    }

    public GeneSetMultiChooserParam() {
        this(GRP, GRP_ENGLISH, GRP_DESC);
    }

    public GeneSet[] getGeneSets() throws Exception {
        return super._getGeneSets();
    }

    public GeneSet getGeneSetCombo() throws Exception {
        GeneSet[] gsets = getGeneSets();
        Set all = new HashSet();
        for (int i = 0; i < gsets.length; i++) {
            all.addAll(gsets[i].getMembersS());
        }

        return new FSet("combo", all);
    }

    public GeneSet[] getGeneSets(Dataset restrict2Dataset) throws Exception {
        GeneSet[] gsets = getGeneSets();

        for (int i = 0; i < gsets.length; i++) {
            gsets[i] = gsets[i].cloneDeep(restrict2Dataset);
        }

        return gsets;
    }

}    // End class GeneSetMultiParam


