/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.GeneSet;

/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the chpices are presented in a JListWindow and not
 * in a text area
 */
public class GeneSetOptParam extends GeneSetChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param nameEnglish
     * @param desc
     */
    public GeneSetOptParam(String name, String nameEnglish, String desc) {
        super(name, nameEnglish, desc, false, false);
    }

    public GeneSetOptParam(String name) {
        this(name, GRP_ENGLISH, GRP_DESC);
    }

    public GeneSetOptParam() {
        this(GRP, GRP_ENGLISH, GRP_DESC);
    }

    public GeneSet getGeneSet() throws Exception {
        return super._getGeneSets()[0];
    }

    public GeneSet getGeneSet(final Dataset restrict2Dataset) throws Exception {
        final GeneSet gset = getGeneSet();
        return gset.cloneDeep(restrict2Dataset);
    }

    public GeneSet getGeneSet(DatasetOptParam dsp) throws Exception {
        if (dsp != null && dsp.isSpecified()) {
            return getGeneSet(dsp.getDataset());
        } else {
            return getGeneSet();
        }
    }

}    // End class GeneSetOptParam
