/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.GeneSet;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class GeneSetReqdParam extends GeneSetChooserAbstractParam {

    /**
     * Class constructor
     */
    public GeneSetReqdParam() {
        this(GRP, GRP_ENGLISH, GRP_DESC);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public GeneSetReqdParam(String name, String nameEnglish, String desc) {
        super(name, nameEnglish, desc, true, true);
    }

    public GeneSet getGeneSet(Dataset restrict2Dataset) throws Exception {
        GeneSet gset = getGeneSet();
        GeneSet cg = gset.cloneDeep(restrict2Dataset);
        if (gset.getNumMembers() != cg.getNumMembers()) {
            log.info("Not all members in input GeneSet were in the Dataset - started with: " + gset.getNumMembers() + " ended with: " + cg.getNumMembers());

        }

        return cg;
    }

    public GeneSet getGeneSet() throws Exception {
        return super._getGeneSets()[0];
    }

}    // End class GeneSetReqdParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
