package xtools.api.param;

import edu.mit.broad.genome.objects.GenesOfInterest;
import edu.mit.broad.genome.parsers.ParserFactory;
import edu.mit.broad.xbench.core.api.Application;

/**
 * @author Aravind Subramanian
 *         Date: Jan 11, 2006
 *         Time: 11:16:54 AM
 */
public class GenesOfInterestParam extends FileParam {

    public GenesOfInterestParam() {
        super("gin", "Path to the gin file", "Path to a gin file",
                false);
    }

    public GenesOfInterestParam(final boolean reqd) {
        super("gin", "Path to the gin file", "Path to a gin file",
                reqd);
    }

    public GenesOfInterest getGenesOfInterest() throws Exception {

        if (isSpecified()) {
            return ParserFactory.readGenesOfInterest(getFile(), true);
        } else { // the default
            return Application.getVdbManager().getDefaultGenesOfInterest();
        }

    }

    /*
    public GeneSet[] getGeneSets() throws Exception {
        return getGenesOfInterest().getGeneSets();
    }
    */

} // End class SampleAnnotParam
