/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.objects.GenesOfInterest;
import edu.mit.broad.genome.objects.PersistentObject;


/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the choices are presented in a JListWindow and not
 * in a text area
 */
abstract class GinChooserAbstractParam extends AbstractPobChooserParam {

    GinChooserAbstractParam(String name, String desc, boolean reqd, boolean multipleAlllowed) {
        super(name, desc, GenesOfInterest[].class, GenesOfInterest.class,
                new GenesOfInterest[]{}, new GenesOfInterest[]{}, reqd, multipleAlllowed);
    }

    public void setValue(GenesOfInterest[] gins) {
        super.setValue(gins);
    }

    public void setValue(GenesOfInterest gin) {
        super.setValue(new GenesOfInterest[]{gin});
    }

    protected GenesOfInterest[] _getGins() throws Exception {

        PersistentObject[] pobs = (PersistentObject[]) getValue();
        GenesOfInterest[] gins = new GenesOfInterest[pobs.length];

        for (int i = 0; i < pobs.length; i++) {
            log.debug(pobs[i].getClass());
            gins[i] = (GenesOfInterest) pobs[i];
        }

        return gins;
    }

}    // End class AbstractGinChooserParam



