/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.math.Matrix;
import edu.mit.broad.genome.objects.PersistentObject;


/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the choices are presented in a JListWindow and not
 * in a text area
 */
abstract class MatrixChooserAbstractParam extends AbstractPobChooserParam {

    MatrixChooserAbstractParam(String name, String desc, boolean reqd, boolean multipleAlllowed) {
        super(name, desc, Matrix[].class, Matrix.class, new Matrix[]{}, new Matrix[]{}, reqd, multipleAlllowed);
    }

    public void setValue(Matrix[] mss) {
        super.setValue(mss);
    }

    public void setValue(Matrix m) {
        super.setValue(new Matrix[]{m});
    }

    protected Matrix[] _getMatrices() throws Exception {

        PersistentObject[] pobs = (PersistentObject[]) getValue();
        Matrix[] mss = new Matrix[pobs.length];

        for (int i = 0; i < pobs.length; i++) {
            log.debug(pobs[i].getClass());
            mss[i] = (Matrix) pobs[i];
        }

        return mss;
    }

}    // End class AbstractMatrixChooserParam



