/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.math.Matrix;

/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the choices are presented in a JListWindow and not
 * in a text area
 */
public class MatrixOptParam extends MatrixChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public MatrixOptParam(String name, String desc) {
        super(name, desc, false, false);
    }

    public MatrixOptParam(String name) {
        this(name, MAT_DESC);
    }

    public MatrixOptParam() {
        this(MAT);
    }

    public Matrix getMatrix() throws Exception {
        Matrix[] mss = _getMatrices();
        if (mss.length != 1) {
            throw new IllegalStateException("Program error - too many mss expected 1, got: " + mss.length);
        }

        return mss[0];
    }

}    // End class MatrixOptParam
