/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import java.awt.event.ActionListener;

/**
 * Object to capture commandline params</p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class ModeReqdParam extends StringReqdParam implements ActionListener {

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public ModeReqdParam(String name, String desc, String[] def_and_hints) {
        super(name, desc, def_and_hints);
    }

    public ModeReqdParam(String[] def_and_hints) {
        super("mode", "Mode of usage", def_and_hints);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param nameEnglish
     * @param desc
     * @param def_and_hints
     */
    public ModeReqdParam(String name, String nameEnglish, String desc, String[] def_and_hints) {
        super(name, nameEnglish, desc, def_and_hints);
    }

    public String getMode() {
        return getString();
    }

}    // End class StringsChooserParam2

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
