/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the chpices are presented in a JListWindow and not
 * in a text area
 */
public class ModesParam extends StringChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public ModesParam(String def_andonly_hint, boolean reqd) {
        this("mode", "Mode(s) of usage", new String[]{def_andonly_hint}, new String[]{def_andonly_hint}, reqd);
    }

    public ModesParam(String name, String def_andonly_hint, boolean reqd) {
        this(name, "Mode(s) of usage", new String[]{def_andonly_hint}, new String[]{def_andonly_hint}, reqd);
    }

    public ModesParam(String name, String desc, String def_andonly_hint, boolean reqd) {
        this(name, desc, new String[]{def_andonly_hint}, new String[]{def_andonly_hint}, reqd);
    }

    public ModesParam(String name, String nameEnglish, String desc, String def_andonly_hint, boolean reqd) {
        this(name, nameEnglish, desc, new String[]{def_andonly_hint}, new String[]{def_andonly_hint}, reqd);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     * @param hint
     * @param reqd
     */
    public ModesParam(String name, String desc, String[] defs, String[] hints, boolean reqd) {
        super(name, desc, defs, hints, reqd, true);
    }

    public ModesParam(String name, String[] defs, String[] hints, boolean reqd) {
        super(name, "Mode(s) of usage", defs, hints, reqd, true);
    }

    public ModesParam(String name, String nameEnglish, String desc, String[] defs, String[] hints, boolean reqd) {
        super(name, nameEnglish, desc, defs, hints, reqd, true);
    }

    public ModesParam(String name, String desc, String def, String[] hints, boolean reqd) {
        this(name, desc, new String[]{def}, hints, reqd);
    }

    public String[] getModes() {
        return super.getStrings();
    }

}    // End class ModesParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
