/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.alg.gsea.Norms;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class NormModeOptParam extends StringOptParam {

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public NormModeOptParam() {
        super("norm", "Normalization mode",
                "normalization mode",
                new String[]{Norms.MEANDIV_POS_NEG_SEPERATE},
                Norms.createNormModeNames(),
                false);
    }

    public String getNormModeName() {
        return super.getString(0);
    }

}    // End class NormModeParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
