package xtools.api.param;

import java.awt.event.ActionListener;

/**
 * Object to capture commandline params</p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class PValuesModeReqdParam extends StringReqdParam implements ActionListener {

    private static String[] MODES = new String[]{"es", "np", "nes", "fdr", "fwer"};

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public PValuesModeReqdParam(String name, String desc, String[] def_and_hints) {
        super(name, desc, def_and_hints);
    }

    public PValuesModeReqdParam() {
        super("mode", "Mode of usage", MODES);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param nameEnglish
     * @param desc
     * @param def_and_hints
     */
    public PValuesModeReqdParam(String name, String nameEnglish, String desc, String[] def_and_hints) {
        super(name, nameEnglish, desc, def_and_hints);
    }

    public String getMode() {
        return getString();
    }

    public boolean isES() {
        return getMode().equalsIgnoreCase("es");
    }

    public boolean isNP() {
        return getMode().equalsIgnoreCase("np");
    }

    public boolean isFDR() {
        return getMode().equalsIgnoreCase("fdr");
    }

    public boolean isNES() {
        return getMode().equalsIgnoreCase("nes");
    }

    public boolean isFWER() {
        return getMode().equalsIgnoreCase("fwer");
    }


}    // End class StringsChooserParam2

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
