/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.swing.fields.GComboBoxField;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;
import edu.mit.broad.vdb.map.ProbeMergeMode;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class ProbeMergeModeParam extends AbstractParam implements ActionListener {

    private GComboBoxField cbOptions;

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public ProbeMergeModeParam(boolean reqd) {
        super(MMODE, ProbeMergeMode.class, MMODE_DESC, ProbeMergeMode.AVERAGE_MULTI_PROBES, ProbeMergeMode.ALL, reqd);
    }

    public ProbeMergeModeParam(ProbeMergeMode def, boolean reqd) {
        super(MMODE, ProbeMergeMode.class, MMODE_DESC, def, ProbeMergeMode.ALL, reqd);
    }

    public boolean isFileBased() {
        return false;
    }

    public void setValue(Object value) {

        if (value == null) {
            super.setValue(null);
        } else {
            super.setValue(ProbeMergeMode.lookup(value));
        }
    }

    public void setValue(ProbeMergeMode mmode) {
        super.setValue(mmode);
    }

    public ProbeMergeMode getMode() {

        Object val = super.getValue();

        if (val == null) {
            throw new NullPointerException("Null param value. Always check isSpecified() before calling");
        }

        return (ProbeMergeMode) val;
    }


    public GFieldPlusChooser getSelectionComponent() {

        if (cbOptions == null) {
            cbOptions = ParamHelper.createActionListenerBoundHintsComboBox(false, this, this);
            ParamHelper.safeSelectValueDefaultByString(cbOptions.getComboBox(), this);
        }

        return cbOptions;

    }

    public void actionPerformed(ActionEvent evt) {
        this.setValue((ProbeMergeMode) ((JComboBox) cbOptions.getComponent()).getSelectedItem());
    }

}    // End class MappingModeParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
