/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

/**
 * @author Aravind Subramanian
 *         Date: Mar 7, 2003
 *         Time: 11:55:11 AM
 *         To change this template use Options | File TemplateBag.
 */
public class ProbesParam extends StringMultiInputParam {

    /**
     * @param reqd
     */
    public ProbesParam(boolean reqd) {
        super(PROBE, PROBE_DESC, reqd);
    }

    public String getLongDesc() {
        if (fLongDesc == null) {
            fLongDesc = new StringBuffer("<html><body>").append(getDesc()).append("<br>");
            fLongDesc.append("Example: M57710_at<br>");
            fLongDesc.append("Must use the same naming convention of feature identifiers as in the Dataset used for the analysis");
            fLongDesc.append("</body></html>");
        }

        return fLongDesc.toString();
    }

    public String[] getProbeNames() {
        return getStrings();
    }

    public boolean isFileBased() {
        return false;
    }

} // End ProbeIdsParam
