/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.QuickNeighDataset;
import edu.mit.broad.genome.objects.QuickNeighborhoodDatasetImpls;

/**
 * @author Aravind Subramanian
 *         Date: Feb 9, 2004
 *         Time: 2:57:04 PM
 */
public class QuickNeighborhoodDatasetReqdParam extends StringReqdParam {

    private static final String[] OPTIONS = new String[]{"Pearson", "Spearman", "Euclidean"};

    /**
     * Class constructor
     */
    public QuickNeighborhoodDatasetReqdParam() {
        super("neigh_metric", "quick neighborhood metric", OPTIONS);
    }

    public QuickNeighDataset createQuickNeighborhoodDataset(Dataset ds) {

        int sel = super.getStringIndexChoosen();

        if (sel == 0) {
            return new QuickNeighborhoodDatasetImpls.Pearson(ds);
        } else if (sel == 1) {
            return new QuickNeighborhoodDatasetImpls.Spearman(ds);
        } else if (sel == 2) {
            return new QuickNeighborhoodDatasetImpls.Euclidean(ds);
        } else {
            throw new IllegalArgumentException("Unknown choice: " + sel);
        }

    }

} // End class QuickNeighborhoodDatasetParam

