/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;

import edu.mit.broad.genome.objects.RankedList;
import edu.mit.broad.genome.objects.RankedListDb;

/**
 * choose 1 or more string
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @note diff from StringsInputParam -> the chpices are presented in a JListWindow and not
 * in a text area
 */
public class RankedListMultiChooserParam extends RankedListChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public RankedListMultiChooserParam(final String name, final String nameEnglish, final String desc, final boolean reqd) {
        super(name, nameEnglish, desc, reqd, true);
    }

    public RankedListMultiChooserParam(final String name,
                                       final String nameEnglish,
                                       final String desc,
                                       final boolean reqd,
                                       final RankedListDb rdb) {
        super(name, nameEnglish, desc, reqd, true, rdb);
    }

    public RankedListMultiChooserParam(final boolean reqd, final RankedListDb rdb) {
        this(RNK, RNK_ENGLISH, RNK_DESC_MULTI, reqd, rdb);
    }

    public RankedListMultiChooserParam(final String name, final boolean reqd, final RankedListDb rdb) {
        this(name, RNK_ENGLISH, RNK_DESC_MULTI, reqd, rdb);
    }

    public RankedListMultiChooserParam(final String name, final boolean reqd) {
        this(name, RNK_ENGLISH, RNK_DESC_MULTI, reqd);
    }

    public RankedListMultiChooserParam(boolean reqd) {
        this(RNK, reqd);
    }

    public RankedList[] getRankedLists() throws Exception {
        return super._getRankedLists();
    }

}    // End class RankedListChooserParam
