package xtools.api.param;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

import edu.mit.broad.genome.objects.RankedList;

import java.awt.event.ActionListener;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class RankedListReqdParam extends PobParam implements ActionListener {
    /**
     * Class constructor
     */
    public RankedListReqdParam() {
        this(RNK, RNK_ENGLISH, RNK_DESC);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public RankedListReqdParam(final String name, final String desc) {
        super(name, RankedList.class, desc, new RankedList[]{}, true);
    }

    public RankedListReqdParam(final String name, final String nameEnglish, final String desc) {
        super(name, nameEnglish, RankedList.class, desc, new RankedList[]{}, true);
    }

    public void setValue(final RankedList rl) {
        super.setValue(rl);
    }

    // Override this parameter for custom ranked list impls
    public RankedList getRankedList() throws Exception {
        return (RankedList) getPob();
    }

    /*
    public RankedList getRankedList(final ChipOptParam chipOpt) throws Exception {
        final RankedList rl = getRankedList();
        if (chipOpt != null && chipOpt.isSpecified()) {
            return rl.extract(chipOpt.getChip().getProbeNamesAsGeneSet());
        } else {
            return rl;
        }

    }

    public RankedList getRankedList(final ChipChooserMultiParam chipOpt) throws Exception {
        final RankedList rl = getRankedList();
        if (chipOpt != null && chipOpt.isSpecified()) {
            return rl.extract(chipOpt.getChipCombo().getProbeNamesAsGeneSet());
        } else {
            return rl;
        }

    }
    */


}    // End class RankedListReqdParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
