package xtools.api.param;

/**
 * @author Aravind Subramanian
 * Date: May 29, 2006
 * Time: 2:36:03 PM
 */

/**
 * @author Aravind Subramanian
 * Date: May 29, 2006
 * Time: 12:47:39 PM
 */

import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.parsers.ParserFactory;
import edu.mit.broad.vdb.sampledb.SampleAnnot;

/**
 * @author Aravind Subramanian
 *         Date: Sep 28, 2005
 *         Time: 9:01:23 PM
 */
public class SampleAnnotParam extends FileParam {

    public SampleAnnotParam() {
        super("sin", "Path to the sin file", "Path to a custom generic sample annotation (SIN) file",
                false);
    }

    public SampleAnnotParam(final boolean reqd) {
        super("sin", "Path to the sin file", "Path to a custom generic sample annotation (SIN) file",
                reqd);
    }

    public SampleAnnotParam(String name) {
        super(name, "Path to the sin file", "Path to a custom generic sample annotation (SIN) file",
                false);
    }

    public SampleAnnot getAnnot() throws Exception {
        return ParserFactory.readSampleAnnot(getFile(), true, true);
    }

    public SampleAnnot getAnnot(final FileParam celFofnParam_opt) throws Exception {
        final SampleAnnot sampleAnnot = getAnnot();

        if (celFofnParam_opt != null && celFofnParam_opt.isSpecified() &&
                celFofnParam_opt.getFile().getName().indexOf(".comp") == -1) {
            final String[] sampleNames = celFofnParam_opt.getStringsUnique();
            return sampleAnnot.cloneDeep(sampleNames);
        } else {
            return sampleAnnot;
        }
    }

    public SampleAnnot getAnnot(final DatasetReqdParam dsParam) throws Exception {
        final SampleAnnot sampleAnnot = getAnnot();

        if (dsParam != null) {
            final String[] sampleNames = dsParam.getDataset().getColumnNamesArray();
            return sampleAnnot.cloneDeep(sampleNames);
        } else {
            return sampleAnnot;
        }

    }

    public SampleAnnot getAnnot(final DatasetOptParam dsParam) throws Exception {
        final SampleAnnot sampleAnnot = getAnnot();

        if (dsParam != null && dsParam.isSpecified()) {
            final String[] sampleNames = dsParam.getDataset().getColumnNamesArray();
            return sampleAnnot.cloneDeep(sampleNames);
        } else {
            return sampleAnnot;
        }
    }

    public SampleAnnot getAnnot(final Dataset ds) throws Exception {
        final SampleAnnot sampleAnnot = getAnnot();

        if (ds != null) {
            final String[] sampleNames = ds.getColumnNamesArray();
            return sampleAnnot.cloneDeep(sampleNames);
        } else {
            return sampleAnnot;
        }
    }

} // End class SampleAnnotParam
