/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.objects.Template;
import edu.mit.broad.genome.objects.TemplateFactory;
import edu.mit.broad.genome.objects.TemplateMode;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

/**
 * Only 1 template choosable
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class SnpTemplateSingleChooserParam extends SnpTemplateChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     * @param reqd
     */
    public SnpTemplateSingleChooserParam(boolean reqd, TemplateMode mode) {
        super(reqd, mode, false);
    }

    public SnpTemplateSingleChooserParam(String name, String desc, boolean reqd, TemplateMode mode) {
        super(name, name, desc, reqd, mode, false);
    }

    public SnpTemplateSingleChooserParam(String name, TemplateMode mode, boolean reqd) {
        super(name, name, CLS_DESC, reqd, mode, false);
    }

    public SnpTemplateSingleChooserParam(String name, String nameEnglish, TemplateMode mode, boolean reqd) {
        super(name, nameEnglish, CLS_DESC, reqd, mode, false);
    }

    public GFieldPlusChooser getSelectionComponent() {
        return _getSelectionComponent();
    }

    public Template getTemplate() throws Exception {
        return _getTemplates(null)[0];
        //return _getTemplate();
    }

    public Template[] getTemplates_ova() throws Exception {
        return TemplateFactory.extractAllOvaTemplates(getTemplate(), true); // backward templates are usually a waste
    }

}    // End class SnpTemplateSingleChooserParam

