package xtools.api.param;

/*
 * Object to capture commandline params</p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */

public class StateNameOptParam extends StringOptParam {

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public StateNameOptParam(final String name, final String desc, final String[] def_and_hints) {
        super(name, desc, def_and_hints);
    }

    public StateNameOptParam(final String[] def_and_hints) {
        super("state", "state name", def_and_hints);
    }

    public StateNameOptParam(final String def) {
        this(new String[]{def});
    }

    public StateNameOptParam() {
        super("state", "state name", new String[]{});
    }

    /**
     * Class constructor
     *
     * @param name
     * @param nameEnglish
     * @param desc
     * @param def_and_hints
     */
    public StateNameOptParam(String name, String nameEnglish, String desc, String[] def_and_hints) {
        super(name, nameEnglish, desc, def_and_hints);
    }

    public String getStateName() {
        return getString(0);
    }

}    // End class StateNameOptParam

