package xtools.api.param;

import java.awt.event.ActionListener;

/**
 * Object to capture commandline params</p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class StateNameReqdParam extends StringReqdParam implements ActionListener {

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public StateNameReqdParam(final String name, final String desc, final String[] def_and_hints) {
        super(name, desc, def_and_hints);
    }

    public StateNameReqdParam(final String[] def_and_hints) {
        super("state", "state name", def_and_hints);
    }

    public StateNameReqdParam(final String def) {
        this(new String[]{def});
    }

    public StateNameReqdParam() {
        super("state", "state name", new String[]{});
    }

    /**
     * Class constructor
     *
     * @param name
     * @param nameEnglish
     * @param desc
     * @param def_and_hints
     */
    public StateNameReqdParam(String name, String nameEnglish, String desc, String[] def_and_hints) {
        super(name, nameEnglish, desc, def_and_hints);
    }

    public String getStateName() {
        return getString();
    }

}    // End class StateNameReqdParam

