package xtools.api.param;

/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

/**
 * Object to capture commandline params</p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class StateNamesReqdParam extends StringMultiInputParam {

    public StateNamesReqdParam(final String[] def_and_hints) {
        super("state", "state", "state name(s)", def_and_hints, true);
    }

    public StateNamesReqdParam() {
        this(new String[]{});
    }

    public StateNamesReqdParam(final String name) {
        super(name, "state", " state names", new String[]{}, true);
    }

    public String[] getStateNames() {
        return getStringsUnique();
    }

}    // End class StateNamesReqdParam

