/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class StringOptParam extends StringChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param type
     * @param desc
     */
    public StringOptParam(String name, String desc, String def_andonly_hint) {
        this(name, desc, new String[]{def_andonly_hint}, new String[]{def_andonly_hint});
    }

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     * @param reqd
     */
    public StringOptParam(String name, String desc) {
        this(name, desc, new String[]{}, new String[]{});
    }

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     * @param hint
     * @param reqd
     */
    public StringOptParam(String name, String nameEnglish, String desc, String[] defs, String[] hints, boolean multipleAllowed) {
        super(name, nameEnglish, desc, defs, hints, false, multipleAllowed);
    }

    public StringOptParam(String name, String desc, String[] defs, String[] hints) {
        super(name, desc, defs, hints, false, false);
    }

    public StringOptParam(String name, String desc, String def, String[] hints) {
        this(name, desc, new String[]{def}, hints);
    }

    public StringOptParam(String name, String nameEnglish, String desc, String def, String[] hints, boolean multipleAllowed) {
        this(name, nameEnglish, desc, new String[]{def}, hints, multipleAllowed);
    }

    public StringOptParam(String name, String desc, String[] hints) {
        super(name, desc, null, hints, false, false);
    }

}    // End class StringOptChooserParam

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
