/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package xtools.api.param;


import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.Template;
import edu.mit.broad.genome.objects.TemplateMode;
import edu.mit.broad.genome.swing.fields.GFieldPlusChooser;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Can choose > 1 template
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class TemplateMultiChooserParam extends TemplateChooserAbstractParam {

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     * @param reqd
     */
    public TemplateMultiChooserParam(final boolean reqd, final TemplateMode mode) {
        super(reqd, mode, true);
    }

    public TemplateMultiChooserParam(final String name,
                                     final String nameEnglish,
                                     final String desc,
                                     final boolean reqd,
                                     final TemplateMode mode) {
        super(name, nameEnglish, desc, reqd, mode, true);
    }

    public TemplateMultiChooserParam(final String nameEnglish,
                                     final boolean reqd,
                                     final TemplateMode mode) {
        super(CLS, nameEnglish, CLS_DESC, reqd, mode, true);
    }

    public TemplateMultiChooserParam(final String name,
                                     final String desc,
                                     final boolean reqd,
                                     final TemplateMode mode) {
        super(name, name, desc, reqd, mode, true);
    }

    public GFieldPlusChooser getSelectionComponent() {
        return _getSelectionComponent();

    }

    public Template[] getTemplates(final Dataset dsOpt) throws Exception {
        return _getTemplates(dsOpt);
    }

    public List getTemplatesL(final Dataset dsOpt) throws Exception {
        Template[] tss = getTemplates(dsOpt);
        List list = new ArrayList();
        for (int t = 0; t < tss.length; t++) {
            list.add(tss[t]);
        }

        return list;
    }

    public Template.Class[] getUniqueTemplateClasses(Dataset dsOpt) throws Exception {
        Template[] tss = getTemplates(dsOpt);
        Map nameClassMap = new HashMap();
        for (int t = 0; t < tss.length; t++) {
            for (int c = 0; c < tss[t].getNumClasses(); c++) {
                nameClassMap.put(tss[t].getClass(c).getName(), tss[t].getClass(c));
            }
        }

        return (Template.Class[]) nameClassMap.values().toArray(new Template.Class[nameClassMap.size()]);
    }

}    // End class TemplateParamHelper

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
