package xtools.gsea;

import edu.mit.broad.genome.objects.strucs.TemplateRandomizerType;
import edu.mit.broad.genome.XLogger;
import org.apache.log4j.Logger;
import xtools.api.param.*;
import edu.duke.igsp.app.params.*;

/**
 * @revised by Qing Xiong <qxiong@email.unc.edu>
 * Date: September 22, 2012
 *
 */
public abstract class AbstractGsaaSeqGP2Tool extends AbstractGsaaSeqGPTool {

    private static final Logger xlog = XLogger.getLogger(AbstractGsaaSeqGP2Tool.class);
    protected final ExpDatasetParam fDatasetParam = new ExpDatasetParam(true);
    protected final ExpTemplateParam fTemplateParam = new ExpTemplateParam(true);
    protected final StringInputParam fPThresholdParam = ParamFactory.createPThresholdParam();
    protected final StringReqdParam fDEMetricParam = ParamFactory.createDEMetricParamSeqGP();
    protected final StringReqdParam fGSAMetricParam = ParamFactory.createGSAMetricParamSeqGP();
    protected final OrderParam fOrderParam = new OrderParam(false);
    protected final SortParam fSortParam = new SortParam(false);
    protected final PermuteTypeChooserParam fPermuteTypeParamType = PermuteTypeChooserParam.createGeneSet(true);
    protected final BooleanParam fSaveRndRankedListsParam = new BooleanParam("save_rnd_lists", "Save random ranked lists", "Save random ranked lists (might be very large)", false, false);
    protected final TemplateRandomizerTypeParam fRndTypeParam = new TemplateRandomizerTypeParam(
            TemplateRandomizerType.NO_BALANCE,
            new TemplateRandomizerType[]{TemplateRandomizerType.NO_BALANCE,
                TemplateRandomizerType.EQUALIZE_AND_BALANCE}, true);

    /**
     * Class constructor
     *
     * @param properties
     */
    protected AbstractGsaaSeqGP2Tool() {
    }

    protected void doAdditionalParams() {
        fParamSet.addParam(fDatasetParam);
        fParamSet.addParamPseudoReqd(fTemplateParam);
        fParamSet.addParamBasic(fGSAMetricParam);
        fParamSet.addParamBasic(fDEMetricParam);
        fParamSet.addParamPseudoReqd(fPermuteTypeParamType);
        fParamSet.addParamAdv(fSaveRndRankedListsParam);
        fParamSet.addParamAdv(fRndTypeParam);
    }

}
