/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.alg;


import edu.mit.broad.genome.math.AddressedVector;


/**
 * Metrics that compare 2 ranks ordered vectors
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public interface RankMetric {

    public String getName();

    public double getScore(AddressedVector x, AddressedVector y);

}    // RankMetric

