/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.alg.cluster;


import edu.mit.broad.genome.math.Vector;

import java.util.Map;


/**
 * Specification of a LinkageMetric
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public interface LinkageMetric {

    public static final String USE_MEDIAN = "use_median";
    public static final String USE_BIASED = "use_biased";
    public static final String FIX_LOW = "fix_low";

    /**
     * keys of the params map correspond to one of the constants defined above.
     * Typical example of params are USE_MEDIAN and USE_BIASED
     */
    public Vector merge(Vector a, Vector b, Map params);

    public float[] merge(float[] a, float[] b, Map params);

    public String getName();

    public LinkageMetric cloneLinkageMetric();

}    // End LinkageMetric
