/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.alg.fdr;

import edu.mit.broad.genome.parsers.ParseUtils;

/**
 * @author Aravind Subramanian
 *         CutoffByCount both Tag and Template
 */
public class CutoffByCount {

    private final int fCutoff;

    /**
     * @param maxhigher_tags_allowed
     * @param maxhigher_templates_allowed
     */
    public CutoffByCount(int cutoff) {
        this.fCutoff = cutoff;
    }

    public int getCutoff() {
        return fCutoff;
    }

    public static CutoffByCount[] createCutoffByCount(String cs) {

        if (cs == null) {
            throw new IllegalArgumentException("Param cs cannot be null");
        }

        int[] ints = ParseUtils.string2ints(cs);

        CutoffByCount[] cutoffs = new CutoffByCount[ints.length];
        for (int i = 0; i < cutoffs.length; i++) {
            cutoffs[i] = new CutoffByCount(ints[i]);
        }

        return cutoffs;
    }

} // End class CutoffByCount

