package edu.mit.broad.genome.alg.filters;

/**
 * @author Aravind Subramanian
 * Date: Jun 27, 2006
 * Time: 11:31:27 AM
 */

import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.FSet;
import edu.mit.broad.genome.objects.GeneSet;

import java.util.List;

/**
 * @author Aravind Subramanian
 *         Date: Oct 1, 2005
 *         Time: 4:24:18 PM
 */
public class FilteredDatasetImpl_only_genes implements FilteredDataset {

    private String fFilterName;

    private String fInfo;

    private GeneSet fPassing;

    private GeneSet fFailing;

    private String[] fOrigAllFeatureNames;

    /**
     * Class constructor
     *
     * @param filterName
     * @param origDataset
     * @param passing
     * @param info
     */
    public FilteredDatasetImpl_only_genes(
            final String filterName,
            final String[] origAllFeatureNames,
            final List passing,
            final List failing,
            final String info) {
        // @note naming method
        this(filterName, origAllFeatureNames,
                new FSet(filterName + "_pass_n" + passing.size(), passing, true),
                new FSet(filterName + "_fail_n" + failing.size(), failing, true),

                info);
    }

    /**
     * Class constructor
     *
     * @param filterName
     * @param origDataset
     * @param passing
     * @param info
     */
    public FilteredDatasetImpl_only_genes(final String filterName,
                                          final String[] origAllFeatureNames,
                                          final GeneSet passing,
                                          final GeneSet failing,
                                          final String info) {

        if (passing == null) {
            throw new IllegalArgumentException("Param passing cannot be null");
        }
        if (failing == null) {
            throw new IllegalArgumentException("Param failing cannot be null");
        }

        this.fOrigAllFeatureNames = origAllFeatureNames;
        this.fFilterName = filterName;
        this.fPassing = passing;
        this.fFailing = failing;
        this.fInfo = info;
    }

    public String getName() {
        return fFilterName;
    }

    public String getInfo() {
        return fInfo;
    }

    public Dataset getDataset(final boolean passing) {
        throw new NotImplementedException();
    }

    public GeneSet getGeneSet(final boolean passing) {
        if (passing) {
            return fPassing;
        } else {
            return fFailing;
        }
    }

    public Dataset getDatasetOriginal() {
        throw new NotImplementedException();
    }

    public int getNumOriginalFeatures() {
        return fOrigAllFeatureNames.length;
    }

} // End class FilteredDataset_only_genes
