/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.alg.gsea;

import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.genome.objects.RankedList;

/**
 * @author Aravind Subramanian
 *         Date: Jun 20, 2004
 *         Time: 3:45:47 PM
 */
public interface GeneSetCohortGenerator {

    public GeneSetCohort createGeneSetCohort(final RankedList rl,
                                             final GeneSet[] gsets,
                                             final GeneToGeneSetMap g2gsetMap,
                                             final boolean qualifySetsAgainstRankedList,
                                             final boolean realRankedList);


    public GeneSetCohort createGeneSetCohort(final RankedList rl,
                                             final GeneSet[] gsets,
                                             final boolean qualifySetsAgainstRankedList,
                                             final boolean realRankedList); // @todo consider realrl

    public GeneSetCohort createGeneSetCohort(final RankedList rl,
                                             final GeneSet gset,
                                             final boolean qualifySetAgainstRankedList,
                                             final boolean realRankedList);

    public GeneSetScoringTable getGeneSetScoringTable();

    public boolean isTwoSidedEs();

} // End class GeneSetCohortGenerator
