/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.alg.gsea;

import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.genome.objects.RankedList;

/**
 * @author Aravind Subramanian
 *         Date: Nov 11, 2004
 *         Time: 2:22:15 PM
 */
public interface GeneSetScoringTable {

    public String getName();

    public float getHitScore(final String name);

    public float getHitScore_gsaasnp(final String name);
    
    public float getHitScoreP2(final String name);

    public float getMissScore(final String name);

    public float getMissScore_native(final String name);

    public GeneSetScoringTable createTable(GeneSet gset, RankedList rl, RankedList realRankedList);

    public boolean isTwoSidedEs();

    public RankedList getRankedList();

}
