package edu.mit.broad.genome.alg.gsea;

import edu.mit.broad.genome.math.Vector;
import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.esmatrix.db.EnrichmentResult;
import edu.mit.broad.genome.objects.esmatrix.db.EnrichmentScore;

/**
 * @author Aravind Subramanian
 *         Date: Dec 10, 2005
 *         Time: 9:41:09 PM
 */
public interface PValueCalculator {

    public EnrichmentResult[] calcNPValuesAndFDR(final EnrichmentResult[] results);

    public EnrichmentResult[] calcNPValuesAndFDR(final EnrichmentResult[] results,
                                                 final Dataset rndESS);

    public EnrichmentResult calcNPValues(final EnrichmentResult result);

    public EnrichmentResult[] calcNPValues(final EnrichmentResult[] results);

    public EnrichmentScore calcNPValues(final EnrichmentScore es, final Vector rndEss);

    public EnrichmentResult[] calcNPValuesAndFDRSeq(EnrichmentResult[] results);

} // End class PValueSetter
