package edu.mit.broad.genome.alg.markers;

import edu.mit.broad.genome.alg.DatasetStatsCore;
import edu.mit.broad.genome.alg.Metric;
import edu.mit.broad.genome.math.LabelledVectorProcessor;
import edu.mit.broad.genome.math.Matrix;
import edu.mit.broad.genome.math.Order;
import edu.mit.broad.genome.math.SortMode;
import edu.mit.broad.genome.objects.*;
import gnu.trove.TIntArrayList;

import java.util.Map;

/**
 * @author Aravind Subramanian
 *         Date: Nov 24, 2005
 *         Time: 10:33:39 PM
 */
public interface PermutationTest {

    // @note DONT put reporting gunk in here (use permutation report instead)

    // Meta data

    public String getName();

    public int getNumMarkers();

    public int getNumPerms();

    public Metric getMetric();

    public SortMode getSortMode();

    public Order getOrder();

    public LabelledVectorProcessor getLabelledVectorProcessor();

    public Map getMetricParams();

    public float[] getSigLevels();

    public int getNumSigMarkers(final float sigLevel);

    public GeneSet getSigMarkers(final float sigLevel);

    public MetricWeightStruc[] getRandomMetricWeights();

    // Data structire
    public RankedList getRankedList();

    public ScoredDataset getScoredDataset();

    public Dataset getDataset();

    public Template getTemplate();

    // Results
    public Dataset getSigLevels(final boolean up);

    public Matrix getSigLevelsMatrix(final boolean up);

    // @todo fix me - na for contin
    public DatasetStatsCore.TwoClassMarkerStats getScore(final String featureName);

    public Template[] getTemplatesRandom();

    public TIntArrayList getMetricCrossOverRanks();

    public int getRealMetricCrossOverRank();

    public MetricWeightStruc getRealMetricWeight();

    public Dataset getRandomScores(final boolean up);

    public GeneSetPair getUpandDnMarkers();

} // End interface PermutationTest
