/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.charts;

import edu.mit.broad.genome.JarResources;
import org.jfree.chart.JFreeChart;

import javax.swing.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

/**
 * simple wrapper Interface
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */


public interface XChart {

    public static final Icon ICON = JarResources.getIcon("Chart.gif");

    public XChart cloneShallow(String newName);

    // imp that it be protected
    // we dont want to expose jfreechart_test usage
    // but sometimes need to
    //protected JFreeChart getFreeChart() {
    public JFreeChart getFreeChart();

    // Name is NOT the same as Title - name is simple and file name safe. Title is short but can be 'English'.
    public String getName();

    // Usually same as the title of the JFreeChart
    public String getTitle();

    // Caption is a more verbose form of Title
    public String getCaption();

    public Icon getIcon();

    public BufferedImage createBufferedImage(int width, int height);

    public void saveAsPNG(File inFile, int width, int height) throws IOException;

    public void saveData(File inFile) throws Exception;


} // End XChart

