/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.math;

/**
 *
 */
public class CellScore {

    private String fName;
    private float fScore;
    private int fRow;
    private int fCol;

    // name can be null for perf reasons
    public CellScore(String name, float score, int row, int col) {
        init(name, score, row, col);
    }

    public CellScore(float score, int row, int col) {
        init(null, score, row, col);
    }

    // does the real init
    private void init(String name, float score, int row, int col) {
        this.fName = name;
        this.fScore = score;
        this.fRow = row;
        this.fCol = col;
    }

    public String getName() {
        return fName;
    }

    public float getScore() {
        return fScore;
    }

    public int getRow() {
        return fRow;
    }

    public int getCol() {
        return fCol;
    }

} // End CellScore

