/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.math;

import java.util.Comparator;

/**
 * @author Aravind Subramanian
 *         Date: Apr 12, 2003
 *         Time: 10:03:23 PM
 */
public class CellScoreComparator implements Comparator {

    /**
     * Return -1 if o1 is less than o2, 0 if they're equal, +1 if o1 is greater than o2.
     */
    public int compare(Object pn1, Object pn2) {

        double pos1 = ((CellScore) pn1).getScore();
        double pos2 = ((CellScore) pn2).getScore();

        if (pos1 < pos2) {
            return -1;
        } else if (pos1 == pos2) {
            return 0;
        } else {
            return +1;
        }
    }

    /**
     * Return true if this equals o2.
     */
    public boolean equals(Object o2) {
        return false;
    }

}    // End CellScoreComparator
