/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

package edu.mit.broad.genome.math;


import edu.mit.broad.genome.utils.ChainedException;


/**
 * Tags an exception as caused by some math related activity.
 * <p/>
 * Basically a checked equivalnet of java.lang.ArithmeticException
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class MathException extends ChainedException {

    /**
     * Construct a new <code>MathException</code> instance.
     *
     * @param message The detail message for this exception.
     */
    public MathException(final String message) {
        super(message);
    }

    /**
     * Construct a new <code>MathException</code> instance.
     *
     * @param message   The detail message for this exception.
     * @param throwable the root cause of the exception
     */
    public MathException(final String message, final Throwable throwable) {
        super(message, throwable);
    }

    /**
     * Construct a new <code>MathException</code> instance.
     *
     * @param throwable the root cause of the exception
     */
    public MathException(final Throwable throwable) {
        super(throwable);
    }
}    // End MathException

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
