/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.math;


/**
 * @author Aravind Subramanian
 *         Date: Mar 27, 2004
 *         Time: 8:33:35 PM
 */
public interface Range {

    public String getName();

    public void setImmutable();

    public void increment();

    public int getCount();

    /**
     * always inclusive
     */
    public boolean isInRange(double valueInclusive);

    public double getMax();

    public double getMin();

    public double getFuzz();

    public double getSpread();

    public double getMean();

    public Range cloneShallow();

}
