/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.math;

/**
 * @author Aravind Subramanian
 *         Date: Jul 17, 2004
 *         Time: 2:33:53 PM
 */
public class RankingMode {

    public static RankingMode POSITIVE_ONLY = new RankingMode("positive_only");
    public static RankingMode NEGATIVE_ONLY = new RankingMode("negative_only");
    public static RankingMode ABSOLUTE_VALUE = new RankingMode("absolute_value");
    public static RankingMode POS_MAX2_MIN_THEN_NEG_MIN_TO_MAX = new RankingMode("POS_MAX2_MIN_THEN_NEG_MIN_TO_MAX");
    public static RankingMode REAL_SORT_DESC = new RankingMode("REAL_SORT_DESC");


    private String mode;

    /**
     * @param name
     */
    private RankingMode(String name) {
        this.mode = name;
    }

    public String getName() {
        return mode;
    }


} /// End class RankingMode
