/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

package edu.mit.broad.genome.math;


import java.util.Map;

/**
 * VectorFunctor -> something that performs a function or an operation on  Vector
 * <p/>
 * VectorFunctors must have no state.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */

public interface VectorFunctor {

    public String getName();

    /**
     * calculates some statistic of the vector
     * <p/>
     * Hmm not needed?? -- i've been using vector as a place for such things
     * YES needed - Vector.somemethod() is ok for most. However for methods
     * that are generic, such as find me the top n max/min/var genes, providing an
     * interface as the method makes it generic.
     */
    public static interface Statistic extends VectorFunctor {

        public void setParam(Map map);

        public double getValue(Vector vector);
    }


}    // End VectorFunctor

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
