/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.math;

import edu.mit.broad.genome.MismatchedSizeException;

/**
 * Contruct to hold 2 related Vectors
 * Not intended to be mutability safe.
 * <p/>
 * Vectors MUST be equal size
 */
public class XYVector {

    public final Vector x;
    public final Vector y;

    public XYVector(final Vector x, final Vector y) {

        this.x = x;
        this.y = y;

        if (x.getSize() != y.getSize()) {
            throw new MismatchedSizeException(x, y);
        }

    }

    public int getSize() {
        return x.getSize();
    }

} // End class XYVector

