package edu.mit.broad.genome.models;

import org.jfree.data.Range;
import org.jfree.data.xy.AbstractXYDataset;
import org.jfree.data.xy.XYDataset;

/**
 * @author Aravind Subramanian
 *         Date: Aug 8, 2005
 *         Time: 4:15:23 PM
 */
public abstract class AbstractXYDatasetStruc extends AbstractXYDataset implements XYDataset {

    private Number domainMin;
    private Number domainMax;
    private Number rangeMin;
    private Number rangeMax;
    private Range domainRange;
    private Range range;

    /**
     * @param xmin
     * @param xmax
     * @param ymin
     * @param maxY
     */
    protected void init(double xmin, double xmax, double ymin, double ymax) {

        this.domainMin = new Double(xmin);
        this.domainMax = new Double(xmax);
        this.domainRange = new Range(xmin, xmax);

        this.rangeMin = new Double(ymin);
        this.rangeMax = new Double(ymax);
        this.range = new Range(ymin, ymax);

    }

    public Number getMinimumDomainValue() {
        return this.domainMin;
    }

    public Number getMaximumDomainValue() {
        return this.domainMax;
    }

    public Range getDomainRange() {
        return this.domainRange;
    }

    public Number getMinimumRangeValue() {
        return this.rangeMin;
    }

    public Number getMaximumRangeValue() {
        return this.rangeMax;
    }

    public Range getValueRange() {
        return this.range;
    }


    protected abstract String getSeriesName(int series);

    ASComparable[] foos;

    public java.lang.Comparable getSeriesKey(int series) {
        if (foos == null) {
            foos = new ASComparable[getSeriesCount()];
            for (int i = 0; i < foos.length; i++) {
                foos[i] = new ASComparable(getSeriesName(i));
            }
        }

        return foos[series];
    }


} // End class AbstractXYDatasetStruc
