package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.math.Order;
import edu.mit.broad.genome.math.SortMode;

/**
 * @author Aravind Subramanian
 *         Date: May 4, 2006
 *         Time: 3:32:15 PM
 */
public abstract class AbstractDataset extends AbstractObject implements Dataset {

    protected AbstractDataset(String name) {
        super(name);
    }

    protected AbstractDataset() {
    }

    public Dataset cloneShallow(final String newName) {
        super.setName(newName);
        return this;
    }

    public int[] getColumnIndices(final String[] colNames) {
        int[] indices = new int[colNames.length];
        for (int i = 0; i < colNames.length; i++) {
            indices[i] = getColumnIndex(colNames[i]);
        }

        return indices;
    }

    public LabelledVector getRowLV(final String rowName) {
        return getRowLV(getRowIndex(rowName));
    }

    public LabelledVector getRowLV(final int rown) {
        return new LabelledVector(getRowName(rown), getColumnNamesArray(), getMatrix().getRowV(rown));
    }

    public RankedList getRowRL(final String rowName, final SortMode sort, final Order order) {
        return getRowLV(rowName).sort(sort, order);
    }

    public RankedList getRowRL(final int rown, final SortMode sort, final Order order) {
        return getRowLV(rown).sort(sort, order);
    }

    /*
    public class DefaultSampleAnnot extends AbstractObject implements SampleAnnot {

        DefaultSampleAnnot() {
            super.initialize(getName());
        }

        public String getQuickInfo() {
            return null;
        }

        public int getNumSamples() {
            return getNumCol();
        }

        public String[] getSampleNames() {
            return getColumnNamesArray();
        }

        public List getSampleNames_list() {
            return getColumnNames();
        }

        public String[] getSampleNames(String[] celFileNames) {
            throw new NotImplementedException();
        }

        public ISample getISample(int coln) {
            throw new NotImplementedException();
        }

        public String[] getCelFileNames() {
            throw new NotImplementedException();
        }

        public String getSampleName(final String celFileName) {
            throw new NotImplementedException();
        }

        public ColorMap.Columns getColorMap() {
            throw new NotImplementedException();
        }

        public SampleAnnot cloneDeep(final String newName, final String[] useOnlyTheseSamples) {

            throw new NotImplementedException();
        }

        public SampleAnnot cloneDeep(final String[] useOnlyTheseSamples) {
            throw new NotImplementedException();
        }

        public Linked getLink(final String sampleName) {
            throw new NotImplementedException();
        }

    } // End class DefaultSampleAnnot
    */


} // End class AbstractDataset
