/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.genome.math.Vector;

import java.awt.*;
import java.util.Map;
import java.util.Set;
import java.util.ArrayList;

/**
 * @author Aravind Subramanian
 *         Date: Feb 12, 2005
 *         Time: 8:15:28 PM
 */
public abstract class AbstractPreTemplate extends AbstractObject implements PreTemplate {

    /**
     * Class constructor
     *
     * @param name
     */
    protected AbstractPreTemplate(String name) {
        super(name);
    }

    public Vector extractProfile(final int rowIndex, final Dataset ds) {
        throw new NotImplementedException();
    }

    public LabelledVector extractProfile_lv(final int rowIndex, final Dataset ds) {
        throw new NotImplementedException();
    }

    public int[] getProfilePositionsOrdered() {
        throw new NotImplementedException();
    }


    public Vector synchProfile(final Vector profile) {
        throw new NotImplementedException();
    }


    public Vector extractProfile(final String rowName, final Dataset ds) {
        throw new NotImplementedException();
    }

    public LabelledVector extractProfile_lv(final String rowName, final Dataset ds) {
        throw new NotImplementedException();
    }

    public Template.Item[] getItemsOrderedByProfilePos() {
        throw new NotImplementedException();

    }

    public Template.Item[] getItemsOrderedByClassFirstAndThenProfilePos() {
        throw new NotImplementedException();
    }

    public int[] getOrderedProfilePositions() {
        throw new NotImplementedException();
    }

    public Template.Class[] getClassesOrderedByProfilePos() {
        throw new NotImplementedException();
    }

    public String[] getClassNamesOrderedByProfilePos() {
        throw new NotImplementedException();
    }

    public String getQuickInfo() {
        return null;
    }

    public void setClassOfInterestIndex(int coiIndex) {
        throw new NoSuchMethodError();
    }

    public void makeImmutable() {
        throw new NoSuchMethodError();
    }

    public String getClassName(int i) {
        throw new NoSuchMethodError();
    }

    public Class getClass(Item item) {
        throw new NoSuchMethodError();
    }

    public Template.Class getClass(int i) {
        throw new NoSuchMethodError();
    }

    public Template.Class getClass(String name) {
        throw new NoSuchMethodError();
    }

    public int getClassIndex(String name) {
        throw new NoSuchMethodError();
    }

    public int getClassIndex(Template.Class cl) {
        throw new NoSuchMethodError();
    }

    public int getNumClasses() {
        throw new NoSuchMethodError();
    }

    public boolean isMemberClass(Template.Class cl) {
        throw new NoSuchMethodError();
    }

    public Class getClassByProfilePos(int posInProfile) {
        throw new NoSuchMethodError();
    }

    public String getClassOfInterestName() {
        throw new NoSuchMethodError();
    }

    public Class getClassOfInterest() {
        throw new NoSuchMethodError();
    }

    public Color getItemColor(int itemProfilePos) {
        throw new NoSuchMethodError();
    }

    public int getClassOfInterestIndex() {
        throw new NoSuchMethodError();
    }

    public Template cloneDeep() {
        throw new NoSuchMethodError();
    }

    public Template cloneDeep(String newName) {
        throw new NoSuchMethodError();
    }

    public boolean equalsShallow(final Template t) {
        throw new NoSuchMethodError();
    }

    public boolean isAscendingProfilePositions() {
        throw new NoSuchMethodError();
    }

    public boolean isClassesContiguous() {
        throw new NoSuchMethodError();
    }

    public Template.Item getItem(int itemIndex) {
        throw new NoSuchMethodError();
    }

    public Template.Item getItemByProfilePos(int primPos) {
        throw new NoSuchMethodError();
    }

    public boolean hasItemWithId(String id) {
        throw new NoSuchMethodError();
    }

    public int getNumItems() {
        throw new NoSuchMethodError();
    }

    public Vector toVector() {
        throw new NoSuchMethodError();
    }

    public String getAsString(boolean gc) {
        throw new NoSuchMethodError();
    }

    public Vector[] splitByTemplateClass(final Vector profile) {
        throw new NoSuchMethodError();
    }

    public ArrayList[] splitByTemplateClass(final ArrayList profile) {
        throw new NoSuchMethodError();
    }

    public java.util.List extractColumnNames(final Dataset ds) {
        throw new NotImplementedException();
    }

    public Set[] splitByTemplateClass(final java.util.List colNames) {
        throw new NoSuchMethodError();
    }

    public String getColumnName(final Template.Item item, final Dataset inDataset) {
        throw new NoSuchMethodError();
    }

    public Map createSampleNameTemplateItem(final Dataset ds) {
        throw new NoSuchMethodError();
    }

    public Map createSampleNameSampleClassNameMap(final Dataset ds) {
        throw new NoSuchMethodError();
    }

    public Map createSampleNameSampleClass(Dataset ds) {
        throw new NoSuchMethodError();
    }

    /*

    private Template frt;


    public void initTemplate(final Template realTemplate) {
        if (realTemplate == null) {
            throw new IllegalArgumentException("Param realTemplate cannot be null");
        }

        this.frt = realTemplate;
    }

    public String getQuickInfo() {
        return null;
    }

    private Template _template() {
        if (this.frt == null) {
            throw new IllegalStateException("Not inited template yet - must call initTemplate first");
        }

        return frt;
    }

    public void setClassOfInterestIndex(int coiIndex) {
        _template().setClassOfInterestIndex(coiIndex);
    }

    public void makeImmutable() {
        _template().makeImmutable();
    }

    public String getClassName(int i) {
        return _template().getClassName(i);
    }

    public Class getClass(Item item) {
        return _template().getClass(item);
    }

    public Template.Class getClass(int i) {
        return _template().getClass(i);
    }

    public Template.Class getClass(String name) {
        return _template().getClass(name);
    }

    public int getClassIndex(String name) {
        return _template().getClassIndex(name);
    }

    public int getClassIndex(Template.Class cl) {
        return _template().getClassIndex(cl);
    }

    public int getNumClasses() {
        return _template().getNumClasses();
    }

    public boolean isMemberClass(Template.Class cl) {
        return _template().isMemberClass(cl);
    }

    public Class getClassByPosInDs(int posInProfile) {
        return _template().getClassByPosInDs(posInProfile);
    }

    public String getClassOfInterestName() {
        return _template().getClassOfInterestName();
    }

    public Class getClassOfInterest() {
        return _template().getClassOfInterest();
    }

    public Color getItemColor(int itemProfilePos) {
        return _template().getItemColor(itemProfilePos);
    }

    public int getClassOfInterestIndex() {
        return _template().getClassOfInterestIndex();
    }

    public Template cloneDeep() {
        return _template().cloneDeep();
    }

    public Template cloneDeep(String newName) {
        return _template().cloneDeep(newName);
    }

    public boolean equalsShallow(final Template t) {
        return _template().equalsShallow(t);
    }

    public boolean isAscendingProfilePositions() {
        return _template().isAscendingProfilePositions();
    }

    public boolean isClassesContiguous() {
        return _template().isClassesContiguous();
    }

    public boolean isAux() {
        return _template().isAux();
    }

    public boolean isContinuous() {
        return _template().isContinuous();
    }

    public Template.Item getItem(int itemIndex) {
        return _template().getItem(itemIndex);
    }

    public Template.Item getItemByProfilePosition(int primPos) {
        return _template().getItemByProfilePosition(primPos);
    }

    public boolean hasItemWithId(String id) {
        return _template().hasItemWithId(id);
    }

    public int getNumItems() {
        return _template().getNumItems();
    }

    public Vector toVector() {
        return _template().toVector();
    }

    public String getAsString() {
        return _template().getAsString();
    }

    public Vector[] splitByTemplateClass(final Vector profile) {
        return _template().splitByTemplateClass(profile);
    }

    public Set[] splitByTemplateClass(final java.util.List colNames) {
        return _template().splitByTemplateClass(colNames);
    }

    public String getSampleName(final Template.Item item, final Dataset inDataset) {
        return _template().getSampleName(item, inDataset);
    }

    public Map createSampleNameTemplateItem(final Dataset ds) {
        return _template().createSampleNameTemplateItem(ds);
    }

    public Map createSampleNameSampleClassNameMap(final Dataset ds) {
        return _template().createSampleNameSampleClassNameMap(ds);
    }

    public Map createSampleNameSampleClass(Dataset ds) {
        return _template().createSampleNameSampleClass(ds);
    }
    */


}
