package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.genome.math.*;

import java.awt.*;

/**
 * @author Aravind Subramanian
 *         Date: Dec 16, 2005
 *         Time: 8:07:03 PM
 */
public class ColorDatasetFromRankedListsAsRows extends RankedListsAsRowsDataset implements ColorDataset {

    private ColorScheme fColorScheme;

    /**
     * Class constructor
     *
     * @param name
     * @param rls
     */
    public ColorDatasetFromRankedListsAsRows(final String name, final RankedList[] rls, final ColorScheme cs) {
        super(name, rls);
        this.fColorScheme = cs;
    }

    public ColorDataset cloneState(final Dataset ds) {
        throw new NotImplementedException();
    }

    public Color getColor(final int row, final int col) {
        float x = getElement(row, col);
        Vector rowv = getRow(row);
        return Helper.computeRelativeMeanColor(x, rowv.min(), rowv.max(), rowv.mean(), DEFAULT_GRAPH_MODE, fColorScheme, false);
    }

    public ColorScheme getColorScheme() {
        return fColorScheme;
    }

    public Orientation getOrientation() {
        return DEFAULT_ORIENTATION;
    }

    public GraphMode getGraphMode() {
        return DEFAULT_GRAPH_MODE;
    }

    public ScaleMode getScaleMode() {
        return DEFAULT_SCALE_MODE;
    }

} // End class RankedListsColorDataset
