package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.objects.strucs.NamedColor;

import java.awt.*;

/**
 * @author Aravind Subramanian
 *         Date: Nov 18, 2005
 *         Time: 1:56:33 PM
 */
public interface ColorMap {

    public static interface Rows {
        // rows have NO intrinsic order so dont proivide that in the API

        public Color getColor(final String rowName, final String colName);

        public Color getColor(final String rowName, final int c);

        public String getColName(final int col);

        public String getValue(final String rowName, final String colName);

        public String getValue(final String rowName, final int col);

        public int getNumCol();

        //; if the map contains symbols or probe sets
        public boolean isInSymbols(int col);

    }

    public static interface Columns {

        public Color getColor(final String categFieldName);

        public Color getColor(final String rowName, final String colName);

        public String getValue(final String rowName, final String colName);

        public int getNumRow();

        public String getRowName(final int row);

        public String[] getRowNames();

        public NamedColor[] getLegend(final String categName);

    }


} // End class ColorMap
