package edu.mit.broad.genome.objects;

import java.awt.*;
import java.util.Map;

/**
 * @author Aravind Subramanian
 *         Date: Aug 10, 2006
 *         Time: 10:14:30 PM
 */

public class ColorMapRowImpl_for_neighbors implements ColorMap.Rows {

    private ColorMap.Rows fOrig;

    private Map geneNameColorMap;

    private static final String MY_COL_NAME = "GENE_VECTOR";

    /**
     * Class constructor
     *
     * @param cmr
     * @param geneNameColorMap
     */
    public ColorMapRowImpl_for_neighbors(final ColorMap.Rows cmr,
                                         final Map geneNameColorMap) {

        if (cmr == null) {
            throw new IllegalArgumentException("Param cmr cannot be null");
        }

        if (geneNameColorMap == null) {
            throw new IllegalArgumentException("Param geneNameColorMap cannot be null");
        }

        this.fOrig = cmr;
        this.geneNameColorMap = geneNameColorMap;
    }

    public Color getColor(final String rowName, final String colName) {

        if (colName.equals(MY_COL_NAME)) {
            if (geneNameColorMap.containsKey(rowName)) {
                return (Color) geneNameColorMap.get(rowName);
            } else {
                throw new IllegalStateException("huh >" + rowName + "<");
                //return Color.BLACK;
            }
        } else {
            return fOrig.getColor(rowName, colName);
        }
    }

    public Color getColor(final String rowName, final int c) {
        if (c == 0) {
            if (geneNameColorMap.containsKey(rowName)) {
                return (Color) geneNameColorMap.get(rowName);
            } else {
                throw new IllegalStateException("huh >" + rowName + "<");
                //return Color.BLACK;
            }
        } else {
            return fOrig.getColor(rowName, c - 1);
        }
    }

    public String getColName(final int col) {
        if (col == 0) {
            return MY_COL_NAME;
        } else {
            return fOrig.getColName(col - 1);
        }
    }

    public String getValue(final String rowName, final String colName) {
        if (colName.equals(MY_COL_NAME)) {
            return "";
        } else {
            return fOrig.getValue(rowName, colName);
        }
    }

    public String getValue(final String rowName, final int col) {
        if (col == 0) {
            return "";
        } else {
            return fOrig.getValue(rowName, col - 1);
        }
    }

    public int getNumCol() {
        return fOrig.getNumCol() + 1;
    }

    public boolean isInSymbols(int col) {
        if (col == 0) {
            return false;
        } else {
            return true;
        }
    }

} // End class ColorMapRowImpl_for_neighbors
