package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.objects.strucs.NamedColor;

import java.awt.*;
import java.util.HashMap;
import java.util.Map;

/**
 * @author Aravind Subramanian
 *         Date: Jan 20, 2006
 *         Time: 8:24:19 AM
 */
public class ColumnsImpl implements ColorMap.Columns {

    private NamedColor[] fNamedColors;

    private Map fName_nc_Map;

    /**
     * Class constructor
     *
     * @param sampleNames
     */
    public ColumnsImpl(final String[] sampleNames) {
        NamedColor[] ncs = new NamedColor[sampleNames.length];
        for (int i = 0; i < sampleNames.length; i++) {
            ncs[i] = new NamedColor(sampleNames[i], Color.WHITE);
        }

        this.init(ncs);
    }

    /**
     * Class constructor
     *
     * @param ncs
     */
    public ColumnsImpl(final NamedColor[] ncs) {
        init(ncs);
    }

    private void init(final NamedColor[] ncs) {

        if (ncs == null) {
            throw new IllegalArgumentException("Param ncs cannot be null");
        }

        this.fNamedColors = ncs;
        this.fName_nc_Map = new HashMap();
        for (int i = 0; i < ncs.length; i++) {
            fName_nc_Map.put(ncs[i].getName(), ncs[i]);
        }
    }

    public Color getColor(final String categFieldName) {
        return Color.WHITE; // huh
    }

    public Color getColor(final String rowName, final String colName) {
        Object obj = fName_nc_Map.get(colName);
        if (obj == null) {
            return Color.WHITE;
        } else {
            return ((NamedColor) obj).getColor();
        }
    }

    public String getValue(final String rowName, final String colName) {
        return rowName;
    }

    public int getNumRow() {
        return 1;
    }

    public String getRowName(final int row) {
        return "SAMPLE";
    }

    public String[] getRowNames() {
        return new String[]{"SAMPLE"};
    }

    public NamedColor[] getLegend(final String categName) {
        return fNamedColors;
    }

} // End inner class WhiteColumns
