/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.NamingConventions;

/**
 * simple container for a Dataset and a Template
 * Intentionally (for simplicity) public vars
 */
public class DT {

    public String name;
    public Dataset ds;
    public Template t;

    /**
     * Class constructor
     *
     * @param name
     * @param ds
     * @param t
     */
    public DT(String name, Dataset ds, Template t) {
        this.name = name;
        this.ds = ds;
        this.t = t;
    }

    /**
     * Class constructor
     *
     * @param ds
     * @param t
     */
    public DT(Dataset ds, Template t) {
        this(NamingConventions.generateName(ds, t, true), ds, t);
    }

} // End class DT

