/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

/**
 * @author Aravind Subramanian
 *         Date: Feb 15, 2003
 *         Time: 7:19:05 PM
 */
public class DefaultRankedFeature implements RankedFeature {

    private final String fName;

    private final int fRank;

    private float fScore;

    /**
     * Class constructor
     *
     * @param name
     * @param rank
     */
    public DefaultRankedFeature(String name, int rank) {
        this(name, rank, Float.NaN);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param rank
     * @param score
     */
    public DefaultRankedFeature(String name, int rank, float score) {
        this.fName = name;
        this.fRank = rank;
        this.fScore = score;
    }

    public String getName() {
        return fName;
    }

    public int getRank() {
        return fRank;
    }

    public float getScore() {
        return fScore;
    }

} // End DefaultDatasetFeature
