package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.objects.strucs.Linked;
import edu.mit.broad.vdb.chip.Chip;

/**
 * @author Aravind Subramanian
 *         Date: Aug 10, 2006
 *         Time: 10:21:16 PM
 */
public class FeatureAnnotImpl2 extends AbstractObject implements FeatureAnnot {

    private FeatureAnnot fFa;

    private ColorMap.Rows fCmr;

    /**
     * Class constructor
     *
     * @param fa
     * @param cmr
     */
    public FeatureAnnotImpl2(final FeatureAnnot fa, final ColorMap.Rows cmr) {
        super(fa.getName());
        this.fFa = fa;
        this.fCmr = cmr;
    }

    public ColorMap.Rows getColorMap() {
        return fCmr;
    }

    // -------------------------------------------------------------------------------------------- //
    // ----------------------------------- REST ARE WRAPPERS -------------------------------------- //
    // -------------------------------------------------------------------------------------------- //

    public String getQuickInfo() {
        return fFa.getQuickInfo();
    }

    public String[] getNames() {
        return fFa.getNames();
    }

    public int getNumFeatures() {
        return fFa.getNumFeatures();
    }

    public String getNativeDesc(final String featureName) {
        return fFa.getNativeDesc(featureName);
    }

    public boolean hasNativeDescriptions() {
        return fFa.hasNativeDescriptions();
    }

    public String getGeneSymbol(final String featureName) {
        return fFa.getGeneSymbol(featureName);
    }

    public String getGeneTitle(final String featureName) {
        return fFa.getGeneTitle(featureName);
    }

    public Chip getChip() {
        return fFa.getChip();
    }

    public void setChip(final Chip chip, ColorMap.Rows cmr) {
        fFa.setChip(chip, cmr);
    }

    public Linked getLink(final String featureName) {
        return fFa.getLink(featureName);
    }

} // End class FeatureAnnotImpl2


