package edu.mit.broad.genome.objects;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Aravind Subramanian
 *         Date: Jul 16, 2005
 *         Time: 12:28:33 AM
 */
public interface GeneSetPair {

    public String getName();

    public GeneSet getUp();

    public GeneSet getDown();

    public GeneSet getBoth();

    public GeneSetPair cloneShallow(String newName);

    public GeneSet get(boolean up);


    public static class Helper {

        public static GeneSet[] toGeneSets(final GeneSetPair[] pairs, final boolean up) {

            GeneSet[] gsets = new GeneSet[pairs.length];

            for (int i = 0; i < pairs.length; i++) {
                gsets[i] = pairs[i].get(up);
            }

            return gsets;
        }

        public static GeneSet createSet(final GeneSetPair[] pairs, final boolean up) {

            List list = new ArrayList();

            for (int i = 0; i < pairs.length; i++) {
                list.addAll(pairs[i].get(up).getMembers());
            }

            return new FSet("all", list, false); // @note false for dupes hack
        }

        public static GeneSetMatrix createMatrix(final GeneSetPair[] pairs, final boolean up) {

            List list = new ArrayList();

            for (int i = 0; i < pairs.length; i++) {
                list.add(pairs[i].get(up));
            }

            return new DefaultGeneSetMatrix("all", list);
        }

        public static GeneSetMatrix createMatrix(final GeneSetPair[] pairs) {

            List list = new ArrayList();

            for (int i = 0; i < pairs.length; i++) {
                list.add(pairs[i].getUp());
                list.add(pairs[i].getDown());
            }

            return new DefaultGeneSetMatrix("all", list);
        }
    }


} // End interface GeneSetPair
