package edu.mit.broad.genome.objects;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Aravind Subramanian
 *         Date: Jul 16, 2005
 *         Time: 12:34:51 AM
 */
public class GeneSetPairImpl implements GeneSetPair {

    private String fName;

    private GeneSet up;
    private GeneSet dn;

    // @todo review
    public GeneSetPair cloneShallow(String newName) {
        this.fName = newName;
        return this;
    }

    /**
     * Class constructor
     *
     * @param name
     * @param up
     * @param dn
     */
    public GeneSetPairImpl(String name, GeneSet up, GeneSet dn) {
        this.fName = name;
        this.up = up;
        this.dn = dn;
    }

    /**
     * Class constructor
     *
     * @param up
     * @param dn
     */
    public GeneSetPairImpl(GeneSet up, GeneSet dn) {
        //this(up.getName(true) + "_" + dn.getName(true), up, dn);
        this(_nameHack(up, dn), up, dn);
    }

    public String getName() {
        return fName;
    }

    public GeneSet getUp() {
        return up;
    }

    public GeneSet get(boolean up) {
        if (up) {
            return getUp();
        } else {
            return getDown();
        }
    }

    public GeneSet getBoth() {
        List both = new ArrayList();
        both.addAll(up.getMembers());
        both.addAll(dn.getMembers());
        return new FSet(getName(), both, true);
        // dont do this as it jumbles up the order
        //return new FSet(getName(), new GeneSet[]{getUp(), getDown()});
    }

    public GeneSet getDown() {
        return dn;
    }

    private static String _nh(String name, String[] things) {

        for (int i = 0; i < things.length; i++) {
            int index = name.indexOf(things[i]);
            if (index != -1) {
                return name.substring(0, index);
            }
        }

        for (int i = 0; i < things.length; i++) {
            int index = name.indexOf(things[i].toUpperCase());
            if (index != -1) {
                return name.substring(0, index);
            }
        }

        for (int i = 0; i < things.length; i++) {
            int index = name.indexOf(things[i].toLowerCase());
            if (index != -1) {
                return name.substring(0, index);
            }
        }

        return name;
    }

    private static String[] ss = new String[]{"_UP", "_DN", "_TOP", "_BOT"};

    private static String _nameHack(GeneSet up, GeneSet dn) {

        //System.out.println("### CHECKING NAME HACK: " + up.getName(true) + " " + dn.getName(true));

        String up_name = up.getName(true);
        up_name = _nh(up_name, ss);
        String dn_name = dn.getName(true);
        dn_name = _nh(dn_name, ss);

        if (up_name.equals(dn_name)) {
            return up_name;
        } else {
            return up.getName(true) + "_" + dn.getName(true);
        }
    }

} // End class GeneSetPairImpl

