/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;


/**
 * @author Aravind Subramanian
 *         Date: Nov 2, 2003
 *         Time: 7:06:03 PM
 */
public interface GeneSetSignal {

    // DONT ADD GET ORIGINAL GENESET

    public int getSize();

    public GeneSet getAsGeneSet();

    public float getMetricAtMax();

    public String getName();

    public int getRankAtMax();

    // % of gene tags before (for + es) or after (for -ve es)
    // the peak in the res// Thus the larger the % the more tags in the gene set
    // contribute to the final es
    public float getTagFraction();

    // in the gene list
    public float getListFraction();

    public float getSignalStrength();


} // End interface GeneSetSignal
