/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

import java.util.List;

/**
 * @author Aravind Subramanian
 *         Date: Apr 9, 2004
 *         Time: 12:55:43 PM
 */
public interface IDataframe extends PersistentObject {

    public Object getElementObj(int rown, int coln);

    public String getRowName(int rown);

    public List getRowNames();

    public int getRowIndex(String rowName);

    public String[] getRowNamesArray();

    public List getColumnNames();

    public int getColumnIndex(String colName);

    public String[] getColumnNamesArray();

    public String getColumnName(int coln);

    public String[] getColumnAsStrings(int coln);

    public String[] getColumnAsStrings(final String colName);

    public int getNumRow();

    public int getNumCol();

    // -------------------------------------------------------------------------------------------- //
    // -------------------------------------------------------------------------------------------- //
    // -------------------------------------------------------------------------------------------- //

    static class Helper {

        public static String[] getColumnAsStrings(IDataframe idf, int coln) {

            String[] ss = new String[idf.getNumRow()];
            for (int r = 0; r < idf.getNumRow(); r++) {
                Object obj = idf.getElementObj(r, coln);
                if (obj != null) {
                    ss[r] = obj.toString();
                } else {
                    ss[r] = null;
                }
            }

            return ss;
        }

        public static String[] getColumnAsStrings(IDataframe idf, final String colName) {
            return getColumnAsStrings(idf, idf.getColumnIndex(colName));
        }

    }

} // End IDataframe
