/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

import java.util.ArrayList;

/**
 * @author Aravind Subramanian
 *         Date: Feb 12, 2005
 *         Time: 8:06:15 PM
 */
public class ProbePreTemplate extends AbstractPreTemplate {

    private String fJustProbeName;

    /**
     * Class constructor
     *
     * @param pts
     */
    public ProbePreTemplate(final String sourceFileName, final String justProbeName) {
        super(sourceFileName + "#" + justProbeName); // name doesnt matter as invisible
        this.fJustProbeName = justProbeName;
    }

    public Template createTemplate(Dataset ds) {
        return TemplateFactory.createContinuousTemplate(fJustProbeName, ds);
    }

    public boolean isContinuous() {
        return true; // @note always
    }

    public boolean isCategorical() {
        return false;
    }

    public boolean isAux() {
        return true; // doesnt matter what
    }

    public boolean isSampleNamesFromDataset() {
        return false;
    }

} // End class ProbePreTemplate
