/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.math.MetricStats;
import edu.mit.broad.genome.math.Order;
import edu.mit.broad.genome.math.SortMode;
import edu.mit.broad.genome.math.Vector;

/**
 * @author Aravind Subramanian
 *         Date: Feb 9, 2004
 *         Time: 2:16:17 PM
 */

public interface QuickNeighDataset extends Dataset {

    public MetricStats getMetricStats(int rown);

    public MetricStats getMetricStats(String rowName);

    // SUB-CLASSES MUST IMPLEMENT
    public MetricStats createMetricStats(final Vector v);

    public RankedList getRankedList(final String probeName, final SortMode sort, final Order order);

    public GeneSet getNeighborsUpOrDn(final String featureName, final int num, final boolean up);

    public GeneSetPair getNeighborsUpAndDn(final String featureName, final int num);

} // End dataset QuickNeighborhoodDataset


