package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.genome.math.MetricStats;
import edu.mit.broad.genome.math.Order;
import edu.mit.broad.genome.math.SortMode;
import edu.mit.broad.genome.math.Vector;

import java.util.List;
import java.util.Random;

/**
 * @author Aravind Subramanian
 *         Date: Jun 7, 2005
 *         Time: 12:15:07 PM
 */
public class QuickNeighSubdataset extends AbstractNeighDataset {

    private GeneSet fIncludeSpace;
    //private List fIncludeSpaceList;

    private QuickNeighDataset fOrigQds;

    /**
     * @param ds
     * @param hood
     * @todo IMPROVE
     */
    public QuickNeighSubdataset(final QuickNeighDataset qds, final GeneSet includeGenes) {
        super();
        this.fIncludeSpace = includeGenes;
        //this.fIncludeSpaceList = includeGenes.getMembers();
        this.fOrigQds = qds;
    }

    public QuickNeighSubdataset(final QuickNeighDataset qds) {
        super();
        this.fIncludeSpace = qds.getRowNamesGeneSet();
        this.fOrigQds = qds;
    }

    public MetricStats getMetricStats(int rown) {
        String name = fIncludeSpace.getMember(rown);
        return getMetricStats(name);
    }

    public MetricStats getMetricStats(String rowName) {
        return fOrigQds.getMetricStats(rowName);
    }

    public Annot getAnnot() {
        throw new NotImplementedException();
    }

    // SUB-CLASSES MUST IMPLEMENT
    public MetricStats createMetricStats(Vector v) {
        throw new NotImplementedException();
    }

    public RankedList getRankedList(final String probeName, final SortMode sort, final Order order) {
        throw new NotImplementedException();
    }

    static Random krandom = new Random();

    public String getRandomMember() {
        int rndIndex = krandom.nextInt(getNumRow());
        return fIncludeSpace.getMember(rndIndex);
    }

    //------------------------------------------------------------------------------------
    //-------------------- REST ARE MUNDANE DATASET IMPLEMENTATIONS ---------------------
    //------------------------------------------------------------------------------------

    public Vector getRow(int rown) {
        throw new NotImplementedException();
    }

    public float getElement(int rown, int coln) {
        throw new NotImplementedException();
    }

    public float getElement(final int row, final String colName) {
        return getElement(row, getColumnIndex(colName));
    }

    public float getElement(final String rowName, final int col) {
        return getElement(getRowIndex(rowName), col);
    }

    public float getElement(final String rowName, final String colName) {
        return getElement(getRowIndex(rowName), getColumnIndex(colName));
    }

    public String getRowName(int rown) {
        return fIncludeSpace.getMember(rown);
    }

    public Vector getRow(String rowName) {
        throw new NotImplementedException();
    }

    public Vector[] getRows(GeneSet gset) {
        throw new NotImplementedException();
    }

    public List getRowNames() {
        return fIncludeSpace.getMembers();
    }

    public int getRowIndex(String rowname) {
        throw new NotImplementedException();
    }

    public String[] getRowNamesArray() {
        return fIncludeSpace.getMembersArray();
    }

    public int getNumRow() {
        return fIncludeSpace.getNumMembers();
    }

    public GeneSet getRowNamesGeneSet() {
        return fIncludeSpace;
    }

} // End class QuickNeighborhoodSubdataset

