package edu.mit.broad.genome.objects;

import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.genome.objects.strucs.Linked;
import edu.mit.broad.genome.objects.strucs.NamedColor;
import edu.mit.broad.genome.reports.web.LinkedFactory;
import edu.mit.broad.vdb.chip.Chip;
import edu.mit.broad.vdb.sampledb.Category;
import edu.mit.broad.vdb.sampledb.Sample;
import edu.mit.broad.vdb.sampledb.SampleAnnot;

import java.awt.*;
import java.util.*;
import java.util.List;

/**
 * @author Aravind Subramanian
 *         Date: Nov 21, 2005
 *         Time: 4:48:35 PM
 */
public class SampleAnnotImpl extends AbstractObject implements SampleAnnot {

    private List fSampleNames;

    private ColorMap.Columns fColorMap;

    public TemplateFromAnnot createTemplate(final String categoryName) throws Exception {
        throw new NotImplementedException();
    }

    public String[] getSampleNames_OrderByCategory(final String categName) {
        return getSampleNames();
    }

    public String[] getSampleNames_OrderByDefaultCategory() {
        return getSampleNames();
    }

    public Comparator createDefaultStateComparator(String categName) {
        throw new NotImplementedException();
    }

    public String[] orderStateNames(final String[] inputStateNames, final String categName) {
        throw new NotImplementedException();
    }

    public Dataset orderStateNames(final Dataset dsWithStatesAsColNames, final String categName) {
        throw new NotImplementedException();
    }

    public String[] orderByDefaultCategory(final String[] inputCelOrSampleNames) {
        throw new NotImplementedException();
    }

    public String[] orderByCategory(final String[] inputSampleNames, final String categName) {
        throw new NotImplementedException();
    }

    public void orderByCategory(final List inputSampleNames, final String categName) {
        throw new NotImplementedException();
    }

    public Dataset orderByDefaultCategory(final Dataset ds) {
        throw new NotImplementedException();
    }

    public Dataset orderByCategory(final Dataset ds, final String categName) {
        throw new NotImplementedException();
    }

    public Comparator createDefaultSampleComparator() {
        throw new NotImplementedException();
    }

    // for ALL Categories
    public TemplateFromAnnot[] createAllTemplates() throws Exception {
        throw new NotImplementedException();
    }

    public SampleAnnot createRandomAnnot() {
        return createRandomAnnot(getSampleNames());
    }

    public SampleAnnot createRandomAnnot(final String[] useOnlyTheseSamples) {
        throw new NotImplementedException();
    }

    public String getStateName(final String categoryName, final Sample sample) {
        throw new NotImplementedException();
    }

    // ------------------------------------------------------------------------------- //
    // ------------------------------- CATEGORY METHODS ------------------------------- //
    // ------------------------------------------------------------------------------- //

    public String[] getAllCategoricalCategoryNames() {
        throw new NotImplementedException();
    }

    public boolean isValidCategoricalCategory(final String categoryName) {
        throw new NotImplementedException();
    }

    //public String[] getAllCategoryNames();

    //public boolean isCategoryName(final String categName);

    public Category[] createAllCategories() {
        throw new NotImplementedException();
    }

    // For ALL states
    public Category createCategory(final String categoryName) {
        throw new NotImplementedException();
    }

    // for ALL samples
    public Category createCategory(final String categoryName, final Set forTheseStateNames) {
        throw new NotImplementedException();
    }

    // for ALL samples
    public Category createCategory(final String categoryName, final String[] forTheseStateNames) {
        throw new NotImplementedException();
    }


    public Sample getSample(String name) {
        throw new NotImplementedException();
    }

    public Sample[] getSamples(String[] name) {
        throw new NotImplementedException();
    }

    public Sample[] getSamples(String name, String b) {
        throw new NotImplementedException();
    }

    public String[] getSampleNames(String name, String b) {
        throw new NotImplementedException();
    }

    public String[] getCelFileNames(String name, String b) {
        throw new NotImplementedException();
    }

    public String[] getCelFileNames(String name) {
        throw new NotImplementedException();
    }

    public String[] getCelFileNames(String[] name) {
        throw new NotImplementedException();
    }

    public Chip getChip(String name) {
        throw new NotImplementedException();
    }

    public Chip getChip() {
        throw new NotImplementedException();
    }

    public Chip getChip(String[] foo) {
        throw new NotImplementedException();
    }

    public Chip getChip(TemplateFromAnnot ta) {
        throw new NotImplementedException();
    }

    public String[] getSampleNames(String name, String[] b) {
        throw new NotImplementedException();
    }

    public List getSamples_list(final int[] indices) {
        throw new NotImplementedException();
    }

    public Sample[] getSamples() {
        throw new NotImplementedException();
    }

    public Sample[] getSamples(final int[] indices) {
        throw new NotImplementedException();
    }


    public int getSampleIndex(final Sample sample) {
        throw new NotImplementedException();
    }

    public int getSampleIndex(final String sampleName) {
        throw new NotImplementedException();
    }

    public boolean isSample(final String cellFileOrSampleName) {
        throw new NotImplementedException();
    }

    public List getSampleNames_list(final int[] indices) {
        throw new NotImplementedException();
    }

    public Map getCelFileSampleNameMap() {
        Map map = new HashMap();
        for (int i = 0; i < getNumSamples(); i++) {

            String cfn = getSample(i).getCelFileName();
            String sn = getSample(i).getName();
            map.put(cfn.toUpperCase(), sn);
            //map.put(cfn.toLowerCase(), sn);
            if (cfn.toUpperCase().endsWith(".CEL") == false) {
                map.put(cfn.toUpperCase() + ".CEL", sn);
                //map.put(cfn.toLowerCase() + ".cel", getSample(i).getName());
            }

        }

        log.debug(">>>> " + map);

        return map;
    }


    /**
     * Class constructor
     *
     * @param sampleNames
     */
    public SampleAnnotImpl(final String name, final List sampleNames, final ColorMap.Columns cm_opt) {
        initHere(name, sampleNames, cm_opt);
    }

    /**
     * Class constructor
     *
     * @param name
     * @param sampleNames
     * @param cm_opt
     */
    public SampleAnnotImpl(final String name, final String[] sampleNames, final ColorMap.Columns cm_opt) {
        if (sampleNames == null) {
            throw new IllegalArgumentException("Param sampleNames cannot be null");
        }

        List names = new ArrayList();
        for (int i = 0; i < sampleNames.length; i++) {
            names.add(sampleNames[i]);
        }

        initHere(name, names, cm_opt);
    }

    // does the core init
    private void initHere(final String name, final List sampleNames, final ColorMap.Columns cm_opt) {
        super.initialize(name);
        if (sampleNames == null) {
            throw new IllegalArgumentException("Param sampleNames cannot be null");
        }

        /*
        if (cm == null) {
            throw new IllegalArgumentException("Param cm cannot be null");
        }
        */

        this.fSampleNames = sampleNames;

        if (cm_opt == null) {
            this.fColorMap = new ColumnsNull();
        } else {
            this.fColorMap = cm_opt;
        }
    }

    public Chip getChip(Dataset ds) {
        throw new NotImplementedException(); // @huh
    }

    public SampleAnnot cloneDeep(final String newName, final String[] useOnlyTheseSamples) {
        return new SampleAnnotImpl(newName, useOnlyTheseSamples, new ColumnsImpl(useOnlyTheseSamples));
    }

    public SampleAnnot cloneDeep(final String[] useOnlyTheseSamples) {
        return cloneDeep(getName() + "resr_" + useOnlyTheseSamples.length, useOnlyTheseSamples);
    }

    public SampleAnnot cloneDeep(final Chip onlyFromThisChip) {
        List useSampleNames = new ArrayList();

        for (int i = 0; i < getNumSamples(); i++) {
            Sample sample = getSample(i);
            if (sample.getChip().equals(onlyFromThisChip)) {
                useSampleNames.add(sample.getName());
            }
        }

        return cloneDeep(getName() + "_" + onlyFromThisChip.getName(), (String[]) useSampleNames.toArray(new String[useSampleNames.size()]));
    }

    // -------------------------------------------------------------------------------------------- //

    public String getQuickInfo() {
        return null;
    }

    public Sample getSample(int i) {
        throw new NotImplementedException();
    }

    public ColorMap.Columns getColorMap() {
        return fColorMap;
    }

    public int getNumSamples() {
        return fSampleNames.size();
    }

    public String[] getSampleNames() {
        return (String[]) fSampleNames.toArray(new String[fSampleNames.size()]);
    }

    public List getSampleNames_list() {
        return fSampleNames;
    }

    public String[] getCelFileNames() {
        throw new NotImplementedException();
    }

    public String getSampleName(final String celFileName) {
        throw new NotImplementedException();
    }

    public String[] getSampleNames(final String[] celFileNames) {
        throw new NotImplementedException();
    }

    public Linked getLink(final String sampleName) {
        return LinkedFactory.createLinkedGeneSymbol(sampleName); // @todo
    }


    class ColumnsNull implements ColorMap.Columns {

        public Color getColor(final String categFieldName) {
            return Color.WHITE;
        }

        public Color getColor(final String rowName, final String colName) {
            return Color.WHITE;
        }

        public String getValue(final String rowName, final String colName) {
            return colName + "_" + rowName;
        }

        public int getNumRow() {
            return 1;
        }

        public String getRowName(final int row) {
            return "SampleName";
        }

        public String[] getRowNames() {
            return new String[]{"SampleName"};
        }

        public NamedColor[] getLegend(final String categName) {
            return new NamedColor[]{new NamedColor("name", Color.WHITE)};
        }

    } // End class ColumnsNull

} // End class SampleAnnotImpl
