/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

import java.util.List;
import java.util.Set;

/**
 * @author Aravind Subramanian
 *         Date: Nov 27, 2003
 *         Time: 1:20:54 PM
 */
public interface SignalMatrix extends GeneSetMatrix {

    public int getNumSignals();

    /**
     * return a ref to the real GeneSetSignal
     *
     * @param i
     * @return
     */
    public GeneSetSignal getSignal(int s);

    public GeneSetSignal getSignal(final String signalName);

    /**
     * All genesets
     * directly -- no cloning
     *
     * @return
     */
    public GeneSetSignal[] getSignals();

    public List getSignalsL();

    public GeneSetSignal[] getSignals(Set gsetOfSignalNames);

    public GeneSetMatrix getOriginalGeneSetMatrix();

    public GeneSet getOriginalGeneSet(String gsetName);

} // End interface SignalMatrix
