/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects;

/**
 * @author Aravind Subramanian
 *         Date: Mar 19, 2003
 *         Time: 9:40:54 PM
 */
// struc

public class TemplateMode {


    public static final TemplateMode CATEGORICAL_2_CLASS_ONLY = new TemplateMode(0, "Categorical, 2 class only");
    public static final TemplateMode CATEGORICAL_2_CLASS_AND_NUMERIC = new TemplateMode(3, "Categorical 2 class and numeric");
    public static final TemplateMode CATEGORICAL_ONLY = new TemplateMode(1, "Categorical template only");
    public static final TemplateMode CONTINUOUS_ONLY = new TemplateMode(2, "Continuous template only");

    public static final TemplateMode UNIPHASE_ONLY = new TemplateMode(7, "Uniclass templates only");

    public static final TemplateMode ALL = new TemplateMode(10, "All modes of Templates");

    private int fMode;
    private String fDesc;

    /**
     * Class constructor
     *
     * @param mode
     * @param desc
     */
    TemplateMode(int mode, String desc) {
        this.fMode = mode;
        this.fDesc = desc;
    }

    public String getDesc() {
        return fDesc;
    }

} // End class TemplateMode
