package edu.mit.broad.genome.objects.esmatrix.db;

import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.genome.objects.PersistentObject;

import java.util.List;

/**
 * @author Aravind Subramanian
 *         Date: Jan 21, 2006
 *         Time: 9:13:52 PM
 * @todo need a better name
 */
public interface EnrichmentDbMulti extends PersistentObject {

    public EnrichmentDbMulti cloneDeep(final String newName,
                                       final String[] useOnlyTheseGeneSetNames,
                                       final String[] useOnlyTheseComps);

    public EnrichmentDbMulti cloneDeep(final String newName, final String[] useOnlyTheseComps);

    public EnrichmentDbMulti cloneDeep(final String[] useOnlyTheseComp);

    public EnrichmentDbMulti cloneDeep_gs(final String newName, final String[] useOnlyTheseGeneSets);

    public EnrichmentDbMulti cloneDeep(final Dataset essDataset);

    // -------------------------------------------------------------------------------------------- //

    public Dataset getESSDataset();

    // @note not always available
    public Dataset getNESSDataset();

    // @note not always available
    public Dataset getFDRDataset();

    // @note not always available
    public Dataset getNPDataset();


    // The number of edbs
    public int getNumEdbs();

    public EnrichmentDb getEdb(final int i);

    public EnrichmentDb getEdb(final String name);

    public int getNumRow();

    public EnrichmentDb[] getEdbs(final String[] edbNames);

    public EnrichmentDb[] getEdbs(final int[] colIndices);

    // -------------------------------------------------------------------------------------------- //

    //public EnrichmentResult getResult(final String gsetName, final String compName);

    public EnrichmentResult[] getResults(final String gsetName); // across all comps

    // -------------------------------------------------------------------------------------------- //

    public List getRowNames();

    public GeneSet getRowNamesGeneSet();

    public String[] getRowNamesArray();

// -------------------------------------------------------------------------------------------- //

    public List getEdbNames();

    public GeneSet getEdbNamesGeneSet();

    public String[] getEdbNamesArray();

    public String getEdbName(final int coln);

    public int getEdbIndex(final String colName);

} //End class EnrichmentMultiDb

/*

public static interface Extracted {

    public RankedList getRankedList();

    public ScoredDataset getScoredDataset();

    public Template getTemplate();

    public String getName();

} // End interface Extracted

// -------------------------------------------------------------------------------------------- //

public Dataset createDataset(final String name, final int[] rlColIndices);

public Dataset createDataset(final String name, final String[] rlColNames);

// -------------------------------------------------------------------------------------------- //

public Extracted extract(final String rlName);

public Extracted extract(final int coln);

public Extracted extract(final String rlName, final GeneSet gset);

public Extracted extract(final int colIndex, final GeneSet gset);

public Extracted extract(final String rlName, final int upAndDnX);

public Extracted extract(final int colIndex, final int upAndDnX);



//public Vector[] getColumns(final String[] colNames);

// public DatasetTemplate getDatasetTemplate(final TemplateCohort.Comp comp);

//public SampleAnnot getSampleAnnot();
//public Annot getAnnot();

public Dataset getDataset();

public Chip getChip();

public Annot getAnnot();

// -------------------------------------------------------------------------------------------- //
// @note disabled because these can take a long time to execute
//public Vector getRow(final String rowName);

// @note disabled because these can take a long time to execute
//public Vector[] getRows(final GeneSet gset);

// -------------------------------------------------------------------------------------------- //

public RankedList getRankedList(final int coln);

public RankedList getRankedList(final String rlName);

public RankedList[] getRankedLists(final String[] rlNames);

public RankedList[] getRankedLists(final int[] colIndices);


public static class OrderedSampleNames {

    public String[] names;

    public GeneSet[] namesByRl;

}


public OrderedSampleNames getSampleNames(final int[] rlIndices, final boolean classA);

//public String[] getSampleNames(final String[] rlNames, final boolean classA);

// -------------------------------------------------------------------------------------------- //

public List getRowNames();

public GeneSet getRowNamesGeneSet();

public String[] getRowNamesArray();

// @note These have no meaning in this context
// public Vector getRow(final int rown);
//public int getRowIndex(final String rowName);
//public String getRowName(final int rown);

// -------------------------------------------------------------------------------------------- //

public List getRankedListNames();

public GeneSet getRankedListNamesGeneSet();

public String[] getRankedListNamesArray();

public String getRankedListName(final int coln);

public int getRankedListIndex(final String colName);

// -------------------------------------------------------------------------------------------- //



*/