package edu.mit.broad.genome.objects.esmatrix.db;

import edu.mit.broad.genome.reports.EnrichmentCharts;
import edu.mit.broad.genome.reports.pages.HtmlPage;

import java.io.File;

/**
 * @author Aravind Subramanian
 *         Date: Dec 12, 2005
 *         Time: 5:41:55 PM
 */
public class EnrichmentReportImpl implements EnrichmentReport {

    private File fPlotFile;

    private File fHtmlFile;

    private EnrichmentCharts fChart;

    private HtmlPage fHtmlPage;

    public EnrichmentReportImpl(final File htmlFile, final File plotFile) {
        this.fPlotFile = plotFile;
        this.fHtmlFile = htmlFile;
    }


    public EnrichmentReportImpl(final EnrichmentCharts chart, final HtmlPage htmlPage) {
        this.fChart = chart;
        this.fHtmlPage = htmlPage;
    }

    public File getESPlotFile() {
        return fPlotFile;
    }

    public File getHtmlFile() {
        return fHtmlFile;
    }

    public EnrichmentCharts getESCharts() {
        return fChart;
    }

    public HtmlPage getHtmlPage() {
        return fHtmlPage;
    }


} // End class EnrichmentResultReportImpl
