/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects.strucs;

import org.apache.ecs.Element;
import org.apache.ecs.html.A;
import org.apache.ecs.html.TD;


/**
 * @author Aravind Subramanian
 *         Date: Sep 17, 2003
 *         Time: 5:50:32 PM
 *         <p/>
 *         // kept here to avoid the vdb loader constraints
 */
public interface Linked {

    public String getText();

    public Hyperlink createDefaultLink();

    public Hyperlink[] createAllLinks();

    public TD toTD(boolean onlyDefault, String targetOpt);

    public Element toA_default(String targetOpt);

    public Element[] toA_all(String targetOpt);


    /**
     * Helper class for shared
     * utility functions
     */
    static class LinkedHelper {

        public static TD toTD(boolean onlyDefault, String targetOpt, Linked linked) {
            TD td = new TD();
            if (onlyDefault) {
                td.addElement(toA_default(targetOpt, linked));
            } else {
                Element[] a = toA_all(targetOpt, linked);
                for (int i = 0; i < a.length; i++) {
                    if (targetOpt != null && a[i] instanceof A) {
                        ((A) a[i]).setTarget(targetOpt);
                    }
                    td.addElement(a[i]);
                    if (i != a.length - 1) {
                        td.addElement("|");
                    }
                }
            }

            return td;
        }

        public static Element toA_default(String targetOpt, Linked linked) {
            return linked.createDefaultLink().toA(targetOpt);
        }

        public static Element[] toA_all(String targetOpt, Linked linked) {
            Hyperlink[] links = linked.createAllLinks();
            Element[] a = new Element[links.length];
            for (int i = 0; i < a.length; i++) {
                a[i] = links[i].toA(targetOpt);
            }

            return a;
        }

    } // End class LinkedHelper


} // End interface Linked
