/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.objects.strucs;


import java.awt.*;


/**
 * A color and its common english name
 * <p> </p>
 * <p> </p>
 * <p> </p>
 * <p> </p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class NamedColor {

    public final String name;
    public final Color color;

    /**
     * Class constructor
     *
     * @param name
     * @param color
     */
    public NamedColor(String name, Color color) {
        this.name = name;
        this.color = color;
    }

    public String getName() {
        return name;
    }

    public Color getColor() {
        return color;
    }

    public int hashCode() {
        return toString().hashCode();
    }

    public String toString() {
        return name + color;
    }

    public boolean equals(Object obj) {
        if (obj instanceof NamedColor) {
            NamedColor nc = (NamedColor) obj;
            if (nc.name.equals(name) && nc.color.equals(color)) {
                return true;
            }
        }

        return false;
    }

    public static String[] toNames(final NamedColor[] ncs) {
        String[] names = new String[ncs.length];
        for (int r = 0; r < ncs.length; r++) {
            names[r] = ncs[r].name;
        }

        return names;
    }

    public static Color[] toColors(final NamedColor[] ncs) {
        Color[] colors = new Color[ncs.length];
        for (int r = 0; r < ncs.length; r++) {
            colors[r] = ncs[r].color;
        }

        return colors;
    }

} // End class NamedColor

/*--- Formatted in Sun Java Convention Style on Fri, Nov 15, '02 ---*/
