package edu.mit.broad.genome.parsers;

import edu.mit.broad.genome.Constants;
import edu.mit.broad.genome.NamingConventions;
import edu.mit.broad.genome.NotImplementedException;
import edu.mit.broad.genome.math.StringMatrix;
import edu.mit.broad.genome.objects.PersistentObject;
import edu.mit.broad.genome.objects.StringDataframe;
import edu.mit.broad.genome.objects.Template;

import java.io.File;
import java.io.InputStream;
import java.util.List;

/**
 * Parses a data store in cls by sample name
 */
public class ClsBySampleNameParser extends AbstractParser implements Constants {

    /**
     * Class Constructor.
     */
    public ClsBySampleNameParser() {
        super(Template.class);
    }

    public void export(final PersistentObject template, final File file) throws Exception {

        throw new NotImplementedException(); // @todo
    }

    public void export(final String classAName, final String[] classASampleNames,
                       final String classBName, final String[] classBSampleNames,
                       final File toFile) throws Exception {

        final String[] colNames = new String[]{"CLASS"};

        final String[] rowNames = new String[classASampleNames.length + classBSampleNames.length];
        final StringMatrix sm = new StringMatrix(classASampleNames.length + classBSampleNames.length, 1);
        int rowCnt = 0;
        for (int r = 0; r < classASampleNames.length; r++) {
            rowNames[rowCnt] = classASampleNames[r];
            sm.setElement(rowCnt++, 0, classAName);
        }

        for (int r = 0; r < classBSampleNames.length; r++) {
            rowNames[rowCnt] = classBSampleNames[r];
            sm.setElement(rowCnt++, 0, classBName);
        }

        final StringDataframeParser sdfp = new StringDataframeParser();
        final String name = NamingConventions.removeExtension(toFile.getName());
        sdfp.export(new StringDataframe(name, sm, rowNames, colNames, true), toFile);

        doneExport();
    }


    /**
     * @param file
     * @return The first line that is NOT empty nor a comment line
     * @throws ParserException
     */
    public List parse(final String fileName, final InputStream is) throws Exception {

        /*
        StringDataframeParser sdfp = new StringDataframeParser();



        startImport(fileName);

        BufferedReader bin = new BufferedReader(new InputStreamReader(is));
        String firstLine = nextNonEmptyLine(bin);


        return null;

        */

        throw new NotImplementedException(); // @todo
    }

}    // End Cls2Parser

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/