package edu.mit.broad.genome.parsers;

import edu.mit.broad.genome.objects.PersistentObject;
import edu.mit.broad.genome.objects.esmatrix.db.EnrichmentDb;
import edu.mit.broad.genome.objects.esmatrix.db.EnrichmentDbMulti;

import java.io.File;
import java.io.InputStream;
import java.util.List;


/**
 * called a "folder" parser because works / makes a folder
 * <p/>
 * <p/>
 * Makes a folder called "edb" with:
 * <p/>
 * edb_multi/
 * rl1_name.edb
 * rl2_name.edb
 * rl3_name.edb
 * ...
 * <p/>
 * NO templates or gex stored
 */
public class EdbFolderMultiParser extends AbstractParser {

    // -------------------------------------------------------------------------------------------- //

    public EdbFolderMultiParser() {
        super(EnrichmentDbMulti.class);
    }

    public EnrichmentDbMulti parseEdbMulti(final File parentDir) throws Exception {

        /*
        if (parentDir.exists() == false || parentDir.isDirectory() == false) {
            throw new ParserException("Invalid dir for parsing ... expecting a dir, got: " + parentDir);
        }

        final File edb_dir = new File(parentDir, "edb_multi");
        if (edb_dir.exists() == false) {
            throw new IllegalArgumentException("edb_multi dir not found: " + edb_dir);
        }

        final File edb_file = new File(edb_dir, EDB_FILE_NAME);
        if (edb_file.exists() == false) {
            throw new IllegalArgumentException("edb file not found: " + edb_file);
        }


        final EnrichmentResult[] results = (EnrichmentResult[]) dtgs.toArray(new EnrichmentResult[dtgs.size()]);
        final EnrichmentDb edb = new EnrichmentDbImpl_one_shared_rl(edb_file.getPath(), results, lvp, metric, mps, sort, order, numPerms);
        edb.addComment(fComment.toString());
        doneImport();
        return edb;
        */

        return null;
    }


    // The top level gsea result dir
    public List parse(String sourcepath, InputStream fis) throws Exception {
        startImport(sourcepath);
        //EnrichmentDb edb = parseEdb(new File(sourcepath));
        //return unmodlist(edb);

        return null;
    }

    // dont make reports (thats not my job)
    public void export(final PersistentObject pob_edb, final File gseaResultDir) throws Exception {
        if (pob_edb == null) {
            throw new IllegalArgumentException("Param pob_edb cannot be null");
        }

        final EnrichmentDb edb = (EnrichmentDb) pob_edb;

        if (gseaResultDir == null) {
            throw new IllegalArgumentException("Param foo cannot be null: " + gseaResultDir);
        }

        if (gseaResultDir.exists() == false) {
            boolean made = gseaResultDir.mkdir();
            if (!made) {
                throw new IllegalArgumentException("Could not make gsea result dir: " + gseaResultDir);
            }
        }

        // now the sub dir
        final File edb_dir = new File(gseaResultDir, "edb");
        if (edb_dir.exists() == false) {
            boolean made = edb_dir.mkdir();
            if (!made) {
                throw new IllegalArgumentException("Could not make edb dir: " + edb_dir);
            }
        }


        doneExport();
    }

}    // End of class EdbParser

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
