/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.parsers;

import edu.mit.broad.genome.math.Matrix;
import edu.mit.broad.genome.objects.PersistentObject;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;

/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class MatrixParser extends AbstractParser {

    /**
     * Class Constructor.
     */
    public MatrixParser() {
        super(Matrix.class);
    }

    public void export(PersistentObject pob, File file) throws Exception {

        MiscParsers.save((Matrix) pob, file);

        doneExport();

    }    // End export

    /**
     *
     *
     */
    public List parse(String hackINeedFullPath, InputStream is) throws Exception {

        startImport(hackINeedFullPath);

        BufferedReader bin = new BufferedReader(new InputStreamReader(is));

        Matrix mat = MiscParsers.parseMatrix(bin, false);

        log.debug("Done reading: " + mat.getQuickInfo());

        bin.close();

        doneImport();
        return unmodlist(new PersistentObject[]{mat});
    }

}    // End MatrixParser
