/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.parsers;


import edu.mit.broad.genome.objects.PersistentObject;

import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;


/**
 * Basic interface for a Parser.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public interface Parser {

    /**
     * Parser the source and produce one or more objects
     */
    public List parse(String objname, File file) throws Exception;

    /**
     * sourcepath is the path to the where the data is coming from
     */
    public List parse(String sourcepath, InputStream is) throws Exception;

    /**
     * Save the specified pob to a store
     */
    public void export(PersistentObject pob, File file) throws Exception;

    public void export(PersistentObject pob, OutputStream os) throws Exception;

    public Class getRepresentationClass();

    public void setSilentMode(boolean silent);

}    // End Parser

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
