/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.reports;

import edu.mit.broad.genome.objects.strucs.Hyperlink;
import org.apache.ecs.Element;
import org.apache.ecs.StringElement;
import org.apache.ecs.html.A;
import org.apache.ecs.html.TD;

/**
 * @author Aravind Subramanian
 *         Date: Sep 17, 2003
 *         Time: 6:11:46 PM
 */
public class DefaultHyperlink implements Hyperlink {

    private String fDispName;

    private String fUrl;

    /**
     * Class constructor
     *
     * @param dispName
     * @param url
     */
    public DefaultHyperlink(final String dispName, final String url) {
        this.fDispName = dispName;
        this.fUrl = url;
    }

    public String getURL() {
        return fUrl;
    }

    public String getDisplayName() {
        return fDispName;
    }

    public Element toA(final String targetOpt) {
        if (getURL() == null || getURL().length() == 0) {
            return new StringElement(getDisplayName()); // NO URL possible
        }

        A a = new A(getURL(), getDisplayName());
        if (targetOpt != null) {
            a.setTarget(targetOpt);
        }

        return a;
    }

    public TD toTD(String targetOpt) {
        return new TD().addElement(toA(targetOpt));
    }

} // End class DefaultHyperlink
