package edu.mit.broad.genome.reports;

import edu.mit.broad.genome.charts.XChart;
import edu.mit.broad.genome.charts.XComboChart;
import edu.mit.broad.genome.charts.XComboRangeChart;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Aravind Subramanian
 *         Date: Jan 22, 2006
 *         Time: 3:33:21 PM
 */
public class EnrichmentCharts {

    public XChart esProfileChart;
    public XChart hitProfileChart;
    public XChart hitProfileWithBgChart;
    public XChart rlProfileChart;

    public XComboChart comboChart;

    protected EnrichmentCharts(XChart esProfileChart,
                               XChart hitProfileChart,
                               XChart hitProfileWithBgChart,
                               XChart rlProfileChart,
                               XComboChart comboChart
    ) {

        this.esProfileChart = esProfileChart;
        this.hitProfileChart = hitProfileChart;
        this.hitProfileWithBgChart = hitProfileWithBgChart;
        this.rlProfileChart = rlProfileChart;
        this.comboChart = comboChart;
    }

    public XComboChart squish() {

        return new XComboRangeChart("foo", "bar", "foo", "dd",
                new XChart[]{esProfileChart, hitProfileChart, hitProfileWithBgChart, rlProfileChart},
                new int[]{1, 1, 1, 1});

    }

    public static XComboChart squish(final EnrichmentCharts[] ecs) {

        List charts = new ArrayList();
        for (int i = 0; i < ecs.length; i++) {
            EnrichmentCharts es = ecs[i];
            charts.add(es.esProfileChart);
            charts.add(es.hitProfileChart);
            charts.add(es.hitProfileWithBgChart);
            charts.add(es.rlProfileChart);
        }

        return new XComboRangeChart("foo", "bar", "foo", "dd",
                (XChart[]) charts.toArray(new XChart[charts.size()])
        );

    }

}
