/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.reports;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * More than one element per elment!
 */
public class MultiElement {

    private List fElements;

    /**
     * Class constructor
     */
    public MultiElement() {
        this.fElements = new ArrayList();
    }

    // permits all elements, including null
    public void add(String s) {
        fElements.add(s);
    }

    public void add(int s) {
        fElements.add(new Integer(s));
    }

    public void add(Collection coll) {
        fElements.add(coll);
    }

    /*
    public String toString() {
        if (fElements.size() == 1) {
            return fElements.get(0).toString();
        } else {
           return new NullSafeStringBuffer(fElements, true, Constants.INTRA_FIELD_DELIM).toString();
        }
    }
    */

    public int getSize() {
        return fElements.size();
    }

    public boolean isEmpty() {
        return fElements.isEmpty();
    }

} // End MultiElement
