/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.reports.api;

import edu.mit.broad.genome.objects.PersistentObject;

import java.io.File;
import java.net.URI;
import java.util.Properties;

/**
 * Read-Only interface for a Report eg reports already done
 * <p/>
 * Keep this here for junits clas slinker stuff
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */

public interface Report extends PersistentObject {

    public static final String PRODUCER_CLASS_ENTRY = "producer_class";

    public static final String TIMESTAMP_ENTRY = "producer_timestamp";

    public static final String FILE_ENTRY = "file";

    public static final String PARAM_ENTRY = "param";

    public File[] getFilesProduced();

    public Properties getParametersUsed();

    public Class getProducer();

    public String getProducerName();

    public long getTimestamp();

    public int getNumPagesMade();

    public void setErroredOut();

    public URI getReportIndex();

    public File getReportDir();

} // End Report

