/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.reports.pages;

import edu.mit.broad.genome.NamingConventions;
import edu.mit.broad.genome.reports.api.PicFile;
import org.apache.ecs.html.A;

import java.io.File;
import java.io.OutputStream;

/**
 *
 */
public class FileWrapperPage implements Page {

    private String fDesc;
    private String fName;
    private File fFile;

    /**
     * Class constructor
     *
     * @param name
     * @param desc
     */
    public FileWrapperPage(File file, String desc) {
        this.fDesc = desc;
        this.fName = file.getName();
        this.fFile = file;
    }

    public File getFile() {
        return fFile;
    }

    public String getName() {
        return fName;
    }

    public String getExt() {
        return NamingConventions.getExtension(fFile);
    }

    public String getDesc() {
        return fDesc;
    }

    public A createLink(final File rptDir, final String optStandardBase) {
        A link = new A().addElement(getName());

        if (optStandardBase != null) {
            HtmlFormat.Links.setHref(link, getFile(), optStandardBase + "/" + rptDir.getName());
        } else {
            //log.debug("report dir is: " + fReportDir);
            HtmlFormat.Links.setHref(link, getFile(), rptDir);
        }
        return link;
    }

    // does nothing
    public PicFile[] write(OutputStream os, File parentDir) throws Exception {
        return new PicFile[]{};
    }

} // End class FileWrapperPage
