/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

package edu.mit.broad.genome.swing;


import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;


/**
 * A convenience event handling class for deciding when to show and when not to show
 * a JPopupMenu based on the type of the MouseEvent.
 * <p/>
 * Classs must implement maybeShowPopup
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public abstract class GPopupChecker extends MouseAdapter {

    public void mousePressed(MouseEvent e) {
        maybeShowPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
        maybeShowPopup(e);
    }

    protected abstract void maybeShowPopup(MouseEvent e);

    /* EXAMPLE
    protected void maybeShowPopup(MouseEvent e) {
       if (e.isPopupTrigger()) {
           if (fooo ...) {
               popup.show(e.getComponent(), e.getX(), e.getY());
               }
           }
       }
   }
   */
}    // End GPopupChecker

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
