/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing;


import javax.swing.*;


/**
 * <p> </p>
 * <p> </p>
 * <p> </p>
 * <p> </p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class GStartPauseButton extends JButton {

    private final Icon start = GuiHelper.ICON_START16;
    private final Icon pause = GuiHelper.ICON_PAUSE16;
    private String fText;
    private boolean fShowText = true;
    public static final int RESUME_MODE = 1;
    public static final int PAUSE_MODE = 10;
    private static final String START = "Start";
    private static final String PAUSE = "Pause";

    /**
     * Class constructor
     *
     * @param initMode
     */
    public GStartPauseButton(int initMode, boolean showtext) {

        super();

        this.fShowText = showtext;

        this.setMode(initMode);
    }

    public boolean isInStartMode() {
        return (fText.equals(START));
    }

    public boolean isInPauseMode() {
        return (fText.equals(PAUSE));
    }

    public void setShowText(boolean show) {
        fShowText = show;
    }

    public void setMode(int mode) {

        if (mode == RESUME_MODE) {
            this.fText = START;

            this.setIcon(start);
        } else {
            this.fText = PAUSE;

            this.setIcon(pause);
        }

        if (fShowText) {
            this.setText(fText);
        }
    }
}    // End GStartPauseButton

/*--- Formatted in Sun Java Convention Style on Sun, Oct 27, '02 ---*/
