/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing;


import javax.swing.*;
import java.awt.*;
import java.awt.geom.AffineTransform;


/**
 * see for anothrr impl: http://www.jalice.net/vertical.htm)
 * <p/>
 * uses graphics2d to draw a text string in a jpanle wertically.
 * <p/>
 * to resues a jvt, first construct, then call setText() this auto redrawas.
 * <p/>
 * NOT MADE GENERIC ENUF YET - tuned and tested for BpogRenderer only
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class GVerticalLabel extends JPanel {

    private Font fFont = new Font("Helvetica", Font.PLAIN, 8);    // default
    private String text = "";

    /**
     * default is white
     */
    private static final Color COLOR_FG = Color.white;

    /**
     * Class Constructor.
     */
    public GVerticalLabel() {
        this.setForeground(COLOR_FG);
    }

    /**
     * Class Constructor.
     */
    public GVerticalLabel(String text) {

        this();

        this.text = text;
    }

    /**
     * Using graphics2D so that the labels can be displayed rotated
     * x -> -3px helps center the text a little better
     */
    public void setText(String text) {

        this.text = text;

        this.repaint();
    }

    public void paintComponent(Graphics g) {

        Graphics2D g2 = (Graphics2D) g;

        g2.fillRect(0, 0, this.getWidth(), this.getHeight());    // this needs to be there for the fg color to show up

        //Oriented from top to bottom
        g2.setColor(Color.black);
        g2.setFont(fFont);

        AffineTransform at = AffineTransform.getRotateInstance(Math.toRadians(90));

        g2.transform(at);
        //g2.drawString(text, this.getWidth() / 2, 0);    // this paramter is imp -> change it and things can diossepear
        g2.drawString(text, 0, 0);
        g2.dispose();

        //System.out.println(" >>> " + text);
        // ortiented from bototm to top - doesnt work yet

        /*
        g2.setColor(Color.black);
        AffineTransform at = AffineTransform.getRotateInstance(Math.toRadians(270));
        g2.transform(at);
        g2.drawString(text, 0, -5); // this paramter is imp -> change it and things can diossepear
        g2.dispose();
        */
    }

    public void setFont(Font font) {
        fFont = font;
    }

    public Font getFont() {
        return fFont;
    }
}    // End of class GVerticalLabel

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
