/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing;

import javax.swing.*;
import java.awt.*;

/**
 * Original code from jgoodies SimpleInternalFrame
 * <p/>
 *
 * @author Aravind Subramanian
 *         Date: Mar 6, 2005
 *         Time: 7:02:58 PM
 */
// A panel with a horizontal gradient background.
public class GradientPanel extends JPanel {

    private Color fGradientColor = UIManager.getColor("control");

    public GradientPanel(final LayoutManager lm, final Color background) {
        super(lm);
        setBackground(background);
    }

    public GradientPanel(final LayoutManager lm, final Color background, final Color gradient) {
        super(lm);
        setBackground(background);
        if (gradient != null) {
            this.fGradientColor = gradient;
        }
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        if (!isOpaque()) {
            return;
        }

        int width = getWidth();
        int height = getHeight();

        Graphics2D g2 = (Graphics2D) g;
        Paint storedPaint = g2.getPaint();
        g2.setPaint(new GradientPaint(0, 0, getBackground(), width, 0, fGradientColor));
        g2.fillRect(0, 0, width, height);
        g2.setPaint(storedPaint);
    }
}
