/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing.fields;

import javax.swing.*;

/**
 * Turns a JCheckBox into a GFieldPlusChooser
 * <p> </p>
 * <p> </p>
 * <p> </p>
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */

public class GCheckBoxField implements GFieldPlusChooser {

    private final JCheckBox fCx;

    /**
     * Class Constructor.
     */
    public GCheckBoxField(final JCheckBox cx) {
        this.fCx = cx;
        fCx.setHorizontalAlignment(SwingUtilities.CENTER);
    }

    public Object getValue() {
        return Boolean.valueOf(fCx.isSelected());
    }

    public JComponent getComponent() {
        return fCx;
    }

    public JCheckBox getJCheckBox() {
        return fCx;
    }

    public boolean isSelected() {
        return fCx.isSelected();
    }

    public void setValue(Object obj) {

        boolean b;

        if (obj == null) {
            b = false;
        } else if (obj instanceof Boolean) {
            b = ((Boolean) obj).booleanValue();
        } else {
            b = Boolean.valueOf(obj.toString()).booleanValue();
        }

        fCx.setSelected(b);
    }

} // End GCheckBoxField
