/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing.fields;

import javax.swing.*;


/**
 * Turns a JComboBox into a GFieldPlusChooser
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */

public class GComboBoxField implements GFieldPlusChooser {

    private final JComboBox fBox;

    /**
     * @param box
     */
    public GComboBoxField(JComboBox box) {
        this.fBox = box;
    }

    public Object getValue() {

        return fBox.getSelectedItem();
    }

    public JComponent getComponent() {
        return fBox;
    }

    public JComboBox getComboBox() {
        return fBox;
    }

    public void setValue(Object obj) {
        fBox.setSelectedItem(obj);
    }

} // End GComboBoxField