/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing.image;

import javax.swing.*;
import java.net.URL;

/**
 * an image icon that can be custom sized
 */
public class IconCustomSized extends ImageIcon {

    private final int width;
    private final int height;

    /**
     * @param url
     * @param width
     * @param height
     */
    public IconCustomSized(URL url, int width, int height) {
        super(url);

        this.width = width;
        this.height = height;
    }

    public int getIconWidth() {
        return width;
    }

    public int getIconHeight() {
        return height;
    }

}


