/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing.image;

import java.awt.*;

/**
 * Container for a BufferedImage and its name
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */

public class NamedImage {

    private final String fName;

    private final Image fBi;

    /**
     * Class Constructor.
     *
     * @param name
     * @param bi
     */
    public NamedImage(String name, Image bi) {
        this.fBi = bi;
        this.fName = name;
    }

    public String getName() {
        return fName;
    }

    public Image getImage() {
        return fBi;
    }

    public String toString() {
        return "Image " + fName;
    }

    public boolean equals(Object obj) {
        if (obj instanceof NamedImage) {
            return equals((NamedImage) obj);
        }
        return false;
    }

    public boolean equals(NamedImage obj) {

        if (obj.fBi == this.fBi) {
            return true;
        } else {
            return false;
        }

    }

    public int hashCode() {
        return fBi.hashCode();
    }

} // End NamedImage
