package edu.mit.broad.genome.swing.windows;

import edu.mit.broad.genome.swing.GBase;
import edu.mit.broad.genome.swing.choosers.GTableInputFieldPlusChooser;
import edu.mit.broad.xbench.core.api.DialogDescriptor;


/**
 * Window wrapper for a JTextArea
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class GTableWindow extends GBase {

    private static final String TITLE = "Specify values, one per column (first line is header)";

    private GTableInputFieldPlusChooser chooser;

    /**
     * Class Constructor.
     *
     * @param options
     */
    public GTableWindow(final GTableInputFieldPlusChooser chooser) {
        this.chooser = chooser;
    }

    /**
     * @return value selected or null is user cancelled
     */
    public String show() {

        //System.out.println(">>>>>>>>");
        DialogDescriptor desc = createDialogDescriptor(TITLE, chooser.getComponentForWindow(), null);

        int res = desc.show();

        if (res == DialogDescriptor.CANCEL_OPTION) {
            return null;
        } else {
            return DialogDescriptor.OK_OPTION + "";
        }
    }

}        // End GTableWindow

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
