/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.swing.windows;


import edu.mit.broad.genome.swing.GBase;
import edu.mit.broad.xbench.core.api.Application;
import edu.mit.broad.xbench.core.api.DialogDescriptor;

import javax.swing.*;
import java.awt.*;


/**
 * Window wrapper for a JTextArea
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class GTextAreaWindow extends GBase {

    private final JTextArea taEntry;

    private static final String TITLE = "Specify values, one per line (spaces NOT allowed)";

    /**
     * Class Constructor.
     */
    public GTextAreaWindow() {
        this("");
    }

    /**
     * Class Constructor.
     *
     * @param options
     */
    public GTextAreaWindow(String curr) {
        taEntry = new JTextArea(curr);
    }

    /**
     * returns null if user cancelled selection
     */
    public String show(String text) {
        taEntry.setText(text);
        return show();
    }

    private Dimension fPrevSize;

    /**
     * @return value selected or null is user cancelled
     */
    public String show() {

        DialogDescriptor desc = Application.getWindowManager().createDialogDescriptor(TITLE, new JScrollPane(taEntry));

        int res = desc.show();

        if (res == DialogDescriptor.CANCEL_OPTION) {
            return null;
        } else {
            return taEntry.getText();
        }
    }

}        // End GTextAreaWindow

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
