/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.utils;


/**
 * <p> </p>
 * <p> </p>
 * <p> </p>
 * <p> </p>
 *
 * @author Brian Goetz
 * @version %I%, %G%
 * @see http://www.javaworld.com/javaworld/jw-09-2001/jw-0914-exceptions-p2.html
 */
public class ChainedRuntimeException extends RuntimeException {

    private Throwable cause = null;

    public ChainedRuntimeException() {
        super();
    }

    public ChainedRuntimeException(String message) {
        super(message);
    }

    public ChainedRuntimeException(String message, Throwable cause) {

        super(message);

        this.cause = cause;
    }

    public ChainedRuntimeException(Throwable cause) {
        this(cause.getMessage(), cause);
    }

    public Throwable getCause() {
        return cause;
    }

    public void printStackTrace() {

        super.printStackTrace();

        if (cause != null) {
            System.err.println("Caused by:");
            cause.printStackTrace();
        }
    }

    public void printStackTrace(java.io.PrintStream ps) {

        super.printStackTrace(ps);

        if (cause != null) {
            ps.println("Caused by:");
            cause.printStackTrace(ps);
        }
    }

    public void printStackTrace(java.io.PrintWriter pw) {

        super.printStackTrace(pw);

        if (cause != null) {
            pw.println("Caused by:");
            cause.printStackTrace(pw);
        }
    }
}

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
