/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.utils;


/**
 * For use by classes that wich to make an object immutable.
 * (in cases where the 2 class object iimmuatbelobject pattern is hard
 * (or unintuitive) to implement
 * <p/>
 * Immuted -> made immutable
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class ImmutedException extends ChainedRuntimeException {

    public ImmutedException() {
        super("This object is immutable or has been immuted and hence this method cannot be called");
    }

}    // End ImmutedException

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
