/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.utils;

/**
 * Useful constants for months.  Note that these are NOT equivalent to the
 * constants defined by java.util.Calendar (where JANUARY=0 and DECEMBER=11).
 * <p/>
 * Used by the SerialDate and RegularTimePeriod classes.
 *
 * @author David Gilbert
 */
public interface MonthConstants {

    /**
     * Constant for January.
     */
    public static final int JANUARY = 1;

    /**
     * Constant for February.
     */
    public static final int FEBRUARY = 2;

    /**
     * Constant for March.
     */
    public static final int MARCH = 3;

    /**
     * Constant for April.
     */
    public static final int APRIL = 4;

    /**
     * Constant for May.
     */
    public static final int MAY = 5;

    /**
     * Constant for June.
     */
    public static final int JUNE = 6;

    /**
     * Constant for July.
     */
    public static final int JULY = 7;

    /**
     * Constant for August.
     */
    public static final int AUGUST = 8;

    /**
     * Constant for September.
     */
    public static final int SEPTEMBER = 9;

    /**
     * Constant for October.
     */
    public static final int OCTOBER = 10;

    /**
     * Constant for November.
     */
    public static final int NOVEMBER = 11;

    /**
     * Constant for December.
     */
    public static final int DECEMBER = 12;

}
