/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.utils;

/**
 * @author Aravind Subramanian
 *         Date: Mar 29, 2003
 *         Time: 8:23:54 PM
 */
public class NamedInteger {

    private int fValue;
    private String fName;

    /**
     * Class constructor
     *
     * @param value
     * @param name
     */
    public NamedInteger(int value, String name) {
        this.fValue = value;
        this.fName = name;
    }

    public String getName() {
        return fName;
    }

    public int getValue() {
        return fValue;
    }

    public String toString() {
        return fName;
    }

    /**
     * IMP to note that equality os determined solely on basis of
     * the int value
     *
     * @param obj
     * @return
     */
    public boolean equals(Object obj) {

        if (obj instanceof NamedInteger) {
            return equals(((NamedInteger) obj).fValue);
        } else if (obj instanceof Number) {
            return equals(((Number) obj).intValue());
        } else {
            return false;
        }

    }

    public boolean equals(int val) {
        return val == fValue;
    }

} // End class NamedInteger
