/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

package edu.mit.broad.genome.utils;


/**
 * Tags a checked exception as Parsing related.
 * Designed for use with ParseUtils.java.
 * <p/>
 * Note: This is for use with simple (i.e single-method parsing operations
 * do not confuse with the ParserException class).
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 * @see edu.mit.broad.genome.parsers.ParseUtils.java
 * @see ParserException.java
 */

// Imp that this be a checked exception as Parse errors tend to be show-stoppers.
public class ParseException extends ChainedException {

    /**
     * Construct a new <code>ParseException</code> instance.
     *
     * @param message The detail message for this exception.
     */
    public ParseException(final String message) {
        super(message);
    }

    /**
     * Construct a new <code>ParseException</code> instance.
     *
     * @param message   The detail message for this exception.
     * @param throwable the root cause of the exception
     */
    public ParseException(final String message, final Throwable throwable) {
        super(message, throwable);
    }

    /**
     * Construct a new <code>ParseException</code> instance.
     *
     * @param throwable the root cause of the exception
     */
    public ParseException(final Throwable throwable) {
        super(throwable);
    }
}    // End ParseException

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
