/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.utils;


/**
 * Performs some predicate which returns true or false based on the input object.
 * Predicate instances can be used to implement queries or to do filtering.
 * <p/>
 * Predicate -> To make a statement or assertion
 *
 * @author <a href="mailto:jstrachan@apache.org">James Strachan</a>
 */
public interface Predicate {

    /**
     * @return true if the input object matches this predicate, else returns false
     */
    public boolean evaluate(Object input);
}

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
