/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.utils.containers;


import javax.swing.*;


/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class ClassNamePair {

    private final Class fClass;
    private final String fName;
    private Icon fIcon;

    /**
     * Class Constructor.
     */
    public ClassNamePair(Class cl, String name) {
        this.fClass = cl;
        this.fName = name;
    }

    public ClassNamePair(Class cl, String name, Icon icon) {

        this.fClass = cl;
        this.fName = name;
        this.fIcon = icon;
    }

    public ClassNamePair(String name) {
        this.fClass = Object.class;
        this.fName = name;
    }

    public String getPairName() {
        return fName;
    }

    public Class getPairClass() {
        return fClass;
    }

    public Icon getPairIcon() {
        return fIcon;
    }

    public String toString() {
        return fName;
    }
}    // End ClassNamePair

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
