/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */

package edu.mit.broad.genome.utils.containers;


/**
 * Object that encapsulates a String. Simply to designate a String as a Password.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class Password extends MutableString implements java.io.Serializable {

    /**
     * Class Constructor.
     * <p/>
     * Creates a new Password with null content.
     */
    public Password() {
        super();
    }

    /**
     * Class Constructor.
     * <p/>
     * Creates a new Password initialized to specified string
     */
    public Password(String str) {
        super(str);
    }

    /**
     * @return The password
     */
    public String getPassword() {
        return getValue();
    }

    /**
     * Changes the password
     */
    public void setPassword(String newpasswd) {
        setValue(newpasswd);
    }
}    // End Password

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
