/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.objects.Dataset;
import edu.mit.broad.xbench.actions.ObjectAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class DatasetViewerAction extends ObjectAction {

    private Dataset fDataset;

    /**
     * Class Constructor.
     */
    public DatasetViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }

    /**
     * Class Constructor.
     *
     * @param ds
     */
    public DatasetViewerAction(Dataset ds) {
        super();

        this.fDataset = ds;
    }

    public void setObject(Object ds) {
        this.fDataset = (Dataset) ds;
    }

    public Widget getWidget() {
        return new DatasetViewer(fDataset);
    }

    public String getId() {
        return "DatasetViewerAction";
    }

    public String getName() {
        return DatasetViewer.NAME;
    }

    public String getDescription() {
        return "View Dataset";
    }

    public Icon getIcon() {
        return DatasetViewer.ICON;
    }
}    // End DatasetViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
