/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.objects.GeneSetMatrix;
import edu.mit.broad.xbench.actions.ObjectAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class GeneSetMatrixViewerAction extends ObjectAction {

    private GeneSetMatrix fGeneSetMatrix;

    /**
     * Class Constructor.
     */
    public GeneSetMatrixViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getName());
    }

    /**
     * Class Constructor.
     *
     * @param ds
     */
    public GeneSetMatrixViewerAction(GeneSetMatrix ds) {
        super();

        this.fGeneSetMatrix = ds;
    }

    public void setObject(Object ds) {
        this.fGeneSetMatrix = (GeneSetMatrix) ds;
    }

    public Widget getWidget() {
        return new GeneSetMatrixViewer2(fGeneSetMatrix);
        //return new GeneSetMatrixViewer(fGeneSetMatrix);
    }

    public String getId() {
        return "GeneSetMatrixViewerAction";
    }

    public String getName() {
        return GeneSetMatrixViewer2.NAME;
    }

    public Icon getIcon() {
        return GeneSetMatrixViewer2.ICON;
    }

    public String getDescription() {
        return "View GeneSetMatrix";
    }
}    // End GeneSetMatrixViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
