/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.JarResources;
import edu.mit.broad.genome.models.GeneSetModel;
import edu.mit.broad.genome.objects.GeneSet;

import javax.swing.*;
import java.awt.*;


/**
 * FSet viewer.
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class GeneSetViewer extends AbstractViewer {

    public static final String NAME = "GeneSetViewer";

    public static final Icon ICON = JarResources.getIcon("Grp.gif");

    private GeneSet fGeneSet;

    /**
     * Builds a Viewer on specified FSet object
     *
     * @param gset
     */
    public GeneSetViewer(final GeneSet gset) {
        super(NAME, ICON, gset);

        this.fGeneSet = gset;

        jbInit();
    }

    private void jbInit() {
        GeneSetModel model = new GeneSetModel(fGeneSet);
        JTable table = createTable(model, true, true);
        setColumnSize(100, 1, table, false);
        this.setLayout(new BorderLayout());
        this.add(createExcelScrollPane(table, fGeneSet), BorderLayout.CENTER);
        this.revalidate();

    }

    public JMenuBar getJMenuBar() {
        return EMPTY_MENU_BAR;
    }

}        // End FSetViewer

/*--- Formatted in Sun Java Convention Style on Thu, Oct 17, '02 ---*/
