/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.objects.FSet;
import edu.mit.broad.genome.objects.GeneSet;
import edu.mit.broad.xbench.actions.ObjectAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class GeneSetViewerAction extends ObjectAction {

    private GeneSet fGeneSet;

    /**
     * Class constructor
     */
    public GeneSetViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }


    /**
     * Class constructor
     *
     * @param gset
     */
    public GeneSetViewerAction(GeneSet gset) {

        this();

        this.fGeneSet = gset;
    }

    public void setObject(Object obj) {
        this.fGeneSet = (FSet) obj;
    }

    public Widget getWidget() {
        return new GeneSetViewer(fGeneSet);

    }

    public String getId() {
        return "GeneSetViewerAction";
    }

    public String getName() {
        return GeneSetViewer.NAME;
    }

    public Icon getIcon() {
        return GeneSetViewer.ICON;
    }

    public String getDescription() {
        return "View the Gene Set";
    }
}    // End GeneSetViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
