/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.objects.Template;
import edu.mit.broad.xbench.actions.ObjectAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class PhenotypeViewerAction extends ObjectAction {

    private Template fTemplate;

    /**
     * Class Constructor
     */
    public PhenotypeViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }


    /**
     * Class Constructor
     *
     * @param template
     */
    public PhenotypeViewerAction(final Template template) {

        this();

        this.fTemplate = template;
    }

    public void setObject(final Object template) {
        this.fTemplate = (Template) template;
    }

    public Widget getWidget() {
        return new PhenotypeViewer(fTemplate);
    }

    public String getId() {
        return "PhenotypeViewerAction";
    }

    public String getName() {
        return "Phenotype viewer";
    }

    public Icon getIcon() {
        return PhenotypeViewer.ICON;
    }

    public String getDescription() {
        return "View details about this phenotype";
    }
}    // End TemplateViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
