/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.objects.RankedList;
import edu.mit.broad.xbench.actions.ObjectAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class RankedListViewerAction extends ObjectAction {

    private RankedList fRankedList;

    /**
     * Class constructor
     */
    public RankedListViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }


    /**
     * Class constructor
     *
     * @param rl
     */
    public RankedListViewerAction(RankedList rl) {

        this();

        this.fRankedList = rl;
    }

    public void setObject(Object obj) {
        this.fRankedList = (RankedList) obj;
    }

    public Widget getWidget() {
        return new RankedListViewer(fRankedList);

    }

    public String getId() {
        return "RankedListViewerAction";
    }

    public String getName() {
        return RankedListViewer.NAME;
    }

    public Icon getIcon() {
        return RankedListViewer.ICON;
    }

    public String getDescription() {
        return "View the Ranked List";
    }
}    // End FSetViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
