/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.reports.api.Report;
import edu.mit.broad.xbench.actions.ObjectAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class ReportViewerAction extends ObjectAction {

    private Report fReport;

    /**
     * Class constructor
     */
    public ReportViewerAction() {

        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }


    /**
     * Class constructor
     *
     * @param fset
     */
    public ReportViewerAction(Report fset) {

        this();

        this.fReport = fset;
    }

    public void setObject(Object rpt) {
        this.fReport = (Report) rpt;
    }

    public Widget getWidget() {
        return new ReportViewer(fReport);

    }

    public String getId() {
        return "ReportViewerAction";
    }

    public String getName() {
        return ReportViewer.NAME;
    }

    public Icon getIcon() {
        return ReportViewer.ICON;
    }

    public String getDescription() {
        return "View the Report";
    }
}    // End ReportViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
