/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;

import edu.mit.broad.xbench.actions.WidgetAction;
import edu.mit.broad.xbench.core.Widget;

import javax.swing.*;


/**
 * @author Aravind Subramanian
 */
public class SystemConsoleViewerAction extends WidgetAction {

    SystemConsoleViewer fScv;

    /**
     * Class Constructor.
     */
    public SystemConsoleViewerAction() {
        this.putValue(Action.NAME, getName());
        this.putValue(Action.SMALL_ICON, getIcon());
        this.putValue(Action.SHORT_DESCRIPTION, getDescription());
    }

    public Widget getWidget() {
        if (fScv == null) {
            this.fScv = new SystemConsoleViewer();
        }

        return fScv;
    }

    public String getId() {
        return "SystemConsoleViewerAction";
    }

    public String getName() {
        return SystemConsoleViewer.NAME;
    }

    public String getDescription() {
        return "View System Console";
    }

    public Icon getIcon() {
        return SystemConsoleViewer.ICON;
    }

}    // End SystemConsoleViewerAction

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
