/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.genome.viewers;


import edu.mit.broad.genome.JarResources;
import edu.mit.broad.genome.charts.XChart;
import org.jfree.chart.ChartPanel;

import javax.swing.*;
import java.awt.*;

/**
 * Widget that builds the local file system view along with a few
 * easy access buttons
 *
 * @author Aravind Subramanian
 * @version %I%, %G%
 */
public class XChartViewer extends AbstractViewer {

    public static final Icon ICON = JarResources.getIcon("Chart16B.png");
    public static final String NAME = "XChartViewer";

    private final XChart[] fCharts;

    /**
     * Class constructor
     *
     * @param chart
     */
    public XChartViewer(final String title, final XChart chart) {
        super(NAME, ICON, title);
        this.fCharts = new XChart[]{chart};
        init();
    }

    public XChartViewer(final String title, XChart[] charts) {
        super(NAME, ICON, title);
        this.fCharts = charts;
        init();
    }

    private void init() {
        /*

        this.setLayout(new SCLayout(fCharts.length));
        for (int i = 0; i < fCharts.length; i++) {
            this.add(new JScrollPane(XChartUtils.createPanel(fCharts[i])));
        }

        */

        ChartPanel chartPanel = new ChartPanel(fCharts[0].getFreeChart());
        //chartPanel.setVerticalAxisTrace(true);
        //chartPanel.setHorizontalAxisTrace(true);

        this.setLayout(new BorderLayout());
        this.add(chartPanel, BorderLayout.CENTER);


    }

}    // End ChartViewer

/*--- Formatted in Sun Java Convention Style on Fri, Sep 27, '02 ---*/
