/**
 * The Broad Institute
 * SOFTWARE COPYRIGHT NOTICE AGREEMENT
 * This software and its documentation are copyright 2004-2005 by the
 * Broad Institute/Massachusetts Institute of Technology.
 * All rights are reserved.
 * This software is supplied without any warranty or guaranteed support
 * whatsoever. Neither the Broad Institute nor MIT can be responsible for
 * its use, misuse, or functionality.
 */
package edu.mit.broad.vdb.meg;

import edu.mit.broad.genome.Constants;

import java.util.Set;

/**
 * @author Aravind Subramanian
 *         Date: Jan 1, 2004
 *         Time: 11:45:15 PM
 */
public interface Gene {

    public static final Gene NULL_GENE = new DefaultGene(Constants.NULL, Constants.NULL, null, null, null);

    public Gene cloneDeep();

    public String getSymbol();

    public String getCyto();

    public String getTitle();

    public String getTitle_truncated();

    public Set getAliases();

    public String[] getAliasesArray();

    public boolean containsAlias(String alias);

    public boolean containsSeqAccession(String acc);

    public Set getSeqAccessions();


    public static class Helper {

        public static String getTitle_truncated(String title) {
            if (title != null && title.length() > 150) {
                return title.substring(150);
            }

            return title;
        }

        public static boolean isNull(final Gene gene) {
            if (gene == null || gene.getSymbol() == null || gene == NULL_GENE) {
                return true;
            }

            return false;
        }

    } // End class Helper

    // End class Hugo
}