package xapps.gsea;

import edu.mit.broad.vdb.VdbRuntimeResources;
import edu.mit.broad.vdb.chip.Chip;
import edu.mit.broad.vdb.msigdb.GeneSetAnnotation;

import javax.swing.table.AbstractTableModel;

// @todo imprive by adding the mapping details

public class GeneSetAnnotation_gene_set_TableModel extends AbstractTableModel {

    private final GeneSetAnnotation fGsann;

    private Chip symbol_chip;

    private static final String[] COL_NAMES = new String[]{"Gene Symbol", "Gene Title"};

    /**
     * Class Constructor.
     * Initializes model to specified Template.
     */
    public GeneSetAnnotation_gene_set_TableModel(final GeneSetAnnotation gsa) {
        this.fGsann = gsa;
        try {
            this.symbol_chip = VdbRuntimeResources.getChip_Gene_Symbol();
        } catch (Throwable t) {
            t.printStackTrace();
        }

    }

    public int getColumnCount() {
        return COL_NAMES.length;
    }

    public int getRowCount() {
        return fGsann.getGeneSet(false).getNumMembers();
    }

    public String getColumnName(int col) {
        return COL_NAMES[col];
    }


    public Object getValueAt(int row, int col) {
        String symbol = fGsann.getGeneSet(false).getMember(row);

        if (col == 0) {
            return symbol;
        } else if (symbol_chip != null) {
            try {
                return symbol_chip.getHugo(symbol).getTitle_truncated();
            } catch (Throwable t) {

            }

            return null;
        }

        return null;
    }

    public Class getColumnClass(int col) {
        return String.class;
    }

    public boolean isEditable() {
        return false;
    }

    public boolean isCellEditable(int row, int col) {
        return false;
    }
}    // End GeneSetModel